// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _AIS_EllipseRadiusDimension_HeaderFile
#define _AIS_EllipseRadiusDimension_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_AIS_EllipseRadiusDimension_HeaderFile
#include <Handle_AIS_EllipseRadiusDimension.hxx>
#endif

#ifndef _gp_Elips_HeaderFile
#include <gp_Elips.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Geom_OffsetCurve_HeaderFile
#include <Handle_Geom_OffsetCurve.hxx>
#endif
#ifndef _AIS_Relation_HeaderFile
#include <AIS_Relation.hxx>
#endif
#ifndef _AIS_KindOfDimension_HeaderFile
#include <AIS_KindOfDimension.hxx>
#endif
#ifndef _AIS_KindOfSurface_HeaderFile
#include <AIS_KindOfSurface.hxx>
#endif
#ifndef _Handle_Geom_Surface_HeaderFile
#include <Handle_Geom_Surface.hxx>
#endif
class Geom_OffsetCurve;
class TopoDS_Shape;
class TCollection_ExtendedString;
class Geom_Surface;



//!  Computes  geometry  (  basis  curve  and  plane  of  dimension) <br>
//!  for  input  shape  aShape  from  TopoDS <br>
//!  Root  class  for MinRadiusDimension  and  MaxRadiusDimension <br>
class AIS_EllipseRadiusDimension : public AIS_Relation {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT virtual  AIS_KindOfDimension KindOfDimension() const;


Standard_EXPORT virtual  Standard_Boolean IsMovable() const;


Standard_EXPORT   void ComputeGeometry() ;
//Standard_EXPORT ~AIS_EllipseRadiusDimension();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


Standard_EXPORT AIS_EllipseRadiusDimension(const TopoDS_Shape& aShape,const TCollection_ExtendedString& aText);


 // Fields PROTECTED
 //
gp_Elips myEllipse;
Standard_Real myFirstPar;
Standard_Real myLastPar;
Standard_Boolean myIsAnArc;
Handle_Geom_OffsetCurve myOffsetCurve;
Standard_Real myOffset;
Standard_Boolean myIsOffset;


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   void ComputeFaceGeometry() ;


Standard_EXPORT   void ComputeCylFaceGeometry(const AIS_KindOfSurface aSurfType,const Handle(Geom_Surface)& aSurf,const Standard_Real Offset) ;


Standard_EXPORT   void ComputePlanarFaceGeometry() ;


Standard_EXPORT   void ComputeEdgeGeometry() ;


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
