// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _AlienImage_BMPAlienData_HeaderFile
#define _AlienImage_BMPAlienData_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_AlienImage_BMPAlienData_HeaderFile
#include <Handle_AlienImage_BMPAlienData.hxx>
#endif

#ifndef _Handle_Aspect_GenericColorMap_HeaderFile
#include <Handle_Aspect_GenericColorMap.hxx>
#endif
#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _AlienImage_AlienImageData_HeaderFile
#include <AlienImage_AlienImageData.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Image_Image_HeaderFile
#include <Handle_Image_Image.hxx>
#endif
#ifndef _Handle_Image_PseudoColorImage_HeaderFile
#include <Handle_Image_PseudoColorImage.hxx>
#endif
#ifndef _Handle_Image_ColorImage_HeaderFile
#include <Handle_Image_ColorImage.hxx>
#endif
class Aspect_GenericColorMap;
class Standard_OutOfRange;
class Standard_TypeMismatch;
class OSD_File;
class Image_Image;
class Image_PseudoColorImage;
class Image_ColorImage;



class AlienImage_BMPAlienData : public AlienImage_AlienImageData {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT AlienImage_BMPAlienData();

//! Frees memory allocated by BMPAlienData <br>
Standard_EXPORT   void Clear() ;
~AlienImage_BMPAlienData()
{
  Clear();
}


//! Read content of a  BMPAlienData object from a file <br>
//!          Returns True if file is a BMP file . <br>
Standard_EXPORT   Standard_Boolean Read(OSD_File& afile) ;

//! Write content of a  BMPAlienData object to a file <br>
Standard_EXPORT   Standard_Boolean Write(OSD_File& afile) const;

//! convert a BMPAlienData object to a Image object. <br>
Standard_EXPORT   Handle_Image_Image ToImage() const;

//! convert a Image object to a BMPAlienData object. <br>
Standard_EXPORT   void FromImage(const Handle(Image_Image)& anImage) ;




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

//! convert a Image object to a GIFAlienData object. <br>
Standard_EXPORT   void FromPseudoColorImage(const Handle(Image_PseudoColorImage)& anImage) ;

//! convert a Image object to a GIFAlienData object. <br>
Standard_EXPORT   void FromColorImage(const Handle(Image_ColorImage)& anImage) ;


 // Fields PRIVATE
 //
Handle_Aspect_GenericColorMap myColorMap;
Standard_Address myData;
Standard_Integer myWidth;
Standard_Integer myHeight;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
