// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _AlienImage_EuclidAlienImage_HeaderFile
#define _AlienImage_EuclidAlienImage_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_AlienImage_EuclidAlienImage_HeaderFile
#include <Handle_AlienImage_EuclidAlienImage.hxx>
#endif

#ifndef _Handle_AlienImage_EuclidAlienData_HeaderFile
#include <Handle_AlienImage_EuclidAlienData.hxx>
#endif
#ifndef _AlienImage_AlienUserImage_HeaderFile
#include <AlienImage_AlienUserImage.hxx>
#endif
#ifndef _Handle_Image_Image_HeaderFile
#include <Handle_Image_Image.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class AlienImage_EuclidAlienData;
class Image_Image;
class OSD_File;


//! This class defines an Euclid Alien image. <br>
class AlienImage_EuclidAlienImage : public AlienImage_AlienUserImage {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT AlienImage_EuclidAlienImage();

//! Frees memory allocated by EuclidAlienImage <br>
Standard_EXPORT   void Clear() ;

//! Converts a EuclidAlienImage object to a Image object. <br>
Standard_EXPORT   Handle_Image_Image ToImage() const;

//! converts a Image object to a EuclidAlienImage object. <br>
Standard_EXPORT   void FromImage(const Handle(Image_Image)& anImage) ;

//! Reads content of a EuclidAlienImage object <br>
//!          from a file . <br>
//!          Returns True if file is a Euclid file . <br>
Standard_EXPORT   Standard_Boolean Read(OSD_File& afile) ;

//! Writes content of a EuclidAlienImage object <br>
//!          to a file . <br>
Standard_EXPORT   Standard_Boolean Write(OSD_File& afile) const;
//Standard_EXPORT ~AlienImage_EuclidAlienImage();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_AlienImage_EuclidAlienData myData;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
