// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _AppParCurves_SmoothCriterion_HeaderFile
#define _AppParCurves_SmoothCriterion_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_AppParCurves_SmoothCriterion_HeaderFile
#include <Handle_AppParCurves_SmoothCriterion.hxx>
#endif

#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Handle_TColStd_HArray1OfReal_HeaderFile
#include <Handle_TColStd_HArray1OfReal.hxx>
#endif
#ifndef _Handle_FEmTool_Curve_HeaderFile
#include <Handle_FEmTool_Curve.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Handle_FEmTool_HAssemblyTable_HeaderFile
#include <Handle_FEmTool_HAssemblyTable.hxx>
#endif
#ifndef _Handle_TColStd_HArray2OfInteger_HeaderFile
#include <Handle_TColStd_HArray2OfInteger.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class Standard_NotImplemented;
class Standard_DomainError;
class TColStd_HArray1OfReal;
class FEmTool_Curve;
class FEmTool_HAssemblyTable;
class TColStd_HArray2OfInteger;
class math_Matrix;
class math_Vector;
class TColStd_Array1OfReal;


//! defined criterion to smooth  points in  curve <br>
class AppParCurves_SmoothCriterion : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT virtual  void SetParameters(const Handle(TColStd_HArray1OfReal)& Parameters)  = 0;


Standard_EXPORT virtual  void SetCurve(const Handle(FEmTool_Curve)& C)  = 0;


Standard_EXPORT virtual  void GetCurve(Handle(FEmTool_Curve)& C) const = 0;


Standard_EXPORT virtual  void SetEstimation(const Standard_Real E1,const Standard_Real E2,const Standard_Real E3)  = 0;


Standard_EXPORT virtual  Standard_Real& EstLength()  = 0;


Standard_EXPORT virtual  void GetEstimation(Standard_Real& E1,Standard_Real& E2,Standard_Real& E3) const = 0;


Standard_EXPORT virtual  Handle_FEmTool_HAssemblyTable AssemblyTable() const = 0;


Standard_EXPORT virtual  Handle_TColStd_HArray2OfInteger DependenceTable() const = 0;


Standard_EXPORT virtual  Standard_Integer QualityValues(const Standard_Real J1min,const Standard_Real J2min,const Standard_Real J3min,Standard_Real& J1,Standard_Real& J2,Standard_Real& J3)  = 0;


Standard_EXPORT virtual  void ErrorValues(Standard_Real& MaxError,Standard_Real& QuadraticError,Standard_Real& AverageError)  = 0;


Standard_EXPORT virtual  void Hessian(const Standard_Integer Element,const Standard_Integer Dimension1,const Standard_Integer Dimension2,math_Matrix& H)  = 0;


Standard_EXPORT virtual  void Gradient(const Standard_Integer Element,const Standard_Integer Dimension,math_Vector& G)  = 0;

//! Convert the assembly Vector in an Curve; <br>
//! <br>
Standard_EXPORT virtual  void InputVector(const math_Vector& X,const Handle(FEmTool_HAssemblyTable)& AssTable)  = 0;


Standard_EXPORT virtual  void SetWeight(const Standard_Real QuadraticWeight,const Standard_Real QualityWeight,const Standard_Real percentJ1,const Standard_Real percentJ2,const Standard_Real percentJ3)  = 0;


Standard_EXPORT virtual  void GetWeight(Standard_Real& QuadraticWeight,Standard_Real& QualityWeight) const = 0;


Standard_EXPORT virtual  void SetWeight(const TColStd_Array1OfReal& Weight)  = 0;
//Standard_EXPORT ~AppParCurves_SmoothCriterion();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
