// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Aspect_AspectMarker_HeaderFile
#define _Aspect_AspectMarker_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Aspect_AspectMarker_HeaderFile
#include <Handle_Aspect_AspectMarker.hxx>
#endif

#ifndef _Quantity_Color_HeaderFile
#include <Quantity_Color.hxx>
#endif
#ifndef _Aspect_TypeOfMarker_HeaderFile
#include <Aspect_TypeOfMarker.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
class Aspect_AspectMarkerDefinitionError;
class Quantity_Color;


//! This class allows the definition of a group <br>
//!	    of attributes for the primitive MARKER. <br>
//!	    the attributes are: <br>
//!		* Colour <br>
//!		* Type <br>
//!		* Scale factor <br>
//!	    When any value of the group is modified <br>
//!	    all graphic objects using the group are modified <br>
class Aspect_AspectMarker : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Modifies the colour of <me>. <br>
Standard_EXPORT   void SetColor(const Quantity_Color& AColor) ;

//! Modifies the scale factor of <me>. <br>
//!	    Marker type Aspect_TOM_POINT is not affected <br>
//!	    by the marker size scale factor. It is always <br>
//!	    the smallest displayable dot. <br>
//!  Warning: Raises AspectMarkerDefinitionError if the <br>
//!	    scale is a negative value. <br>
Standard_EXPORT   void SetScale(const Standard_Real AScale) ;

//! Modifies the type of marker <me>. <br>
Standard_EXPORT   void SetType(const Aspect_TypeOfMarker AType) ;

//! Returns the current values of the group <me>. <br>
Standard_EXPORT   void Values(Quantity_Color& AColor,Aspect_TypeOfMarker& AType,Standard_Real& AScale) const;
//Standard_EXPORT ~Aspect_AspectMarker();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

//! Initialise the constructor for Graphic3d_AspectMarker3d. <br>
Standard_EXPORT Aspect_AspectMarker();

//! Initialise the values for the <br>
//!	    constructor of Graphic3d_AspectMarker3d. <br>
//!  Warning: Raises AspectMarkerDefinitionError if the <br>
//!	    scale is a negative value. <br>
Standard_EXPORT Aspect_AspectMarker(const Quantity_Color& AColor,const Aspect_TypeOfMarker AType,const Standard_Real AScale);


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Quantity_Color MyColor;
Aspect_TypeOfMarker MyType;
Standard_Real MyScale;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
