// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Aspect_TypeMap_HeaderFile
#define _Aspect_TypeMap_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Aspect_TypeMap_HeaderFile
#include <Handle_Aspect_TypeMap.hxx>
#endif

#ifndef _Aspect_SequenceOfTypeMapEntry_HeaderFile
#include <Aspect_SequenceOfTypeMapEntry.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class Aspect_BadAccess;
class Aspect_TypeMapEntry;
class Aspect_LineStyle;


//! This class defines a TypeMap object. <br>
class Aspect_TypeMap : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT Aspect_TypeMap();

//! Adds an entry in the type map <me>. <br>
//!  Warning: Raises BadAccess if TypeMap size is exceeded. <br>
Standard_EXPORT   void AddEntry(const Aspect_TypeMapEntry& AnEntry) ;

//! Search an identical type style entry in the type map <me> <br>
//! and returns the TypeMapEntry Index if exist. <br>
//! Or add a new entry and returns the computed TypeMapEntry index used. <br>
Standard_EXPORT   Standard_Integer AddEntry(const Aspect_LineStyle& aStyle) ;

//! Returns the Allocated typemap Size <br>
Standard_EXPORT   Standard_Integer Size() const;

//! Returns the TypeMapEntry.Index of the TypeMap <br>
//!          at rank <aTypemapIndex> . <br>
Standard_EXPORT   Standard_Integer Index(const Standard_Integer aTypemapIndex) const;


Standard_EXPORT   void Dump() const;

//! Returns the Type map entry with the index <AnIndex>. <br>
//!  Warning: Raises BadAccess if the index less than 1 or <br>
//!	    greater than Size. <br>
Standard_EXPORT  const Aspect_TypeMapEntry& Entry(const Standard_Integer AnIndex) const;
//Standard_EXPORT ~Aspect_TypeMap();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //
Aspect_SequenceOfTypeMapEntry mydata;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
