// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BOPTools_CArray1OfESInterference_HeaderFile
#define _BOPTools_CArray1OfESInterference_HeaderFile

#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Standard_OutOfRange;
class Standard_OutOfMemory;
class BOPTools_ESInterference;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class BOPTools_CArray1OfESInterference  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT BOPTools_CArray1OfESInterference(const Standard_Integer Length = 0,const Standard_Integer BlockLength = 5);


Standard_EXPORT   void Resize(const Standard_Integer theNewLength) ;


Standard_EXPORT   void Destroy() ;
~BOPTools_CArray1OfESInterference()
{
  Destroy();
}



Standard_EXPORT   Standard_Integer Length() const;


Standard_EXPORT   Standard_Integer Extent() const;


Standard_EXPORT   Standard_Integer FactLength() const;


Standard_EXPORT   Standard_Integer Append(const BOPTools_ESInterference& Value) ;


Standard_EXPORT   void Remove(const Standard_Integer Index) ;


Standard_EXPORT  const BOPTools_ESInterference& Value(const Standard_Integer Index) const;
 const BOPTools_ESInterference& operator ()(const Standard_Integer Index) const
{
  return Value(Index);
}



Standard_EXPORT   BOPTools_ESInterference& ChangeValue(const Standard_Integer Index) ;
  BOPTools_ESInterference& operator ()(const Standard_Integer Index) 
{
  return ChangeValue(Index);
}



Standard_EXPORT   void SetBlockLength(const Standard_Integer aBL) ;


Standard_EXPORT   Standard_Integer BlockLength() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT BOPTools_CArray1OfESInterference(const BOPTools_CArray1OfESInterference& AnArray);


Standard_EXPORT   BOPTools_CArray1OfESInterference& Assign(const BOPTools_CArray1OfESInterference& Other) ;
  BOPTools_CArray1OfESInterference& operator =(const BOPTools_CArray1OfESInterference& Other) 
{
  return Assign(Other);
}



Standard_EXPORT   Standard_Boolean IsInvalidIndex(const Standard_Integer Index) const;


 // Fields PRIVATE
 //
Standard_Address myStart;
Standard_Integer myLength;
Standard_Integer myFactLength;
Standard_Integer myBlockLength;
Standard_Boolean myIsAllocated;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
