// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BOPTools_Pave_HeaderFile
#define _BOPTools_Pave_HeaderFile

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _BooleanOperations_KindOfInterference_HeaderFile
#include <BooleanOperations_KindOfInterference.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


//!  Class for storing info about a vertex on an edge <br>
class BOPTools_Pave  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


//! Empty constructor <br>
Standard_EXPORT BOPTools_Pave();


//! Constructor <br>
//! Index  - DS-index of the vertex <br>
//! aParam - value of the parameter of the vertex on an edge <br>
//! aType  - the type of interference from which the pave comes from <br>
Standard_EXPORT BOPTools_Pave(const Standard_Integer Index,const Standard_Real aParam,const BooleanOperations_KindOfInterference aType = BooleanOperations_UnknownInterference);


//! Modifier <br>
Standard_EXPORT   void SetParam(const Standard_Real aParam) ;


//! Modifier <br>
Standard_EXPORT   void SetIndex(const Standard_Integer Index) ;


//! Modifier <br>
Standard_EXPORT   void SetType(const BooleanOperations_KindOfInterference aType) ;


//! Modifier <br>
//! Sets the index of the interference in corresponding table <br>
Standard_EXPORT   void SetInterference(const Standard_Integer Index) ;


//! Selector <br>
Standard_EXPORT   Standard_Real Param() const;


//! Selector <br>
Standard_EXPORT   Standard_Integer Index() const;


//! Selector <br>
Standard_EXPORT   BooleanOperations_KindOfInterference Type() const;


//! Selector <br>
Standard_EXPORT   Standard_Integer Interference() const;


//! Returns TRUE if  <Other>==me <br>
Standard_EXPORT   Standard_Boolean IsEqual(const BOPTools_Pave& Other) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real myParam;
Standard_Integer myIndex;
BooleanOperations_KindOfInterference myType;
Standard_Integer myInterf;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
