// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BOP_Refiner_HeaderFile
#define _BOP_Refiner_HeaderFile

#ifndef _TopoDS_Shape_HeaderFile
#include <TopoDS_Shape.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _TopTools_ListOfShape_HeaderFile
#include <TopTools_ListOfShape.hxx>
#endif
class TopoDS_Shape;
class TopTools_ListOfShape;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


//!  The  algorithm to provide the refinition <br>
//!  for a resulting shape of Boolean Operation <br>
//!  algorithm. <br>
//!  (not  completed  yet) <br>
class BOP_Refiner  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


//! Empty constructor; <br>
Standard_EXPORT BOP_Refiner();


//! Constructor; <br>
Standard_EXPORT BOP_Refiner(const TopoDS_Shape& aS);


//! Modifier <br>
Standard_EXPORT   void SetShape(const TopoDS_Shape& aS) ;


//! Modifier <br>
Standard_EXPORT   void SetInternals(const TopTools_ListOfShape& aLS) ;


//! Performs the algorithm <br>
Standard_EXPORT   void Do() ;


//! Selector <br>
Standard_EXPORT   Standard_Boolean IsDone() const;


//! Selector <br>
Standard_EXPORT   Standard_Integer ErrorStatus() const;


//! Selector <br>
Standard_EXPORT  const TopoDS_Shape& Shape() const;


//! Selector <br>
Standard_EXPORT   Standard_Integer NbRemovedVertices() const;


//! Selector <br>
Standard_EXPORT   Standard_Integer NbRemovedEdges() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


//! Internal usage <br>
Standard_EXPORT   void DoInternals() ;


 // Fields PRIVATE
 //
TopoDS_Shape myShape;
Standard_Boolean myIsDone;
Standard_Integer myErrorStatus;
Standard_Integer myNbRemovedVertices;
Standard_Integer myNbRemovedEdges;
TopTools_ListOfShape myInternals;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
