// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepApprox_Approx_HeaderFile
#define _BRepApprox_Approx_HeaderFile

#ifndef _BRepApprox_TheComputeLineOfApprox_HeaderFile
#include <BRepApprox_TheComputeLineOfApprox.hxx>
#endif
#ifndef _BRepApprox_TheComputeLineBezierOfApprox_HeaderFile
#include <BRepApprox_TheComputeLineBezierOfApprox.hxx>
#endif
#ifndef _Approx_MCurvesToBSpCurve_HeaderFile
#include <Approx_MCurvesToBSpCurve.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_BRepApprox_ApproxLine_HeaderFile
#include <Handle_BRepApprox_ApproxLine.hxx>
#endif
#ifndef _Approx_ParametrizationType_HeaderFile
#include <Approx_ParametrizationType.hxx>
#endif
class Standard_OutOfRange;
class StdFail_NotDone;
class BRepAdaptor_Surface;
class BRepApprox_SurfaceTool;
class IntSurf_Quadric;
class IntSurf_QuadricTool;
class BRepApprox_ApproxLine;
class BRepApprox_ThePrmPrmSvSurfacesOfApprox;
class BRepApprox_TheInt2SOfThePrmPrmSvSurfacesOfApprox;
class BRepApprox_TheImpPrmSvSurfacesOfApprox;
class BRepApprox_TheZerImpFuncOfTheImpPrmSvSurfacesOfApprox;
class BRepApprox_TheMultiLineOfApprox;
class BRepApprox_TheMultiLineToolOfApprox;
class BRepApprox_TheComputeLineOfApprox;
class BRepApprox_MyBSplGradientOfTheComputeLineOfApprox;
class BRepApprox_MyGradientbisOfTheComputeLineOfApprox;
class BRepApprox_TheComputeLineBezierOfApprox;
class BRepApprox_MyGradientOfTheComputeLineBezierOfApprox;
class AppParCurves_MultiBSpCurve;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class BRepApprox_Approx  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT BRepApprox_Approx();


Standard_EXPORT   void Perform(const BRepAdaptor_Surface& Surf1,const BRepAdaptor_Surface& Surf2,const Handle(BRepApprox_ApproxLine)& aLine,const Standard_Boolean ApproxXYZ = Standard_True,const Standard_Boolean ApproxU1V1 = Standard_True,const Standard_Boolean ApproxU2V2 = Standard_True,const Standard_Integer indicemin = 0,const Standard_Integer indicemax = 0) ;


Standard_EXPORT   void Perform(const Handle(BRepApprox_ApproxLine)& aLine,const Standard_Boolean ApproxXYZ = Standard_True,const Standard_Boolean ApproxU1V1 = Standard_True,const Standard_Boolean ApproxU2V2 = Standard_True,const Standard_Integer indicemin = 0,const Standard_Integer indicemax = 0) ;


Standard_EXPORT   void SetParameters(const Standard_Real Tol3d,const Standard_Real Tol2d,const Standard_Integer DegMin,const Standard_Integer DegMax,const Standard_Integer NbIterMax,const Standard_Boolean ApproxWithTangency = Standard_True,const Approx_ParametrizationType Parametrization = Approx_ChordLength) ;


Standard_EXPORT   void SetParameters(const Standard_Real Tol3d,const Standard_Real Tol2d,const Standard_Boolean RelativeTol,const Standard_Integer DegMin,const Standard_Integer DegMax,const Standard_Integer NbIterMax,const Standard_Integer NbPntMax,const Standard_Boolean ApproxWithTangency = Standard_True,const Approx_ParametrizationType Parametrization = Approx_ChordLength) ;


Standard_EXPORT   void Perform() ;


Standard_EXPORT   Standard_Real TolReached3d() const;


Standard_EXPORT   Standard_Real TolReached2d() const;


Standard_EXPORT   Standard_Boolean IsDone() const;


Standard_EXPORT   Standard_Integer NbMultiCurves() const;


Standard_EXPORT  const AppParCurves_MultiBSpCurve& Value(const Standard_Integer Index) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   void Perform(const BRepAdaptor_Surface& Surf1,const IntSurf_Quadric& Surf2,const Handle(BRepApprox_ApproxLine)& aLine,const Standard_Boolean ApproxXYZ,const Standard_Boolean ApproxU1V1,const Standard_Boolean ApproxU2V2,const Standard_Integer indicemin,const Standard_Integer indicemax) ;


Standard_EXPORT   void Perform(const IntSurf_Quadric& Surf1,const BRepAdaptor_Surface& Surf2,const Handle(BRepApprox_ApproxLine)& aLine,const Standard_Boolean ApproxXYZ,const Standard_Boolean ApproxU1V1,const Standard_Boolean ApproxU2V2,const Standard_Integer indicemin,const Standard_Integer indicemax) ;


Standard_EXPORT   void UpdateTolReached() ;


 // Fields PRIVATE
 //
BRepApprox_TheComputeLineOfApprox myComputeLine;
BRepApprox_TheComputeLineBezierOfApprox myComputeLineBezier;
Approx_MCurvesToBSpCurve myBezToBSpl;
Standard_Boolean myTolReached;
Standard_Boolean myApproxBez;
Standard_Boolean myWithTangency;
Standard_Real myTol3d;
Standard_Real myTol2d;
Standard_Boolean myRelativeTol;
Standard_Integer myDegMin;
Standard_Integer myDegMax;
Standard_Integer myNbPntMax;
Standard_Integer myNbIterMax;
Standard_Real myMinFactorXYZ;
Standard_Real myMinFactorUV;
Standard_Real myTolReached3d;
Standard_Real myTolReached2d;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
