// File generated by CPPExt (Enum)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepBuilderAPI_FaceError_HeaderFile
#define _BRepBuilderAPI_FaceError_HeaderFile

//!  Indicates the outcome of the <br>
//! construction of a face, i.e. whether it has been successful or <br>
//! not, as explained below: <br>
//! -      BRepBuilderAPI_FaceDone No error occurred. The face is <br>
//!    correctly built. <br>
//! -      BRepBuilderAPI_NoFace No initialization of the <br>
//!    algorithm; only an empty constructor was used. <br>
//! -      BRepBuilderAPI_NotPlanar <br>
//!    No surface was given and the wire was not planar. <br>
//! -      BRepBuilderAPI_CurveProjectionFailed <br>
//!    Not used so far. <br>
//! -      BRepBuilderAPI_ParametersOutOfRange <br>
//!    The parameters given to limit the surface are out of its    bounds. <br>
//! -      BRepBuilderAPI_SurfaceNotC2    Not used so far. <br>
enum BRepBuilderAPI_FaceError { 
 BRepBuilderAPI_FaceDone,
BRepBuilderAPI_NoFace,
BRepBuilderAPI_NotPlanar,
BRepBuilderAPI_CurveProjectionFailed,
BRepBuilderAPI_ParametersOutOfRange,
BRepBuilderAPI_SurfaceNotC2
};


#ifndef _Standard_PrimitiveTypes_HeaderFile
#include <Standard_PrimitiveTypes.hxx>
#endif

#endif
