// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRepFill_NSections_HeaderFile
#define _BRepFill_NSections_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_BRepFill_NSections_HeaderFile
#include <Handle_BRepFill_NSections.hxx>
#endif

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _TopTools_SequenceOfShape_HeaderFile
#include <TopTools_SequenceOfShape.hxx>
#endif
#ifndef _TColStd_SequenceOfReal_HeaderFile
#include <TColStd_SequenceOfReal.hxx>
#endif
#ifndef _Handle_TopTools_HArray2OfShape_HeaderFile
#include <Handle_TopTools_HArray2OfShape.hxx>
#endif
#ifndef _Handle_Geom_BSplineSurface_HeaderFile
#include <Handle_Geom_BSplineSurface.hxx>
#endif
#ifndef _BRepFill_SectionLaw_HeaderFile
#include <BRepFill_SectionLaw.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_GeomFill_SectionLaw_HeaderFile
#include <Handle_GeomFill_SectionLaw.hxx>
#endif
#ifndef _GeomAbs_Shape_HeaderFile
#include <GeomAbs_Shape.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class TopTools_HArray2OfShape;
class Geom_BSplineSurface;
class TopTools_SequenceOfShape;
class TColStd_SequenceOfReal;
class GeomFill_SectionLaw;
class TopoDS_Vertex;
class TopoDS_Shape;


//! Build Section Law, with N Sections <br>
//! <br>
class BRepFill_NSections : public BRepFill_SectionLaw {

public:
 // Methods PUBLIC
 // 

//! Construct <br>
Standard_EXPORT BRepFill_NSections(const TopTools_SequenceOfShape& S,const Standard_Boolean Build = Standard_True);

//! Construct <br>
Standard_EXPORT BRepFill_NSections(const TopTools_SequenceOfShape& S,const TColStd_SequenceOfReal& P,const Standard_Real VF,const Standard_Real VL,const Standard_Boolean Build = Standard_True);

//! Say if the input shape is a  vertex. <br>
Standard_EXPORT virtual  Standard_Boolean IsVertex() const;

//! Say if the Law is  Constant. <br>
Standard_EXPORT virtual  Standard_Boolean IsConstant() const;

//! Give the law build on a concatened section <br>
Standard_EXPORT virtual  Handle_GeomFill_SectionLaw ConcatenedLaw() const;


Standard_EXPORT virtual  GeomAbs_Shape Continuity(const Standard_Integer Index,const Standard_Real TolAngular) const;


Standard_EXPORT virtual  Standard_Real VertexTol(const Standard_Integer Index,const Standard_Real Param) const;


Standard_EXPORT virtual  TopoDS_Vertex Vertex(const Standard_Integer Index,const Standard_Real Param) const;


Standard_EXPORT virtual  void D0(const Standard_Real Param,TopoDS_Shape& S) ;
//Standard_EXPORT ~BRepFill_NSections();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   void Init(const TColStd_SequenceOfReal& P,const Standard_Boolean B) ;


 // Fields PRIVATE
 //
Standard_Real VFirst;
Standard_Real VLast;
TopTools_SequenceOfShape myShapes;
TColStd_SequenceOfReal myParams;
Handle_TopTools_HArray2OfShape myEdges;
Handle_Geom_BSplineSurface mySurface;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
