// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BRep_CurveOn2Surfaces_HeaderFile
#define _BRep_CurveOn2Surfaces_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_BRep_CurveOn2Surfaces_HeaderFile
#include <Handle_BRep_CurveOn2Surfaces.hxx>
#endif

#ifndef _Handle_Geom_Surface_HeaderFile
#include <Handle_Geom_Surface.hxx>
#endif
#ifndef _TopLoc_Location_HeaderFile
#include <TopLoc_Location.hxx>
#endif
#ifndef _GeomAbs_Shape_HeaderFile
#include <GeomAbs_Shape.hxx>
#endif
#ifndef _BRep_CurveRepresentation_HeaderFile
#include <BRep_CurveRepresentation.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Handle_BRep_CurveRepresentation_HeaderFile
#include <Handle_BRep_CurveRepresentation.hxx>
#endif
class Geom_Surface;
class Standard_NullObject;
class TopLoc_Location;
class gp_Pnt;
class BRep_CurveRepresentation;


//! Defines a continuity between two surfaces. <br>
class BRep_CurveOn2Surfaces : public BRep_CurveRepresentation {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT BRep_CurveOn2Surfaces(const Handle(Geom_Surface)& S1,const Handle(Geom_Surface)& S2,const TopLoc_Location& L1,const TopLoc_Location& L2,const GeomAbs_Shape C);

//! Returns True. <br>
Standard_EXPORT virtual  Standard_Boolean IsRegularity() const;

//! A curve on two surfaces (continuity). <br>
Standard_EXPORT virtual  Standard_Boolean IsRegularity(const Handle(Geom_Surface)& S1,const Handle(Geom_Surface)& S2,const TopLoc_Location& L1,const TopLoc_Location& L2) const;

//! Raises an error. <br>
Standard_EXPORT   void D0(const Standard_Real U,gp_Pnt& P) const;


Standard_EXPORT virtual const Handle_Geom_Surface& Surface() const;


Standard_EXPORT virtual const Handle_Geom_Surface& Surface2() const;


Standard_EXPORT virtual const TopLoc_Location& Location2() const;


Standard_EXPORT virtual const GeomAbs_Shape& Continuity() const;


Standard_EXPORT virtual  void Continuity(const GeomAbs_Shape C) ;

//! Return a copy of this representation. <br>
Standard_EXPORT   Handle_BRep_CurveRepresentation Copy() const;
//Standard_EXPORT ~BRep_CurveOn2Surfaces();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Geom_Surface mySurface;
Handle_Geom_Surface mySurface2;
TopLoc_Location myLocation2;
GeomAbs_Shape myContinuity;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
