// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _BinMDF_HeaderFile
#define _BinMDF_HeaderFile

#ifndef _Handle_BinMDF_ADriverTable_HeaderFile
#include <Handle_BinMDF_ADriverTable.hxx>
#endif
#ifndef _Handle_CDM_MessageDriver_HeaderFile
#include <Handle_CDM_MessageDriver.hxx>
#endif
class BinMDF_ADriverTable;
class CDM_MessageDriver;
class BinMDF_ADriver;
class BinMDF_ReferenceDriver;
class BinMDF_TagSourceDriver;
class BinMDF_StringIdMap;
class BinMDF_TypeADriverMap;
class BinMDF_TypeIdMap;
class BinMDF_ADriverTable;
class BinMDF_DataMapNodeOfStringIdMap;
class BinMDF_DataMapIteratorOfStringIdMap;
class BinMDF_DataMapNodeOfTypeADriverMap;
class BinMDF_DataMapIteratorOfTypeADriverMap;
class BinMDF_DoubleMapNodeOfTypeIdMap;
class BinMDF_DoubleMapIteratorOfTypeIdMap;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! This package provides classes and methods to <br>
//!          translate a transient DF into a persistent one and <br>
//!          vice versa. <br>
//! <br>
//!          Driver <br>
//! <br>
//!          A driver is a tool used to translate a transient <br>
//!          attribute into a persistent one and vice versa. <br>
//! <br>
//!          Driver Table <br>
//! <br>
//!          A driver table is an object building links between <br>
//!          object types and object drivers. In the <br>
//!          translation process, a driver table is asked to <br>
//!          give a translation driver for each current object <br>
//!          to be translated. <br>
class BinMDF  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Adds the attribute storage drivers to <aDriverTable>. <br>
Standard_EXPORT static  void AddDrivers(const Handle(BinMDF_ADriverTable)& aDriverTable,const Handle(CDM_MessageDriver)& aMsgDrv) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class BinMDF_ADriver;
friend class BinMDF_ReferenceDriver;
friend class BinMDF_TagSourceDriver;
friend class BinMDF_StringIdMap;
friend class BinMDF_TypeADriverMap;
friend class BinMDF_TypeIdMap;
friend class BinMDF_ADriverTable;
friend class BinMDF_DataMapNodeOfStringIdMap;
friend class BinMDF_DataMapIteratorOfStringIdMap;
friend class BinMDF_DataMapNodeOfTypeADriverMap;
friend class BinMDF_DataMapIteratorOfTypeADriverMap;
friend class BinMDF_DoubleMapNodeOfTypeIdMap;
friend class BinMDF_DoubleMapIteratorOfTypeIdMap;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
