// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _CDF_DirectoryIterator_HeaderFile
#define _CDF_DirectoryIterator_HeaderFile

#ifndef _CDM_ListIteratorOfListOfDocument_HeaderFile
#include <CDM_ListIteratorOfListOfDocument.hxx>
#endif
#ifndef _Handle_CDF_Directory_HeaderFile
#include <Handle_CDF_Directory.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_CDM_Document_HeaderFile
#include <Handle_CDM_Document.hxx>
#endif
class Standard_NoSuchObject;
class CDF_Directory;
class CDM_Document;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class CDF_DirectoryIterator  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! creates an Iterator with the directory <br>
//!          of the current CDF. <br>
Standard_EXPORT CDF_DirectoryIterator();


Standard_EXPORT CDF_DirectoryIterator(const Handle(CDF_Directory)& aDirectory);

//! Returns True if there are more entries to return <br>
Standard_EXPORT   Standard_Boolean MoreDocument() ;

//! Go to the next entry <br>
//!           (if there is not, Value will raise an exception) <br>
Standard_EXPORT   void NextDocument() ;

//! Returns item value of current entry <br>
Standard_EXPORT   Handle_CDM_Document Document() ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
CDM_ListIteratorOfListOfDocument myIterator;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
