// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Draft_HeaderFile
#define _Draft_HeaderFile

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class TopoDS_Face;
class gp_Dir;
class Draft_Modification;
class Draft_FaceInfo;
class Draft_EdgeInfo;
class Draft_VertexInfo;
class Draft_DataMapOfFaceFaceInfo;
class Draft_DataMapOfEdgeEdgeInfo;
class Draft_DataMapOfVertexVertexInfo;
class Draft_DataMapNodeOfDataMapOfFaceFaceInfo;
class Draft_DataMapIteratorOfDataMapOfFaceFaceInfo;
class Draft_DataMapNodeOfDataMapOfEdgeEdgeInfo;
class Draft_DataMapIteratorOfDataMapOfEdgeEdgeInfo;
class Draft_DataMapNodeOfDataMapOfVertexVertexInfo;
class Draft_DataMapIteratorOfDataMapOfVertexVertexInfo;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class Draft  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Returns the draft angle of the  face <F> using the <br>
//!          direction <Direction>.  The  method is valid for : <br>
//!          - Plane  faces, <br>
//!          - Cylindrical or conical faces, when the direction <br>
//!          of the axis of the surface is colinear with the <br>
//!          direction. <br>
//!          Otherwise, the exception DomainError is raised. <br>
Standard_EXPORT static  Standard_Real Angle(const TopoDS_Face& F,const gp_Dir& Direction) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //

friend class Draft_Modification;
friend class Draft_FaceInfo;
friend class Draft_EdgeInfo;
friend class Draft_VertexInfo;
friend class Draft_DataMapOfFaceFaceInfo;
friend class Draft_DataMapOfEdgeEdgeInfo;
friend class Draft_DataMapOfVertexVertexInfo;
friend class Draft_DataMapNodeOfDataMapOfFaceFaceInfo;
friend class Draft_DataMapIteratorOfDataMapOfFaceFaceInfo;
friend class Draft_DataMapNodeOfDataMapOfEdgeEdgeInfo;
friend class Draft_DataMapIteratorOfDataMapOfEdgeEdgeInfo;
friend class Draft_DataMapNodeOfDataMapOfVertexVertexInfo;
friend class Draft_DataMapIteratorOfDataMapOfVertexVertexInfo;

};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
