// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _DrawTrSurf_Curve2d_HeaderFile
#define _DrawTrSurf_Curve2d_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_DrawTrSurf_Curve2d_HeaderFile
#include <Handle_DrawTrSurf_Curve2d.hxx>
#endif

#ifndef _Handle_Geom2d_Curve_HeaderFile
#include <Handle_Geom2d_Curve.hxx>
#endif
#ifndef _Draw_Color_HeaderFile
#include <Draw_Color.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _DrawTrSurf_Drawable_HeaderFile
#include <DrawTrSurf_Drawable.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Draw_Drawable3D_HeaderFile
#include <Handle_Draw_Drawable3D.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class Geom2d_Curve;
class Draw_Color;
class Draw_Display;
class Draw_Drawable3D;
class Draw_Interpretor;


//! This class defines a drawable curve in 2d space. <br>
//!  The curve is drawned in the plane XOY. <br>
class DrawTrSurf_Curve2d : public DrawTrSurf_Drawable {

public:
 // Methods PUBLIC
 // 


//!  creates a drawable curve from a curve of package Geom2d. <br>
Standard_EXPORT DrawTrSurf_Curve2d(const Handle(Geom2d_Curve)& C,const Standard_Boolean DispOrigin = Standard_True);


Standard_EXPORT DrawTrSurf_Curve2d(const Handle(Geom2d_Curve)& C,const Draw_Color& aColor,const Standard_Integer Discret,const Standard_Boolean DispOrigin = Standard_True,const Standard_Boolean DispCurvRadius = Standard_False,const Standard_Real RadiusMax = 1.0e3,const Standard_Real RatioOfRadius = 0.1);


Standard_EXPORT   void DrawOn(Draw_Display& dis) const;

  Handle_Geom2d_Curve GetCurve() const;

  void SetColor(const Draw_Color& aColor) ;

  void ShowCurvature() ;

  void ClearCurvature() ;

  void SetRadiusMax(const Standard_Real Radius) ;

  void SetRadiusRatio(const Standard_Real Ratio) ;

  Draw_Color Color() const;

  Standard_Real RadiusMax() const;

  Standard_Real RadiusRatio() const;

//! For variable copy. <br>
Standard_EXPORT virtual  Handle_Draw_Drawable3D Copy() const;

//! For variable dump. <br>
Standard_EXPORT virtual  void Dump(Standard_OStream& S) const;

//! Returns False. <br>
Standard_EXPORT virtual  Standard_Boolean Is3D() const;

//! For variable whatis command. Set  as a result  the <br>
//!          type of the variable. <br>
Standard_EXPORT virtual  void Whatis(Draw_Interpretor& I) const;
//Standard_EXPORT ~DrawTrSurf_Curve2d();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //
Handle_Geom2d_Curve curv;
Draw_Color look;
Standard_Boolean disporigin;
Standard_Boolean dispcurvradius;
Standard_Real radiusmax;
Standard_Real radiusratio;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};


#include <DrawTrSurf_Curve2d.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
