// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Draw_Drawable3D_HeaderFile
#define _Draw_Drawable3D_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Draw_Drawable3D_HeaderFile
#include <Handle_Draw_Drawable3D.hxx>
#endif

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class Draw_Display;
class Draw_Interpretor;



class Draw_Drawable3D : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT virtual  void DrawOn(Draw_Display& dis) const = 0;

//! Returs True if the pick is outside the box <br>
Standard_EXPORT virtual  Standard_Boolean PickReject(const Standard_Real X,const Standard_Real Y,const Standard_Real Prec) const;

//! For variable copy. <br>
Standard_EXPORT virtual  Handle_Draw_Drawable3D Copy() const;

//! For variable dump. <br>
Standard_EXPORT virtual  void Dump(Standard_OStream& S) const;

//! For variable whatis command. Set  as a result  the <br>
//!          type of the variable. <br>
Standard_EXPORT virtual  void Whatis(Draw_Interpretor& I) const;

//! Is a 3D object. (Default True). <br>
Standard_EXPORT virtual  Standard_Boolean Is3D() const;


Standard_EXPORT   void SetBounds(const Standard_Real xmin,const Standard_Real xmax,const Standard_Real ymin,const Standard_Real ymax) ;


Standard_EXPORT   void Bounds(Standard_Real& xmin,Standard_Real& xmax,Standard_Real& ymin,Standard_Real& ymax) const;

  Standard_Boolean Visible() const;

  void Visible(const Standard_Boolean V) ;

  Standard_Boolean Protected() const;

  void Protected(const Standard_Boolean P) ;

  Standard_CString Name() const;

virtual  void Name(const Standard_CString N) ;
//Standard_EXPORT ~Draw_Drawable3D();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


Standard_EXPORT Draw_Drawable3D();


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real myXmin;
Standard_Real myXmax;
Standard_Real myYmin;
Standard_Real myYmax;
Standard_Boolean isVisible;
Standard_Boolean isProtected;
Standard_CString myName;


};


#include <Draw_Drawable3D.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
