// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Draw_ProgressIndicator_HeaderFile
#define _Draw_ProgressIndicator_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Draw_ProgressIndicator_HeaderFile
#include <Handle_Draw_ProgressIndicator.hxx>
#endif

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Message_ProgressIndicator_HeaderFile
#include <Message_ProgressIndicator.hxx>
#endif
class Draw_Interpretor;


//! Implements ProgressIndicator (interface provided by Message) <br>
//!          for DRAW, with possibility to output to TCL window <br>
//!          and/or trace file <br>
class Draw_ProgressIndicator : public Message_ProgressIndicator {

public:
 // Methods PUBLIC
 // 

//! Creates a progress indicator and remembers pointer to <br>
//!          Draw_Interpretor <br>
//!          The updateTime, if given, defines time interval between <br>
//!          updates of the indicator (in seconds) <br>
Standard_EXPORT Draw_ProgressIndicator(const Draw_Interpretor& di,const Standard_Integer updateTime = 0);

//! Destructor; calls Reset() <br>
Standard_EXPORT   void Destroy() ;
~Draw_ProgressIndicator()
{
  Destroy();
}


//! Sets text output mode (on/off) <br>
Standard_EXPORT   void SetTextMode(const Standard_Boolean theTextMode) ;

//! Gets text output mode (on/off) <br>
Standard_EXPORT   Standard_Boolean GetTextMode() const;

//! Sets graphical output mode (on/off) <br>
Standard_EXPORT   void SetGraphMode(const Standard_Boolean theGraphMode) ;

//! Gets graphical output mode (on/off) <br>
Standard_EXPORT   Standard_Boolean GetGraphMode() const;

//! Clears/erases opened TCL windows if any <br>
//!          and sets myBreak to False <br>
Standard_EXPORT virtual  void Reset() ;

//! Defines method Show of Progress Indicator <br>
Standard_EXPORT virtual  Standard_Boolean Show(const Standard_Boolean force = Standard_True) ;

//! Redefines method UserBreak of Progress Indicator <br>
Standard_EXPORT virtual  Standard_Boolean UserBreak() ;


Standard_EXPORT static  Standard_Boolean& DefaultTextMode() ;

//! Get/Set default values for output modes <br>
Standard_EXPORT static  Standard_Boolean& DefaultGraphMode() ;

//! Internal method for implementation of UserBreak mechanism <br>
Standard_EXPORT static  Standard_Integer& StopIndicator() ;




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Boolean myTextMode;
Standard_Boolean myGraphMode;
Standard_Address myDraw;
Standard_Boolean myShown;
Standard_Boolean myBreak;
Standard_Integer myUpdateTime;
Standard_Integer myLastUpdate;
Standard_Integer myStartTime;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
