// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _DsgPrs_SymmetricPresentation_HeaderFile
#define _DsgPrs_SymmetricPresentation_HeaderFile

#ifndef _Handle_Prs3d_Presentation_HeaderFile
#include <Handle_Prs3d_Presentation.hxx>
#endif
#ifndef _Handle_Prs3d_Drawer_HeaderFile
#include <Handle_Prs3d_Drawer.hxx>
#endif
class Prs3d_Presentation;
class Prs3d_Drawer;
class gp_Pnt;
class gp_Dir;
class gp_Lin;
class gp_Circ;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! A framework to define display of symmetry between shapes. <br>
class DsgPrs_SymmetricPresentation  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Adds the points OffsetPoint, AttachmentPoint1, <br>
//! AttachmentPoint2, the direction aDirection1 and the <br>
//! axis anAxis to the presentation object aPresentation. <br>
//! The display attributes of the symmetry are defined by <br>
//! the attribute manager aDrawer. <br>
//! This syntax is used for display of symmetries between two segments. <br>
Standard_EXPORT static  void Add(const Handle(Prs3d_Presentation)& aPresentation,const Handle(Prs3d_Drawer)& aDrawer,const gp_Pnt& AttachmentPoint1,const gp_Pnt& AttachmentPoint2,const gp_Dir& aDirection1,const gp_Lin& aAxis,const gp_Pnt& OffsetPoint) ;

//! Adds the points OffsetPoint, AttachmentPoint1, <br>
//! AttachmentPoint2, the direction aDirection1 the circle <br>
//! aCircle1 and the axis anAxis to the presentation <br>
//! object aPresentation. <br>
//! The display attributes of the symmetry are defined by <br>
//! the attribute manager aDrawer. <br>
//! This syntax is used for display of symmetries between two arcs. <br>
Standard_EXPORT static  void Add(const Handle(Prs3d_Presentation)& aPresentation,const Handle(Prs3d_Drawer)& aDrawer,const gp_Pnt& AttachmentPoint1,const gp_Pnt& AttachmentPoint2,const gp_Circ& aCircle1,const gp_Lin& aAxis,const gp_Pnt& OffsetPoint) ;

//! Adds the points OffsetPoint, AttachmentPoint1, <br>
//! AttachmentPoint2 and the axis anAxis to the <br>
//! presentation object aPresentation. <br>
//! The display attributes of the symmetry are defined by <br>
//! the attribute manager aDrawer. <br>
//! This syntax is used for display of symmetries between two vertices. <br>
Standard_EXPORT static  void Add(const Handle(Prs3d_Presentation)& aPresentation,const Handle(Prs3d_Drawer)& aDrawer,const gp_Pnt& AttachmentPoint1,const gp_Pnt& AttachmentPoint2,const gp_Lin& aAxis,const gp_Pnt& OffsetPoint) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
