// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Dynamic_MethodDefinition_HeaderFile
#define _Dynamic_MethodDefinition_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Dynamic_MethodDefinition_HeaderFile
#include <Handle_Dynamic_MethodDefinition.hxx>
#endif

#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _Dynamic_Method_HeaderFile
#include <Dynamic_Method.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Handle_Dynamic_Parameter_HeaderFile
#include <Handle_Dynamic_Parameter.hxx>
#endif
#ifndef _Dynamic_ModeEnum_HeaderFile
#include <Dynamic_ModeEnum.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class TCollection_HAsciiString;
class TCollection_AsciiString;
class Dynamic_Parameter;


//! This  inherited class   is   for  describing   the <br>
//!          definition  of    a  method.   This  definition is <br>
//!          composed by its name which is readable by the type <br>
//!          function   and a  collection   of  variables which <br>
//!          defines the signature  of the method definition in <br>
//!          term of arguments passed  to the function and also <br>
//!          the useful  internal or constant  variables if the <br>
//!          function is a composite method. This class is also <br>
//!          a  deferred  class and can   not be  used directly <br>
//!          because it is  necessary to specify if the  method <br>
//!          is compiled, interpreted or composite. <br>
class Dynamic_MethodDefinition : public Dynamic_Method {

public:
 // Methods PUBLIC
 // 

//! Returns the name of the method definition. <br>
Standard_EXPORT virtual  TCollection_AsciiString Type() const;

//! Adds  a  new  variable   created from    the parameter <br>
//!          <aparameter>, which  defines the  name of the variable <br>
//!          its type and if necessary its  default value, the mode <br>
//!          <amode> which  precise  if it is  an  in,  out, inout, <br>
//!          internal or   constant variable and the  flag <agroup> <br>
//!          for accepting  a  set of homogeneous variables.   with <br>
//!          the parameter value <aparameter>. <br>
Standard_EXPORT   void AddVariable(const Handle(Dynamic_Parameter)& aparameter,const Dynamic_ModeEnum amode,const Standard_Boolean agroup = Standard_False) ;

//! Useful for debugging. <br>
Standard_EXPORT virtual  void Dump(Standard_OStream& astream) const;
//Standard_EXPORT ~Dynamic_MethodDefinition();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

//! Creates a MethodDefinition with <aname> as type. <br>
Standard_EXPORT Dynamic_MethodDefinition(const Standard_CString aname);


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_TCollection_HAsciiString thename;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
