// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Expr_NamedExpression_HeaderFile
#define _Expr_NamedExpression_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Expr_NamedExpression_HeaderFile
#include <Handle_Expr_NamedExpression.hxx>
#endif

#ifndef _TCollection_AsciiString_HeaderFile
#include <TCollection_AsciiString.hxx>
#endif
#ifndef _Expr_GeneralExpression_HeaderFile
#include <Expr_GeneralExpression.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Expr_GeneralExpression_HeaderFile
#include <Handle_Expr_GeneralExpression.hxx>
#endif
class TCollection_AsciiString;
class Expr_GeneralExpression;


//! Describe an expression used  by its name (as constants <br>
//!          or variables). A single reference is made to a <br>
//!          NamedExpression in every Expression (i.e. a <br>
//!          NamedExpression is shared). <br>
class Expr_NamedExpression : public Expr_GeneralExpression {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT  const TCollection_AsciiString& GetName() const;


Standard_EXPORT   void SetName(const TCollection_AsciiString& name) ;

//! Tests if <me> can be shared by one or more expressions <br>
//!          or must be copied. This method redefines to a True <br>
//!          value the GeneralExpression method. <br>
Standard_EXPORT virtual  Standard_Boolean IsShareable() const;

//! Tests if <me> and <Other> define the same expression. <br>
//!          This method does not include any simplification before <br>
//!          testing. <br>
Standard_EXPORT   Standard_Boolean IsIdentical(const Handle(Expr_GeneralExpression)& Other) const;

//! returns a string representing <me> in a readable way. <br>
Standard_EXPORT   TCollection_AsciiString String() const;
//Standard_EXPORT ~Expr_NamedExpression();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TCollection_AsciiString myName;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
