// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Expr_RUIterator_HeaderFile
#define _Expr_RUIterator_HeaderFile

#ifndef _Expr_MapOfNamedUnknown_HeaderFile
#include <Expr_MapOfNamedUnknown.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Expr_GeneralRelation_HeaderFile
#include <Handle_Expr_GeneralRelation.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Expr_NamedUnknown_HeaderFile
#include <Handle_Expr_NamedUnknown.hxx>
#endif
class Standard_NoMoreObject;
class Standard_NoSuchObject;
class Expr_GeneralRelation;
class Expr_NamedUnknown;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Iterates on NamedUnknowns in a GeneralRelation. <br>
class Expr_RUIterator  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Creates an iterator on every NamedUnknown contained in <br>
//!          <rel>. <br>
Standard_EXPORT Expr_RUIterator(const Handle(Expr_GeneralRelation)& rel);

//! Returns False if on other unknown remains. <br>
Standard_EXPORT   Standard_Boolean More() const;


Standard_EXPORT   void Next() ;

//! Returns current NamedUnknown. <br>
//!          Raises exception if no more unknowns remain. <br>
Standard_EXPORT   Handle_Expr_NamedUnknown Value() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Expr_MapOfNamedUnknown myMap;
Standard_Integer myCurrent;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
