// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _GeomFill_TgtField_HeaderFile
#define _GeomFill_TgtField_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_GeomFill_TgtField_HeaderFile
#include <Handle_GeomFill_TgtField.hxx>
#endif

#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Law_BSpline_HeaderFile
#include <Handle_Law_BSpline.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class Law_BSpline;
class gp_Vec;


//! Root class defining the methods we need to make an <br>
//!          algorithmic tangents field. <br>
class GeomFill_TgtField : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT virtual  Standard_Boolean IsScalable() const;


Standard_EXPORT virtual  void Scale(const Handle(Law_BSpline)& Func) ;

//! Computes  the value  of the    field of tangency    at <br>
//!          parameter W. <br>
Standard_EXPORT virtual  gp_Vec Value(const Standard_Real W) const = 0;

//! Computes the  derivative of  the field of  tangency at <br>
//!          parameter W. <br>
Standard_EXPORT virtual  gp_Vec D1(const Standard_Real W) const = 0;

//! Computes the value and the  derivative of the field of <br>
//!          tangency at parameter W. <br>
Standard_EXPORT virtual  void D1(const Standard_Real W,gp_Vec& V,gp_Vec& DV) const = 0;
//Standard_EXPORT ~GeomFill_TgtField();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
