// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Graphic3d_AspectMarker3d_HeaderFile
#define _Graphic3d_AspectMarker3d_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Graphic3d_AspectMarker3d_HeaderFile
#include <Handle_Graphic3d_AspectMarker3d.hxx>
#endif

#ifndef _Handle_Graphic3d_HArray1OfBytes_HeaderFile
#include <Handle_Graphic3d_HArray1OfBytes.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Aspect_AspectMarker_HeaderFile
#include <Aspect_AspectMarker.hxx>
#endif
#ifndef _Aspect_TypeOfMarker_HeaderFile
#include <Aspect_TypeOfMarker.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class Graphic3d_HArray1OfBytes;
class Quantity_Color;


//! Creates and updates an attribute group for <br>
//!	    marker type primitives. This group contains the type <br>
//!	    of marker, its colour, and its scale factor. <br>
class Graphic3d_AspectMarker3d : public Aspect_AspectMarker {

public:
 // Methods PUBLIC
 // 

//! Creates a context table for marker primitives <br>
//!	    defined with the following default values: <br>
Standard_EXPORT Graphic3d_AspectMarker3d();


Standard_EXPORT Graphic3d_AspectMarker3d(const Aspect_TypeOfMarker AType,const Quantity_Color& AColor,const Standard_Real AScaleOrId);

//! Creates a context table for marker primitives <br>
//!	    defined with the specified values. <br>
Standard_EXPORT Graphic3d_AspectMarker3d(const Aspect_TypeOfMarker AType,const Quantity_Color& AColor,const Standard_Real AScaleOrId,const Standard_Integer AWidth,const Standard_Integer AHeight,const Handle(Graphic3d_HArray1OfBytes)& ATexture);

//! Returns marker's texture size. <br>
Standard_EXPORT   void GetTextureSize(Standard_Integer& AWidth,Standard_Integer& AHeight) ;

//! Returns marker's texture. <br>
Standard_EXPORT  const Handle_Graphic3d_HArray1OfBytes& GetTexture() ;


Standard_EXPORT   void SetTexture(const Standard_Integer AWidth,const Standard_Integer AHeight,const Handle(Graphic3d_HArray1OfBytes)& ATexture) ;
//Standard_EXPORT ~Graphic3d_AspectMarker3d();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //
Handle_Graphic3d_HArray1OfBytes MyTexture;
Standard_Integer MyTextureWidth;
Standard_Integer MyTextureHeight;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
