// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Graphic3d_GraphicDevice_HeaderFile
#define _Graphic3d_GraphicDevice_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Graphic3d_GraphicDevice_HeaderFile
#include <Handle_Graphic3d_GraphicDevice.hxx>
#endif

#ifndef _Handle_Graphic3d_GraphicDriver_HeaderFile
#include <Handle_Graphic3d_GraphicDriver.hxx>
#endif
#ifndef _Xw_GraphicDevice_HeaderFile
#include <Xw_GraphicDevice.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Xw_TypeOfMapping_HeaderFile
#include <Xw_TypeOfMapping.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Aspect_Display_HeaderFile
#include <Aspect_Display.hxx>
#endif
#ifndef _Handle_Aspect_GraphicDriver_HeaderFile
#include <Handle_Aspect_GraphicDriver.hxx>
#endif
class Graphic3d_GraphicDriver;
class Aspect_GraphicDeviceDefinitionError;
class Aspect_GraphicDriver;


//! This class allows the definition of the Advanced <br>
//!	    Graphic Device <br>
//! Warning: An Graphic Device is defined by a connexion <br>
//!	    "host:server.screen" <br>
class Graphic3d_GraphicDevice : public Xw_GraphicDevice {

public:
 // Methods PUBLIC
 // 

//! Creates a GraphicDevice <br>
Standard_EXPORT Graphic3d_GraphicDevice(const Standard_CString Connexion,const Xw_TypeOfMapping Mapping = Xw_TOM_COLORCUBE,const Standard_Integer Ncolors = 0,const Standard_Boolean UseDefault = Standard_True);

//! Creates a GraphicDevice from the Display structure <br>
Standard_EXPORT Graphic3d_GraphicDevice(const Aspect_Display DisplayHandle);

//! Deletes the GraphicDevice <me>. <br>
Standard_EXPORT   void Destroy() ;
~Graphic3d_GraphicDevice()
{
  Destroy();
}


//! Returns the GraphicDriver. <br>
Standard_EXPORT   Handle_Aspect_GraphicDriver GraphicDriver() const;




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

//! Sets the GraphicDriver. <br>
Standard_EXPORT   void SetGraphicDriver() ;

//! Returns Standard_True if the shared library <br>
//!	    is defined by the environment. <br>
//!	    (variables : CSF_GraphicShr, CSF_Graphic3dLib, GRAPHICHOME) <br>
Standard_EXPORT   Standard_Boolean ShrIsDefined(Standard_CString& aShr) const;


 // Fields PRIVATE
 //
Handle_Graphic3d_GraphicDriver MyGraphicDriver;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
