// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Graphic3d_Plotter_HeaderFile
#define _Graphic3d_Plotter_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Graphic3d_Plotter_HeaderFile
#include <Handle_Graphic3d_Plotter.hxx>
#endif

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Handle_Graphic3d_DataStructureManager_HeaderFile
#include <Handle_Graphic3d_DataStructureManager.hxx>
#endif
class Graphic3d_PlotterDefinitionError;
class Graphic3d_DataStructureManager;


//! This class allows the definition of a plotter <br>
class Graphic3d_Plotter : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Deletes the plotter <me>. <br>
Standard_EXPORT virtual  void Destroy() ;
~Graphic3d_Plotter()
{
  Destroy();
}



//!  Warning: Returns Standard_True if plotting is enabled in the view. <br>
//!	    Raises PlotterDefinitionError from Graphic3d <br>
//!	    if plotting has already started. <br>
Standard_EXPORT virtual  Standard_Boolean BeginPlot(const Handle(Graphic3d_DataStructureManager)& aProjector) ;

//! Stops the plotting. <br>
//!  Warning: Raises PlotterDefinitionError from Graphic3d <br>
//!	    if plotting has not started yet. <br>
Standard_EXPORT virtual  void EndPlot() ;


Standard_EXPORT virtual  Standard_Boolean PlottingState() const = 0;




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

//! Initialise the constructor of the plotter. <br>
//!  Warning: Raises InitialisationError if the initialisation <br>
//!	    of the plotter failed. <br>
Standard_EXPORT Graphic3d_Plotter();


 // Fields PROTECTED
 //
Standard_Boolean MyPlottingState;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
