// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IFGraph_Cycles_HeaderFile
#define _IFGraph_Cycles_HeaderFile

#ifndef _IFGraph_SubPartsIterator_HeaderFile
#include <IFGraph_SubPartsIterator.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Interface_Graph;
class IFGraph_StrongComponants;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! determines strong componants in a graph which are Cycles <br>
class IFGraph_Cycles  : public IFGraph_SubPartsIterator {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! creates with a Graph, and will analyse : <br>
//!           whole True  : all the contents of the Model <br>
//!           whole False : sub-parts which will be given later <br>
Standard_EXPORT IFGraph_Cycles(const Interface_Graph& agraph,const Standard_Boolean whole);

//! creates from a StrongComponants which was already computed <br>
Standard_EXPORT IFGraph_Cycles(IFGraph_StrongComponants& subparts);

//! does the computation. Cycles are StrongComponants which are <br>
//!           not Single <br>
Standard_EXPORT virtual  void Evaluate() ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
