// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IFSelect_ModifReorder_HeaderFile
#define _IFSelect_ModifReorder_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IFSelect_ModifReorder_HeaderFile
#include <Handle_IFSelect_ModifReorder.hxx>
#endif

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _IFSelect_Modifier_HeaderFile
#include <IFSelect_Modifier.hxx>
#endif
#ifndef _Handle_Interface_InterfaceModel_HeaderFile
#include <Handle_Interface_InterfaceModel.hxx>
#endif
#ifndef _Handle_Interface_Protocol_HeaderFile
#include <Handle_Interface_Protocol.hxx>
#endif
class IFSelect_ContextModif;
class Interface_InterfaceModel;
class Interface_Protocol;
class Interface_CopyTool;
class TCollection_AsciiString;


//! This modifier reorders a whole model from its roots, i.e. <br>
//!           according to <rootlast> status, it considers each of its <br>
//!           roots, then it orders all its shared entities at any level, <br>
//!           the result begins by the lower level entities ... ends by <br>
//!           the roots. <br>
class IFSelect_ModifReorder : public IFSelect_Modifier {

public:
 // Methods PUBLIC
 // 

//! Creates a ModifReorder. It may change the graph (it does !) <br>
//!           If <rootlast> is True (D), roots are set at the end of packets <br>
//!           Else, they are set at beginning (as done by AddWithRefs) <br>
Standard_EXPORT IFSelect_ModifReorder(const Standard_Boolean rootlast = Standard_True);

//! Acts by computing orders (by method All from ShareTool) then <br>
//!           forcing them in the model. Remark that selection is ignored : <br>
//!           ALL the model is processed in once <br>
Standard_EXPORT   void Perform(IFSelect_ContextModif& ctx,const Handle(Interface_InterfaceModel)& target,const Handle(Interface_Protocol)& protocol,Interface_CopyTool& TC) const;

//! Returns Label as "Reorder, Roots (last or first)" <br>
Standard_EXPORT   TCollection_AsciiString Label() const;
//Standard_EXPORT ~IFSelect_ModifReorder();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Boolean thertl;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
