// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IFSelect_Modifier_HeaderFile
#define _IFSelect_Modifier_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IFSelect_Modifier_HeaderFile
#include <Handle_IFSelect_Modifier.hxx>
#endif

#ifndef _IFSelect_GeneralModifier_HeaderFile
#include <IFSelect_GeneralModifier.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Interface_InterfaceModel_HeaderFile
#include <Handle_Interface_InterfaceModel.hxx>
#endif
#ifndef _Handle_Interface_Protocol_HeaderFile
#include <Handle_Interface_Protocol.hxx>
#endif
class IFSelect_ContextModif;
class Interface_InterfaceModel;
class Interface_Protocol;
class Interface_CopyTool;


//! This class gives a frame for Actions which can work globally <br>
//!           on a File once completely defined (i.e. afterwards) <br>
//! <br>
//!           Remark : if no Selection is set as criterium, the Modifier is <br>
//!           set to work and should consider all the content of the Model <br>
//!           produced. <br>
class IFSelect_Modifier : public IFSelect_GeneralModifier {

public:
 // Methods PUBLIC
 // 

//! This deferred method defines the action specific to each class <br>
//!           of Modifier. It is called by a ModelCopier, once the Model <br>
//!           generated and filled. ModelCopier has already checked the <br>
//!           criteria (Dispatch, Model Rank, Selection) before calling it. <br>
//! <br>
//!           <ctx> detains informations about original data and selection. <br>
//!           The result of copying, on which modifications are to be done, <br>
//!           is <target>. <br>
//!           <TC> allows to run additional copies as required <br>
//! <br>
//!           In case of Error, use methods CCheck from the ContextModif <br>
//!           to aknowledge an entity Check or a Global Check with messages <br>
Standard_EXPORT virtual  void Perform(IFSelect_ContextModif& ctx,const Handle(Interface_InterfaceModel)& target,const Handle(Interface_Protocol)& protocol,Interface_CopyTool& TC) const = 0;
//Standard_EXPORT ~IFSelect_Modifier();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

//! Calls inherited Initialize, transmits to it the information <br>
//!           <maychangegraph> <br>
Standard_EXPORT IFSelect_Modifier(const Standard_Boolean maychangegraph);


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
