// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IFSelect_SelectFlag_HeaderFile
#define _IFSelect_SelectFlag_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IFSelect_SelectFlag_HeaderFile
#include <Handle_IFSelect_SelectFlag.hxx>
#endif

#ifndef _TCollection_AsciiString_HeaderFile
#include <TCollection_AsciiString.hxx>
#endif
#ifndef _IFSelect_SelectExtract_HeaderFile
#include <IFSelect_SelectExtract.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_Interface_InterfaceModel_HeaderFile
#include <Handle_Interface_InterfaceModel.hxx>
#endif
class Interface_EntityIterator;
class Interface_Graph;
class Standard_Transient;
class Interface_InterfaceModel;
class TCollection_AsciiString;


//! A SelectFlag queries a flag noted in the bitmap of the Graph. <br>
//!           The Flag is designated by its Name. Flag Names are defined <br>
//!           by Work Session and, as necessary, other functional objects <br>
//! <br>
//!           WorkSession from IFSelect defines flag "Incorrect" <br>
//!           Objects which control application running define some others <br>
class IFSelect_SelectFlag : public IFSelect_SelectExtract {

public:
 // Methods PUBLIC
 // 

//! Creates a Select Flag, to query a flag designated by its name <br>
Standard_EXPORT IFSelect_SelectFlag(const Standard_CString flagname);

//! Returns the name of the flag <br>
Standard_EXPORT   Standard_CString FlagName() const;

//! Returns the list of selected entities. It is redefined to <br>
//!           work on the graph itself (not queried by sort) <br>
//! <br>
//!           An entity is selected if its flag is True on Direct mode, <br>
//!           False on Reversed mode <br>
//! <br>
//!           If flag does not exist for the given name, returns an empty <br>
//!           result, whatever the Direct/Reversed sense <br>
Standard_EXPORT virtual  Interface_EntityIterator RootResult(const Interface_Graph& G) const;

//! Returns always False because RootResult has done the work <br>
Standard_EXPORT   Standard_Boolean Sort(const Standard_Integer rank,const Handle(Standard_Transient)& ent,const Handle(Interface_InterfaceModel)& model) const;

//! Returns a text defining the criterium, includes the flag name <br>
Standard_EXPORT   TCollection_AsciiString ExtractLabel() const;
//Standard_EXPORT ~IFSelect_SelectFlag();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TCollection_AsciiString thename;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
