// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESAppli_NodalConstraint_HeaderFile
#define _IGESAppli_NodalConstraint_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESAppli_NodalConstraint_HeaderFile
#include <Handle_IGESAppli_NodalConstraint.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_IGESAppli_Node_HeaderFile
#include <Handle_IGESAppli_Node.hxx>
#endif
#ifndef _Handle_IGESDefs_HArray1OfTabularData_HeaderFile
#include <Handle_IGESDefs_HArray1OfTabularData.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
#ifndef _Handle_IGESDefs_TabularData_HeaderFile
#include <Handle_IGESDefs_TabularData.hxx>
#endif
class IGESAppli_Node;
class IGESDefs_HArray1OfTabularData;
class Standard_OutOfRange;
class IGESDefs_TabularData;


//! defines NodalConstraint, Type <418> Form <0> <br>
//!          in package IGESAppli <br>
//!          Relates loads and/or constraints to specific nodes in <br>
//!          the Finite Element Model by creating a relation between <br>
//!          Node entities and Tabular Data Property that contains <br>
//!          the load or constraint data <br>
class IGESAppli_NodalConstraint : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESAppli_NodalConstraint();

//! This method is used to set the fields of the class <br>
//!           NodalConstraint <br>
//!       - aType      : Loads / Constraints <br>
//!       - aNode      : the Node <br>
//!       - allTabData : Tabular Data Property carrying the load <br>
//!                      or constraint vector <br>
Standard_EXPORT   void Init(const Standard_Integer aType,const Handle(IGESAppli_Node)& aNode,const Handle(IGESDefs_HArray1OfTabularData)& allTabData) ;

//! returns total number of cases <br>
Standard_EXPORT   Standard_Integer NbCases() const;

//! returns whether Loads (1) or Constraints (2) <br>
Standard_EXPORT   Standard_Integer Type() const;

//! returns the Node <br>
Standard_EXPORT   Handle_IGESAppli_Node NodeEntity() const;

//! returns Tabular Data Property carrying load or constraint vector <br>
//! raises exception if Index <= 0 or Index > NbCases <br>
Standard_EXPORT   Handle_IGESDefs_TabularData TabularData(const Standard_Integer Index) const;
//Standard_EXPORT ~IGESAppli_NodalConstraint();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer theType;
Handle_IGESAppli_Node theNode;
Handle_IGESDefs_HArray1OfTabularData theTabularDataProps;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
