// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESBasic_AssocGroupType_HeaderFile
#define _IGESBasic_AssocGroupType_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESBasic_AssocGroupType_HeaderFile
#include <Handle_IGESBasic_AssocGroupType.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
class TCollection_HAsciiString;


//! defines AssocGroupType, Type <406> Form <23> <br>
//!          in package IGESBasic <br>
//!          Used to assign an unambiguous identification to a Group <br>
//!          Associativity. <br>
class IGESBasic_AssocGroupType : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESBasic_AssocGroupType();

//! This method is used to set the fields of the class <br>
//!           AssocGroupType <br>
//!       - nbDataFields : number of parameter data fields = 2 <br>
//!       - aType        : type of attached associativity <br>
//!       - aName        : identifier of associativity of type AType <br>
Standard_EXPORT   void Init(const Standard_Integer nbDataFields,const Standard_Integer aType,const Handle(TCollection_HAsciiString)& aName) ;

//! returns the number of parameter data fields, always = 2 <br>
Standard_EXPORT   Standard_Integer NbData() const;

//! returns the type of attached associativity <br>
Standard_EXPORT   Standard_Integer AssocType() const;

//! returns identifier of instance of specified associativity <br>
Standard_EXPORT   Handle_TCollection_HAsciiString Name() const;
//Standard_EXPORT ~IGESBasic_AssocGroupType();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer theNbData;
Standard_Integer theType;
Handle_TCollection_HAsciiString theName;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
