// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESBasic_ExternalRefFileName_HeaderFile
#define _IGESBasic_ExternalRefFileName_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESBasic_ExternalRefFileName_HeaderFile
#include <Handle_IGESBasic_ExternalRefFileName.hxx>
#endif

#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class TCollection_HAsciiString;


//! defines ExternalRefFileName, Type <416> Form <0-2> <br>
//!          in package IGESBasic <br>
//!          Used when single definition from the reference file is <br>
//!          required or for external logical references where an <br>
//!          entity in one file relates to an entity in another file <br>
class IGESBasic_ExternalRefFileName : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESBasic_ExternalRefFileName();

//! This method is used to set the fields of the class <br>
//!           ExternalRefFileName <br>
//!       - aFileIdent : External Reference File Identifier <br>
//!       - anExtName  : External Reference Entity Symbolic Name <br>
Standard_EXPORT   void Init(const Handle(TCollection_HAsciiString)& aFileIdent,const Handle(TCollection_HAsciiString)& anExtName) ;

//! Changes FormNumber to be 2 if <mode> is True (For Entity) <br>
//!           or 0 if <mode> is False (For Definition) <br>
Standard_EXPORT   void SetForEntity(const Standard_Boolean mode) ;

//! returns External Reference File Identifier <br>
Standard_EXPORT   Handle_TCollection_HAsciiString FileId() const;

//! returns External Reference Entity Symbolic Name <br>
Standard_EXPORT   Handle_TCollection_HAsciiString ReferenceName() const;
//Standard_EXPORT ~IGESBasic_ExternalRefFileName();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_TCollection_HAsciiString theExtRefFileIdentifier;
Handle_TCollection_HAsciiString theExtRefEntitySymbName;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
