// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESData_IGESType_HeaderFile
#define _IGESData_IGESType_HeaderFile

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! taken from directory part of an entity (from file or model), <br>
//!           gives "type" and "form" data, used to recognize entity's type <br>
class IGESData_IGESType  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT IGESData_IGESType();


Standard_EXPORT IGESData_IGESType(const Standard_Integer atype,const Standard_Integer aform);

//! returns "type" data <br>
Standard_EXPORT   Standard_Integer Type() const;

//! returns "form" data <br>
Standard_EXPORT   Standard_Integer Form() const;

//! compares two IGESTypes, avoiding comparing their fields <br>
Standard_EXPORT   Standard_Boolean IsEqual(const IGESData_IGESType& another) const;
  Standard_Boolean operator ==(const IGESData_IGESType& another) const
{
  return IsEqual(another);
}


//! resets fields (usefull when an IGESType is stored as mask) <br>
Standard_EXPORT   void Nullify() ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer thetype;
Standard_Integer theform;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
