// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESDefs_AssociativityDef_HeaderFile
#define _IGESDefs_AssociativityDef_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESDefs_AssociativityDef_HeaderFile
#include <Handle_IGESDefs_AssociativityDef.hxx>
#endif

#ifndef _Handle_TColStd_HArray1OfInteger_HeaderFile
#include <Handle_TColStd_HArray1OfInteger.hxx>
#endif
#ifndef _Handle_IGESBasic_HArray1OfHArray1OfInteger_HeaderFile
#include <Handle_IGESBasic_HArray1OfHArray1OfInteger.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class TColStd_HArray1OfInteger;
class IGESBasic_HArray1OfHArray1OfInteger;
class Standard_DimensionMismatch;
class Standard_OutOfRange;


//! defines IGES Associativity Definition Entity, Type <302> <br>
//!          Form <5001 - 9999> in package IGESDefs. <br>
//!          This class permits the preprocessor to define an <br>
//!          associativity schema. i.e., by using it preprocessor <br>
//!          defines the type of relationship. <br>
class IGESDefs_AssociativityDef : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESDefs_AssociativityDef();

//! This method is used to set the fields of the class <br>
//!           AssociativityDef <br>
//!       - requirements : Back Pointers requirements <br>
//!       - orders       : Class Orders <br>
//!       - numItems     : Number of Items per Class <br>
//!       - items        : Items in each class <br>
//! raises exception if lengths of the arrays are not the same. <br>
Standard_EXPORT   void Init(const Handle(TColStd_HArray1OfInteger)& requirements,const Handle(TColStd_HArray1OfInteger)& orders,const Handle(TColStd_HArray1OfInteger)& numItems,const Handle(IGESBasic_HArray1OfHArray1OfInteger)& items) ;


Standard_EXPORT   void SetFormNumber(const Standard_Integer form) ;

//! returns the Number of class definitions <br>
Standard_EXPORT   Standard_Integer NbClassDefs() const;

//! returns 1 if the theBackPointerReqs(ClassNum) = 1 <br>
//! returns 0 if the theBackPointerReqs(ClassNum) = 2 <br>
//! raises exception if ClassNum <= 0 or ClassNum > NbClassDefs() <br>
Standard_EXPORT   Standard_Boolean IsBackPointerReq(const Standard_Integer ClassNum) const;

//! returns 1 or 2 <br>
//! raises exception if ClassNum <= 0 or ClassNum > NbClassDefs() <br>
Standard_EXPORT   Standard_Integer BackPointerReq(const Standard_Integer ClassNum) const;

//! returns 1 if theClassOrders(ClassNum) = 1 (ordered class) <br>
//! returns 0 if theClassOrders(ClassNum) = 2 (unordered class) <br>
//! raises exception if ClassNum <= 0 or ClassNum > NbClassDefs() <br>
Standard_EXPORT   Standard_Boolean IsOrdered(const Standard_Integer ClassNum) const;

//! returns 1 or 2 <br>
//! raises exception if ClassNum <= 0 or ClassNum > NbClassDefs() <br>
Standard_EXPORT   Standard_Integer ClassOrder(const Standard_Integer ClassNum) const;

//! returns no. of items per class entry <br>
//! raises exception if ClassNum <= 0 or ClassNum > NbClassDefs() <br>
Standard_EXPORT   Standard_Integer NbItemsPerClass(const Standard_Integer ClassNum) const;

//! returns ItemNum'th Item of ClassNum'th Class <br>
//! raises exception if <br>
//!      ClassNum <= 0 or ClassNum > NbClassDefs() <br>
//!      ItemNum <= 0 or ItemNum > NbItemsPerClass(ClassNum) <br>
Standard_EXPORT   Standard_Integer Item(const Standard_Integer ClassNum,const Standard_Integer ItemNum) const;
//Standard_EXPORT ~IGESDefs_AssociativityDef();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_TColStd_HArray1OfInteger theBackPointerReqs;
Handle_TColStd_HArray1OfInteger theClassOrders;
Handle_TColStd_HArray1OfInteger theNbItemsPerClass;
Handle_IGESBasic_HArray1OfHArray1OfInteger theItems;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
