// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESDimen_GeneralModule_HeaderFile
#define _IGESDimen_GeneralModule_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESDimen_GeneralModule_HeaderFile
#include <Handle_IGESDimen_GeneralModule.hxx>
#endif

#ifndef _IGESData_GeneralModule_HeaderFile
#include <IGESData_GeneralModule.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_IGESData_IGESEntity_HeaderFile
#include <Handle_IGESData_IGESEntity.hxx>
#endif
#ifndef _Handle_Interface_Check_HeaderFile
#include <Handle_Interface_Check.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
class IGESData_IGESEntity;
class Interface_EntityIterator;
class IGESData_DirChecker;
class Interface_ShareTool;
class Interface_Check;
class Standard_Transient;
class Interface_CopyTool;


//! Definition of General Services for IGESDimen (specific part) <br>
//!           This Services comprise : Shared & Implied Lists, Copy, Check <br>
class IGESDimen_GeneralModule : public IGESData_GeneralModule {

public:
 // Methods PUBLIC
 // 

//! Creates a GeneralModule from IGESDimen and puts it into GeneralLib <br>
Standard_EXPORT IGESDimen_GeneralModule();

//! Lists the Entities shared by a given IGESEntity <ent>, from <br>
//!           its specific parameters : specific for each type <br>
Standard_EXPORT   void OwnSharedCase(const Standard_Integer CN,const Handle(IGESData_IGESEntity)& ent,Interface_EntityIterator& iter) const;

//! Returns a DirChecker, specific for each type of Entity <br>
//!           (identified by its Case Number) : this DirChecker defines <br>
//!           constraints which must be respected by the DirectoryPart <br>
Standard_EXPORT   IGESData_DirChecker DirChecker(const Standard_Integer CN,const Handle(IGESData_IGESEntity)& ent) const;

//! Performs Specific Semantic Check for each type of Entity <br>
Standard_EXPORT   void OwnCheckCase(const Standard_Integer CN,const Handle(IGESData_IGESEntity)& ent,const Interface_ShareTool& shares,Handle(Interface_Check)& ach) const;

//! Specific creation of a new void entity <br>
Standard_EXPORT   Standard_Boolean NewVoid(const Standard_Integer CN,Handle(Standard_Transient)& entto) const;

//! Copies parameters which are specific of each Type of Entity <br>
Standard_EXPORT   void OwnCopyCase(const Standard_Integer CN,const Handle(IGESData_IGESEntity)& entfrom,const Handle(IGESData_IGESEntity)& entto,Interface_CopyTool& TC) const;

//! Returns a category number which characterizes an entity <br>
//!           Drawing for all <br>
Standard_EXPORT virtual  Standard_Integer CategoryNumber(const Standard_Integer CN,const Handle(Standard_Transient)& ent,const Interface_ShareTool& shares) const;
//Standard_EXPORT ~IGESDimen_GeneralModule();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
