// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSelect_DispPerDrawing_HeaderFile
#define _IGESSelect_DispPerDrawing_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSelect_DispPerDrawing_HeaderFile
#include <Handle_IGESSelect_DispPerDrawing.hxx>
#endif

#ifndef _Handle_IGESSelect_ViewSorter_HeaderFile
#include <Handle_IGESSelect_ViewSorter.hxx>
#endif
#ifndef _IFSelect_Dispatch_HeaderFile
#include <IFSelect_Dispatch.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class IGESSelect_ViewSorter;
class TCollection_AsciiString;
class Interface_Graph;
class IFGraph_SubPartsIterator;
class Interface_EntityIterator;


//! This type of dispatch defines sets of entities attached to <br>
//!           distinct drawings. This information is taken from attached <br>
//!           views which appear in the Directory Part. Also Drawing Frames <br>
//!           are considered when Drawings are part of input list. <br>
//! <br>
//!           Remaining data concern entities not attached to a drawing. <br>
class IGESSelect_DispPerDrawing : public IFSelect_Dispatch {

public:
 // Methods PUBLIC
 // 

//! Creates a DispPerDrawing <br>
Standard_EXPORT IGESSelect_DispPerDrawing();

//! Returns as Label, "One File per Drawing" <br>
Standard_EXPORT   TCollection_AsciiString Label() const;

//! Computes the list of produced Packets. Packets are computed <br>
//!           by a ViewSorter (SortDrawings with also frames). <br>
Standard_EXPORT   void Packets(const Interface_Graph& G,IFGraph_SubPartsIterator& packs) const;

//! Returns True, because of entities attached to no view. <br>
Standard_EXPORT virtual  Standard_Boolean CanHaveRemainder() const;

//! Returns Remainder which is a set of Entities. <br>
//!           It is supposed to be called once Packets has been called. <br>
Standard_EXPORT virtual  Interface_EntityIterator Remainder(const Interface_Graph& G) const;
//Standard_EXPORT ~IGESSelect_DispPerDrawing();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_IGESSelect_ViewSorter thesorter;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
