// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSelect_IGESTypeForm_HeaderFile
#define _IGESSelect_IGESTypeForm_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSelect_IGESTypeForm_HeaderFile
#include <Handle_IGESSelect_IGESTypeForm.hxx>
#endif

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _IFSelect_Signature_HeaderFile
#include <IFSelect_Signature.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_Interface_InterfaceModel_HeaderFile
#include <Handle_Interface_InterfaceModel.hxx>
#endif
class Standard_Transient;
class Interface_InterfaceModel;


//! IGESTypeForm is a Signature specific to the IGES Norm : <br>
//!           it gives the signature under two possible forms : <br>
//!           - as "mmm nnn", with "mmm" as IGES Type Number, and "nnn" <br>
//!             as IGES From Number (even if = 0)  [Default] <br>
//!           - as "mmm" alone, which gives only the IGES Type Number <br>
class IGESSelect_IGESTypeForm : public IFSelect_Signature {

public:
 // Methods PUBLIC
 // 

//! Creates a Signature for IGES Type & Form Numbers <br>
//!           If <withform> is False, for IGES Type Number only <br>
Standard_EXPORT IGESSelect_IGESTypeForm(const Standard_Boolean withform = Standard_True);

//! Changes the mode for giving the Form Number <br>
Standard_EXPORT   void SetForm(const Standard_Boolean withform) ;

//! Returns the signature for IGES, "mmm nnn" or "mmm" according <br>
//!           creation choice (Type & Form or Type only) <br>
Standard_EXPORT   Standard_CString Value(const Handle(Standard_Transient)& ent,const Handle(Interface_InterfaceModel)& model) const;
//Standard_EXPORT ~IGESSelect_IGESTypeForm();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Boolean theform;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
