// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSolid_BooleanTree_HeaderFile
#define _IGESSolid_BooleanTree_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSolid_BooleanTree_HeaderFile
#include <Handle_IGESSolid_BooleanTree.hxx>
#endif

#ifndef _Handle_IGESData_HArray1OfIGESEntity_HeaderFile
#include <Handle_IGESData_HArray1OfIGESEntity.hxx>
#endif
#ifndef _Handle_TColStd_HArray1OfInteger_HeaderFile
#include <Handle_TColStd_HArray1OfInteger.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_IGESData_IGESEntity_HeaderFile
#include <Handle_IGESData_IGESEntity.hxx>
#endif
class IGESData_HArray1OfIGESEntity;
class TColStd_HArray1OfInteger;
class Standard_OutOfRange;
class IGESData_IGESEntity;


//! defines BooleanTree, Type <180> Form Number <0> <br>
//!          in package IGESSolid <br>
//!          The Boolean tree describes a binary tree structure <br>
//!          composed of regularized Boolean operations and operands, <br>
//!          in post-order notation. <br>
class IGESSolid_BooleanTree : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESSolid_BooleanTree();

//! This method is used to set the fields of the class <br>
//!           BooleanTree <br>
//!       - operands   : Array containing pointer to DE of operands <br>
//!       - operations : Array containing integer type for operations <br>
Standard_EXPORT   void Init(const Handle(IGESData_HArray1OfIGESEntity)& operands,const Handle(TColStd_HArray1OfInteger)& operations) ;

//! returns the length of the post-order list <br>
Standard_EXPORT   Standard_Integer Length() const;

//! returns True if Index'th value in the post-order list is an Operand; <br>
//! else returns False if it is an Integer Operations <br>
//! raises exception if Index < 1 or Index > Length() <br>
Standard_EXPORT   Standard_Boolean IsOperand(const Standard_Integer Index) const;

//! returns the Index'th value in the post-order list only if it is <br>
//! an operand else returns NULL <br>
//! raises exception if Index < 1 or Index > Length() <br>
Standard_EXPORT   Handle_IGESData_IGESEntity Operand(const Standard_Integer Index) const;

//! returns the Index'th value in the post-order list only if it is <br>
//! an operation else returns 0 <br>
//! raises exception if Index < 1 or Index > Length() <br>
Standard_EXPORT   Standard_Integer Operation(const Standard_Integer Index) const;
//Standard_EXPORT ~IGESSolid_BooleanTree();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_IGESData_HArray1OfIGESEntity theOperands;
Handle_TColStd_HArray1OfInteger theOperations;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
