// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSolid_SelectedComponent_HeaderFile
#define _IGESSolid_SelectedComponent_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSolid_SelectedComponent_HeaderFile
#include <Handle_IGESSolid_SelectedComponent.hxx>
#endif

#ifndef _Handle_IGESSolid_BooleanTree_HeaderFile
#include <Handle_IGESSolid_BooleanTree.hxx>
#endif
#ifndef _gp_XYZ_HeaderFile
#include <gp_XYZ.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
class IGESSolid_BooleanTree;
class gp_XYZ;
class gp_Pnt;


//! defines SelectedComponent, Type <182> Form Number <0> <br>
//!          in package IGESSolid <br>
//!          The Selected Component entity provides a means of <br>
//!          selecting one component of a disjoint CSG solid <br>
class IGESSolid_SelectedComponent : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESSolid_SelectedComponent();

//! This method is used to set the fields of the class <br>
//!           SelectedComponent <br>
//!       - anEntity  : the Boolean tree entity <br>
//!       - selectPnt : Point in or on the desired component <br>
Standard_EXPORT   void Init(const Handle(IGESSolid_BooleanTree)& anEntity,const gp_XYZ& selectPnt) ;

//! returns the Boolean tree entity <br>
Standard_EXPORT   Handle_IGESSolid_BooleanTree Component() const;

//! returns the point on/in the selected component <br>
Standard_EXPORT   gp_Pnt SelectPoint() const;

//! returns the point on/in the selected component <br>
//! after applying TransformationMatrix <br>
Standard_EXPORT   gp_Pnt TransformedSelectPoint() const;
//Standard_EXPORT ~IGESSolid_SelectedComponent();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_IGESSolid_BooleanTree theEntity;
gp_XYZ theSelectPoint;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
