// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSolid_SolidInstance_HeaderFile
#define _IGESSolid_SolidInstance_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSolid_SolidInstance_HeaderFile
#include <Handle_IGESSolid_SolidInstance.hxx>
#endif

#ifndef _Handle_IGESData_IGESEntity_HeaderFile
#include <Handle_IGESData_IGESEntity.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class IGESData_IGESEntity;


//! defines SolidInstance, Type <430> Form Number <0> <br>
//!          in package IGESSolid <br>
//!          This provides a mechanism for replicating a solid <br>
//!          representation. <br>
//! <br>
//!          From IGES-5.3, Form may be <1> for a BREP <br>
//!          Else it is for a Boolean Tree, Primitive, other Solid Inst. <br>
class IGESSolid_SolidInstance : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESSolid_SolidInstance();

//! This method is used to set the fields of the class <br>
//!           SolidInstance <br>
//!       - anEntity : the entity corresponding to the solid <br>
Standard_EXPORT   void Init(const Handle(IGESData_IGESEntity)& anEntity) ;

//! Tells if a SolidInstance is for a BREP <br>
//!           Default is False <br>
Standard_EXPORT   Standard_Boolean IsBrep() const;

//! Sets or unsets the Brep status (FormNumber = 1 else 0) <br>
Standard_EXPORT   void SetBrep(const Standard_Boolean brep) ;

//! returns the solid entity <br>
Standard_EXPORT   Handle_IGESData_IGESEntity Entity() const;
//Standard_EXPORT ~IGESSolid_SolidInstance();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_IGESData_IGESEntity theEntity;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
