// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IGESSolid_SolidOfLinearExtrusion_HeaderFile
#define _IGESSolid_SolidOfLinearExtrusion_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_IGESSolid_SolidOfLinearExtrusion_HeaderFile
#include <Handle_IGESSolid_SolidOfLinearExtrusion.hxx>
#endif

#ifndef _Handle_IGESData_IGESEntity_HeaderFile
#include <Handle_IGESData_IGESEntity.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _gp_XYZ_HeaderFile
#include <gp_XYZ.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
class IGESData_IGESEntity;
class gp_XYZ;
class gp_Dir;


//! defines SolidOfLinearExtrusion, Type <164> Form Number <0> <br>
//!          in package IGESSolid <br>
//!          Solid of linear extrusion is defined by translatin an <br>
//!          area determined by a planar curve <br>
class IGESSolid_SolidOfLinearExtrusion : public IGESData_IGESEntity {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT IGESSolid_SolidOfLinearExtrusion();

//! This method is used to set the fields of the class <br>
//!           SolidOfLinearExtrusion <br>
//!       - aCurve     : the planar curve that is to be translated <br>
//!       - aLength    : the length of extrusion <br>
//!       - aDirection : the vector specifying the direction of extrusion <br>
//!                      default (0,0,1) <br>
Standard_EXPORT   void Init(const Handle(IGESData_IGESEntity)& aCurve,const Standard_Real aLength,const gp_XYZ& aDirection) ;

//! returns the planar curve that is to be translated <br>
Standard_EXPORT   Handle_IGESData_IGESEntity Curve() const;

//! returns the Extrusion Length <br>
Standard_EXPORT   Standard_Real ExtrusionLength() const;

//! returns the Extrusion direction <br>
Standard_EXPORT   gp_Dir ExtrusionDirection() const;

//! returns ExtrusionDirection after applying TransformationMatrix <br>
Standard_EXPORT   gp_Dir TransformedExtrusionDirection() const;
//Standard_EXPORT ~IGESSolid_SolidOfLinearExtrusion();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_IGESData_IGESEntity theCurve;
Standard_Real theLength;
gp_XYZ theDirection;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
