// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IntPatch_HInterTool_HeaderFile
#define _IntPatch_HInterTool_HeaderFile

#ifndef _Handle_Adaptor3d_HVertex_HeaderFile
#include <Handle_Adaptor3d_HVertex.hxx>
#endif
#ifndef _Handle_Adaptor2d_HCurve2d_HeaderFile
#include <Handle_Adaptor2d_HCurve2d.hxx>
#endif
#ifndef _Handle_Adaptor3d_HSurface_HeaderFile
#include <Handle_Adaptor3d_HSurface.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class Adaptor3d_HVertex;
class Adaptor2d_HCurve2d;
class Adaptor3d_HSurface;
class IntPatch_HCurve2dTool;
class IntPatch_HSurfaceTool;
class gp_Pnt2d;
class gp_Pnt;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class IntPatch_HInterTool  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

static  Standard_Boolean SingularOnUMin(const Handle(Adaptor3d_HSurface)& S) ;

static  Standard_Boolean SingularOnUMax(const Handle(Adaptor3d_HSurface)& S) ;

static  Standard_Boolean SingularOnVMin(const Handle(Adaptor3d_HSurface)& S) ;

static  Standard_Boolean SingularOnVMax(const Handle(Adaptor3d_HSurface)& S) ;


Standard_EXPORT static  Standard_Integer NbSamplesU(const Handle(Adaptor3d_HSurface)& S,const Standard_Real u1,const Standard_Real u2) ;


Standard_EXPORT static  Standard_Integer NbSamplesV(const Handle(Adaptor3d_HSurface)& S,const Standard_Real v1,const Standard_Real v2) ;


Standard_EXPORT static  Standard_Integer NbSamplePoints(const Handle(Adaptor3d_HSurface)& S) ;


Standard_EXPORT static  void SamplePoint(const Handle(Adaptor3d_HSurface)& S,const Standard_Integer Index,Standard_Real& U,Standard_Real& V) ;


Standard_EXPORT static  Standard_Boolean HasBeenSeen(const Handle(Adaptor2d_HCurve2d)& C) ;


Standard_EXPORT static  Standard_Integer NbSamplesOnArc(const Handle(Adaptor2d_HCurve2d)& A) ;


Standard_EXPORT static  void Bounds(const Handle(Adaptor2d_HCurve2d)& C,Standard_Real& Ufirst,Standard_Real& Ulast) ;


Standard_EXPORT static  Standard_Boolean Project(const Handle(Adaptor2d_HCurve2d)& C,const gp_Pnt2d& P,Standard_Real& Paramproj,gp_Pnt2d& Ptproj) ;


Standard_EXPORT static  Standard_Real Tolerance(const Handle(Adaptor3d_HVertex)& V,const Handle(Adaptor2d_HCurve2d)& C) ;


Standard_EXPORT static  Standard_Real Parameter(const Handle(Adaptor3d_HVertex)& V,const Handle(Adaptor2d_HCurve2d)& C) ;


Standard_EXPORT static  Standard_Integer NbPoints(const Handle(Adaptor2d_HCurve2d)& C) ;


Standard_EXPORT static  void Value(const Handle(Adaptor2d_HCurve2d)& C,const Standard_Integer Index,gp_Pnt& Pt,Standard_Real& Tol,Standard_Real& U) ;


Standard_EXPORT static  Standard_Boolean IsVertex(const Handle(Adaptor2d_HCurve2d)& C,const Standard_Integer Index) ;


Standard_EXPORT static  void Vertex(const Handle(Adaptor2d_HCurve2d)& C,const Standard_Integer Index,Handle(Adaptor3d_HVertex)& V) ;


Standard_EXPORT static  Standard_Integer NbSegments(const Handle(Adaptor2d_HCurve2d)& C) ;


Standard_EXPORT static  Standard_Boolean HasFirstPoint(const Handle(Adaptor2d_HCurve2d)& C,const Standard_Integer Index,Standard_Integer& IndFirst) ;


Standard_EXPORT static  Standard_Boolean HasLastPoint(const Handle(Adaptor2d_HCurve2d)& C,const Standard_Integer Index,Standard_Integer& IndLast) ;


Standard_EXPORT static  Standard_Boolean IsAllSolution(const Handle(Adaptor2d_HCurve2d)& C) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};

#define TheHVertex Handle_Adaptor3d_HVertex
#define TheHVertex_hxx <Adaptor3d_HVertex.hxx>
#define TheHCurve2d Handle_Adaptor2d_HCurve2d
#define TheHCurve2d_hxx <Adaptor2d_HCurve2d.hxx>
#define TheHSurface Handle_Adaptor3d_HSurface
#define TheHSurface_hxx <Adaptor3d_HSurface.hxx>
#define TheHCurve2dTool IntPatch_HCurve2dTool
#define TheHCurve2dTool_hxx <IntPatch_HCurve2dTool.hxx>
#define TheHSurfaceTool IntPatch_HSurfaceTool
#define TheHSurfaceTool_hxx <IntPatch_HSurfaceTool.hxx>
#define IntPatch_HInterToolGen IntPatch_HInterTool
#define IntPatch_HInterToolGen_hxx <IntPatch_HInterTool.hxx>

#include <IntPatch_HInterToolGen.lxx>

#undef TheHVertex
#undef TheHVertex_hxx
#undef TheHCurve2d
#undef TheHCurve2d_hxx
#undef TheHSurface
#undef TheHSurface_hxx
#undef TheHCurve2dTool
#undef TheHCurve2dTool_hxx
#undef TheHSurfaceTool
#undef TheHSurfaceTool_hxx
#undef IntPatch_HInterToolGen
#undef IntPatch_HInterToolGen_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
