// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IntPolyh_Triangle_HeaderFile
#define _IntPolyh_Triangle_HeaderFile

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Handle_Adaptor3d_HSurface_HeaderFile
#include <Handle_Adaptor3d_HSurface.hxx>
#endif
class Adaptor3d_HSurface;
class IntPolyh_ArrayOfPoints;
class IntPolyh_ArrayOfTriangles;
class IntPolyh_ArrayOfEdges;
class Bnd_Box;
class IntPolyh_StartPoint;
class IntPolyh_ArrayOfCouples;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class IntPolyh_Triangle  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT IntPolyh_Triangle();


Standard_EXPORT IntPolyh_Triangle(const Standard_Integer i1,const Standard_Integer i2,const Standard_Integer i3);


Standard_EXPORT   Standard_Integer FirstPoint() const;


Standard_EXPORT   Standard_Integer SecondPoint() const;


Standard_EXPORT   Standard_Integer ThirdPoint() const;


Standard_EXPORT   Standard_Integer FirstEdge() const;


Standard_EXPORT   Standard_Integer FirstEdgeOrientation() const;


Standard_EXPORT   Standard_Integer SecondEdge() const;


Standard_EXPORT   Standard_Integer SecondEdgeOrientation() const;


Standard_EXPORT   Standard_Integer ThirdEdge() const;


Standard_EXPORT   Standard_Integer ThirdEdgeOrientation() const;


Standard_EXPORT   Standard_Real GetFleche() const;


Standard_EXPORT   Standard_Integer IndiceIntersectionPossible() const;


Standard_EXPORT   Standard_Integer IndiceIntersection() const;


Standard_EXPORT   void SetFirstPoint(const Standard_Integer v) ;


Standard_EXPORT   void SetSecondPoint(const Standard_Integer v) ;


Standard_EXPORT   void SetThirdPoint(const Standard_Integer v) ;


Standard_EXPORT   void SetFirstEdge(const Standard_Integer v,const Standard_Integer s) ;


Standard_EXPORT   void SetSecondEdge(const Standard_Integer v,const Standard_Integer s) ;


Standard_EXPORT   void SetThirdEdge(const Standard_Integer v,const Standard_Integer s) ;


Standard_EXPORT   void SetFleche(const Standard_Real v) ;


Standard_EXPORT   void SetIndiceIntersectionPossible(const Standard_Integer v) ;


Standard_EXPORT   void SetIndiceIntersection(const Standard_Integer v) ;


Standard_EXPORT   Standard_Integer GetEdgeNumber(const Standard_Integer v) const;


Standard_EXPORT   void SetEdge(const Standard_Integer v,const Standard_Integer en) ;


Standard_EXPORT   Standard_Integer GetEdgeOrientation(const Standard_Integer v) const;


Standard_EXPORT   void SetEdgeOrientation(const Standard_Integer v,const Standard_Integer oe) ;


Standard_EXPORT   void TriangleDeflection(const Handle(Adaptor3d_HSurface)& MaSurface,const IntPolyh_ArrayOfPoints& TP) ;


Standard_EXPORT   Standard_Integer CheckCommonEdge(const Standard_Integer PE1,const Standard_Integer PE2,const Standard_Integer P3,const Standard_Integer Index,const IntPolyh_ArrayOfTriangles& TTriangles) const;


Standard_EXPORT   Standard_Integer GetNextTriangle2(const Standard_Integer NumTri,const Standard_Integer NumEdge,const IntPolyh_ArrayOfEdges& TEdges) const;


Standard_EXPORT   void MiddleRefinement(const Standard_Integer TriangleNumber,const Handle(Adaptor3d_HSurface)& MySurface,IntPolyh_ArrayOfPoints& TPoints,IntPolyh_ArrayOfTriangles& TTriangles,IntPolyh_ArrayOfEdges& TEdges) ;


Standard_EXPORT   void MultipleMiddleRefinement(const Standard_Integer NombreAffinages,const Standard_Integer TriangleNumber,const Handle(Adaptor3d_HSurface)& MySurface,IntPolyh_ArrayOfPoints& TPoints,IntPolyh_ArrayOfTriangles& TTriangles,IntPolyh_ArrayOfEdges& TEdges) ;


Standard_EXPORT   Standard_Integer CompareBoxTriangle(const Bnd_Box& b,const IntPolyh_ArrayOfPoints& TPoints) const;


Standard_EXPORT   void MultipleMiddleRefinement2(const Standard_Real RefineCriterion,const Bnd_Box& thebox,const Standard_Integer TriangleNumber,const Handle(Adaptor3d_HSurface)& MySurface,IntPolyh_ArrayOfPoints& TPoints,IntPolyh_ArrayOfTriangles& TTriangles,IntPolyh_ArrayOfEdges& TEdges) ;


Standard_EXPORT   Standard_Integer GetNextChainTriangle(const IntPolyh_StartPoint& SPIni,const Standard_Integer LastTTC,IntPolyh_ArrayOfCouples& TriContactsArray,const IntPolyh_ArrayOfTriangles& TTriangles1,const IntPolyh_ArrayOfTriangles& TTriangles2,Standard_Integer& NumContact,Standard_Integer& NextTriangle) const;


Standard_EXPORT   void LinkEdges2Triangle(const IntPolyh_ArrayOfEdges& TEdges,const Standard_Integer ed1,const Standard_Integer ed2,const Standard_Integer ed3) ;


Standard_EXPORT   void SetEdgeandOrientation(const Standard_Integer Edge,const IntPolyh_ArrayOfEdges& TEdges) ;


Standard_EXPORT   void Dump(const Standard_Integer v) const;


Standard_EXPORT   void DumpFleche(const Standard_Integer v) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer p1;
Standard_Integer p2;
Standard_Integer p3;
Standard_Integer e1;
Standard_Integer oe1;
Standard_Integer e2;
Standard_Integer oe2;
Standard_Integer e3;
Standard_Integer oe3;
Standard_Integer II;
Standard_Integer IP;
Standard_Real Fleche;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
