// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _IntTools_FClass2d_HeaderFile
#define _IntTools_FClass2d_HeaderFile

#ifndef _BRepTopAdaptor_SeqOfPtr_HeaderFile
#include <BRepTopAdaptor_SeqOfPtr.hxx>
#endif
#ifndef _TColStd_SequenceOfInteger_HeaderFile
#include <TColStd_SequenceOfInteger.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _TopoDS_Face_HeaderFile
#include <TopoDS_Face.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _TopAbs_State_HeaderFile
#include <TopAbs_State.hxx>
#endif
class TopoDS_Face;
class gp_Pnt2d;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Class provides an algorithm to classify a 2d Point <br>
//!         in 2d space of face using boundaries of the face. <br>
class IntTools_FClass2d  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


//! Empty constructor <br>
Standard_EXPORT IntTools_FClass2d();


//! Initializes algorithm by the face F <br>
//! and tolerance Tol <br>
Standard_EXPORT IntTools_FClass2d(const TopoDS_Face& F,const Standard_Real Tol);


//! Initializes algorithm by the face F <br>
//! and tolerance Tol <br>
Standard_EXPORT   void Init(const TopoDS_Face& F,const Standard_Real Tol) ;


//! Returns state of infinite 2d point relatively to (0, 0) <br>
Standard_EXPORT   TopAbs_State PerformInfinitePoint() const;


//! Returns state of the 2d point Puv. <br>
//! If RecadreOnPeriodic is true (defalut value), <br>
//! for the periodic surface 2d point, adjusted to period, is <br>
//! classified. <br>
Standard_EXPORT   TopAbs_State Perform(const gp_Pnt2d& Puv,const Standard_Boolean RecadreOnPeriodic = Standard_True) const;


//! Destructor <br>
Standard_EXPORT   void Destroy() ;
~IntTools_FClass2d()
{
  Destroy();
}



//! Test a point with +- an offset (Tol) and returns <br>
//! On if some points are OUT an some are IN <br>
//!  (Caution: Internal use . see the code for more details) <br>
Standard_EXPORT   TopAbs_State TestOnRestriction(const gp_Pnt2d& Puv,const Standard_Real Tol,const Standard_Boolean RecadreOnPeriodic = Standard_True) const;


Standard_EXPORT   Standard_Boolean IsHole() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
BRepTopAdaptor_SeqOfPtr TabClass;
TColStd_SequenceOfInteger TabOrien;
Standard_Real Toluv;
TopoDS_Face Face;
Standard_Real U1;
Standard_Real V1;
Standard_Real U2;
Standard_Real V2;
Standard_Real Umin;
Standard_Real Umax;
Standard_Real Vmin;
Standard_Real Vmax;
Standard_Boolean myIsHole;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
