// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Law_Interpol_HeaderFile
#define _Law_Interpol_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Law_Interpol_HeaderFile
#include <Handle_Law_Interpol.hxx>
#endif

#ifndef _Law_BSpFunc_HeaderFile
#include <Law_BSpFunc.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class TColgp_Array1OfPnt2d;


//! Provides an evolution law that interpolates a set <br>
//!          of parameter and value pairs (wi, radi) <br>
class Law_Interpol : public Law_BSpFunc {

public:
 // Methods PUBLIC
 // 

//! Constructs an empty interpolative evolution law. <br>
//! The function Set is used to define the law. <br>
Standard_EXPORT Law_Interpol();


//!    Defines this evolution law by interpolating the set of 2D <br>
//! points ParAndRad. The Y coordinate of a point of <br>
//! ParAndRad is the value of the function at the parameter <br>
//! point given by its X coordinate. <br>
//! If Periodic is true, this function is assumed to be periodic. <br>
//! Warning <br>
//! -   The X coordinates of points in the table ParAndRad <br>
//!   must be given in ascendant order. <br>
//! -   If Periodic is true, the first and last Y coordinates of <br>
//!   points in the table ParAndRad are assumed to be <br>
//!   equal. In addition, with the second syntax, Dd and Df <br>
//!   are also assumed to be equal. If this is not the case, <br>
//!   Set uses the first value(s) as last value(s). <br>
Standard_EXPORT   void Set(const TColgp_Array1OfPnt2d& ParAndRad,const Standard_Boolean Periodic = Standard_False) ;


Standard_EXPORT   void SetInRelative(const TColgp_Array1OfPnt2d& ParAndRad,const Standard_Real Ud,const Standard_Real Uf,const Standard_Boolean Periodic = Standard_False) ;


//!    Defines this evolution law by interpolating the set of 2D <br>
//! points ParAndRad. The Y coordinate of a point of <br>
//! ParAndRad is the value of the function at the parameter <br>
//! point given by its X coordinate. <br>
//! If Periodic is true, this function is assumed to be periodic. <br>
//! In the second syntax, Dd and Df define the values of <br>
//! the first derivative of the function at its first and last points. <br>
//! Warning <br>
//! -   The X coordinates of points in the table ParAndRad <br>
//!   must be given in ascendant order. <br>
//! -   If Periodic is true, the first and last Y coordinates of <br>
//!   points in the table ParAndRad are assumed to be <br>
//!   equal. In addition, with the second syntax, Dd and Df <br>
//!   are also assumed to be equal. If this is not the case, <br>
//!   Set uses the first value(s) as last value(s). <br>
Standard_EXPORT   void Set(const TColgp_Array1OfPnt2d& ParAndRad,const Standard_Real Dd,const Standard_Real Df,const Standard_Boolean Periodic = Standard_False) ;


Standard_EXPORT   void SetInRelative(const TColgp_Array1OfPnt2d& ParAndRad,const Standard_Real Ud,const Standard_Real Uf,const Standard_Real Dd,const Standard_Real Df,const Standard_Boolean Periodic = Standard_False) ;
//Standard_EXPORT ~Law_Interpol();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
