// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _LocOpe_WiresOnShape_HeaderFile
#define _LocOpe_WiresOnShape_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_LocOpe_WiresOnShape_HeaderFile
#include <Handle_LocOpe_WiresOnShape.hxx>
#endif

#ifndef _TopoDS_Shape_HeaderFile
#include <TopoDS_Shape.hxx>
#endif
#ifndef _TopTools_IndexedDataMapOfShapeShape_HeaderFile
#include <TopTools_IndexedDataMapOfShapeShape.hxx>
#endif
#ifndef _TopTools_DataMapOfShapeShape_HeaderFile
#include <TopTools_DataMapOfShapeShape.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _LocOpe_ProjectedWires_HeaderFile
#include <LocOpe_ProjectedWires.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class TopoDS_Shape;
class TopoDS_Wire;
class TopoDS_Face;
class TopoDS_Edge;
class TopoDS_Vertex;



class LocOpe_WiresOnShape : public LocOpe_ProjectedWires {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT LocOpe_WiresOnShape(const TopoDS_Shape& S);


Standard_EXPORT   void Init(const TopoDS_Shape& S) ;


Standard_EXPORT   void Bind(const TopoDS_Wire& W,const TopoDS_Face& F) ;


Standard_EXPORT   void Bind(const TopoDS_Edge& E,const TopoDS_Face& F) ;


Standard_EXPORT   void Bind(const TopoDS_Edge& EfromW,const TopoDS_Edge& EonFace) ;


Standard_EXPORT   void BindAll() ;

  Standard_Boolean IsDone() const;


Standard_EXPORT   void InitEdgeIterator() ;


Standard_EXPORT   Standard_Boolean MoreEdge() ;


Standard_EXPORT   TopoDS_Edge Edge() ;

//! Returns the face of the shape on which the current <br>
//!          edge is projected. <br>
Standard_EXPORT   TopoDS_Face OnFace() ;

//! If the   current  edge is  projected  on  an edge, <br>
//!          returns <Standard_True> and sets the value of <E>. <br>
//!          Otherwise, returns <Standard_False>. <br>
Standard_EXPORT   Standard_Boolean OnEdge(TopoDS_Edge& E) ;


Standard_EXPORT   void NextEdge() ;


Standard_EXPORT   Standard_Boolean OnVertex(const TopoDS_Vertex& Vwire,TopoDS_Vertex& Vshape) ;

//! If the vertex <V> lies on  an edge of the original <br>
//!          shape,  returns     <Standard_True> and   sets the <br>
//!          concerned edge in  <E>,  and the parameter on  the <br>
//!          edge in <P>. <br>
//!          Else returns <Standard_False>. <br>
Standard_EXPORT   Standard_Boolean OnEdge(const TopoDS_Vertex& V,TopoDS_Edge& E,Standard_Real& P) ;
//Standard_EXPORT ~LocOpe_WiresOnShape();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TopoDS_Shape myShape;
TopTools_IndexedDataMapOfShapeShape myMapEF;
TopTools_DataMapOfShapeShape myMap;
Standard_Boolean myDone;
Standard_Integer myIndex;


};


#include <LocOpe_WiresOnShape.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
