// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MAT_BasicElt_HeaderFile
#define _MAT_BasicElt_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_MAT_BasicElt_HeaderFile
#include <Handle_MAT_BasicElt.hxx>
#endif

#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Handle_MAT_Arc_HeaderFile
#include <Handle_MAT_Arc.hxx>
#endif
class MAT_Arc;


//! A    BasicELt  is  associated   to  each  elemtary <br>
//!          constituant of  the figure. <br>
class MAT_BasicElt : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Constructor, <anInteger> is the <index> of <me>. <br>
Standard_EXPORT MAT_BasicElt(const Standard_Integer anInteger);

//! Return <startArcLeft> or <startArcRight> corresponding <br>
//!            to <aSide>. <br>
Standard_EXPORT   Handle_MAT_Arc StartArc() const;

//! Return <endArcLeft> or <endArcRight> corresponding <br>
//!            to <aSide>. <br>
Standard_EXPORT   Handle_MAT_Arc EndArc() const;

//! Return the <index> of <me> in Graph.TheBasicElts. <br>
Standard_EXPORT   Standard_Integer Index() const;

//! Return the <GeomIndex> of <me>. <br>
Standard_EXPORT   Standard_Integer GeomIndex() const;


Standard_EXPORT   void SetStartArc(const Handle(MAT_Arc)& anArc) ;


Standard_EXPORT   void SetEndArc(const Handle(MAT_Arc)& anArc) ;


Standard_EXPORT   void SetIndex(const Standard_Integer anInteger) ;


Standard_EXPORT   void SetGeomIndex(const Standard_Integer anInteger) ;
//Standard_EXPORT ~MAT_BasicElt();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Address startLeftArc;
Standard_Address endLeftArc;
Standard_Integer index;
Standard_Integer geomIndex;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
