// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MeshShape_SurfacePoint_HeaderFile
#define _MeshShape_SurfacePoint_HeaderFile

#ifndef _gp_XY_HeaderFile
#include <gp_XY.hxx>
#endif
#ifndef _gp_XYZ_HeaderFile
#include <gp_XYZ.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class gp_XY;
class gp_XYZ;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Describe a point on surface with his UV value and <br>
//!          the coresponding 3d point. <br>
class MeshShape_SurfacePoint  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT MeshShape_SurfacePoint();


Standard_EXPORT MeshShape_SurfacePoint(const Standard_Real u,const Standard_Real v,const Standard_Real x,const Standard_Real y,const Standard_Real z);


Standard_EXPORT MeshShape_SurfacePoint(const gp_XY& uv,const gp_XYZ& coord);


Standard_EXPORT MeshShape_SurfacePoint(const Standard_Real u,const Standard_Real v,const gp_XYZ& coord);

 const gp_XY& UV() const;

 const gp_XYZ& Coord() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
gp_XY myUV;
gp_XYZ myCoord;


};


#include <MeshShape_SurfacePoint.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
