// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _MeshVS_Tool_HeaderFile
#define _MeshVS_Tool_HeaderFile

#ifndef _Handle_Graphic3d_AspectFillArea3d_HeaderFile
#include <Handle_Graphic3d_AspectFillArea3d.hxx>
#endif
#ifndef _Handle_MeshVS_Drawer_HeaderFile
#include <Handle_MeshVS_Drawer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Graphic3d_AspectLine3d_HeaderFile
#include <Handle_Graphic3d_AspectLine3d.hxx>
#endif
#ifndef _Handle_Graphic3d_AspectMarker3d_HeaderFile
#include <Handle_Graphic3d_AspectMarker3d.hxx>
#endif
#ifndef _Handle_Graphic3d_AspectText3d_HeaderFile
#include <Handle_Graphic3d_AspectText3d.hxx>
#endif
class Graphic3d_AspectFillArea3d;
class MeshVS_Drawer;
class Graphic3d_MaterialAspect;
class Graphic3d_AspectLine3d;
class Graphic3d_AspectMarker3d;
class Graphic3d_AspectText3d;
class TColStd_Array1OfReal;
class gp_Vec;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! This class provides auxiliary methods to create differents aspects <br>
class MeshVS_Tool  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Creates fill area aspect with values from Drawer according to keys from DrawerAttribute <br>
Standard_EXPORT static  Handle_Graphic3d_AspectFillArea3d CreateAspectFillArea3d(const Handle(MeshVS_Drawer)& theDr,const Standard_Boolean UseDefaults = Standard_True) ;

//! Creates fill aspect with values from Drawer according to keys from DrawerAttribute <br>
//! and specific material aspect <br>
Standard_EXPORT static  Handle_Graphic3d_AspectFillArea3d CreateAspectFillArea3d(const Handle(MeshVS_Drawer)& theDr,const Graphic3d_MaterialAspect& Mat,const Standard_Boolean UseDefaults = Standard_True) ;

//! Creates line aspect with values from Drawer according to keys from DrawerAttribute <br>
Standard_EXPORT static  Handle_Graphic3d_AspectLine3d CreateAspectLine3d(const Handle(MeshVS_Drawer)& theDr,const Standard_Boolean UseDefaults = Standard_True) ;

//! Creates marker aspect with values from Drawer according to keys from DrawerAttribute <br>
Standard_EXPORT static  Handle_Graphic3d_AspectMarker3d CreateAspectMarker3d(const Handle(MeshVS_Drawer)& theDr,const Standard_Boolean UseDefaults = Standard_True) ;

//! Creates text aspect with values from Drawer according to keys from DrawerAttribute <br>
Standard_EXPORT static  Handle_Graphic3d_AspectText3d CreateAspectText3d(const Handle(MeshVS_Drawer)& theDr,const Standard_Boolean UseDefaults = Standard_True) ;

//! Get one of normals to polygon described by these points. <br>
//!          If the polygon isn't planar, function returns false <br>
Standard_EXPORT static  Standard_Boolean GetNormal(const TColStd_Array1OfReal& Nodes,gp_Vec& Norm) ;

//! Get an average of normals to non-planar polygon described by these points or compute <br>
//!          normal of planar polygon. If the polygon isn't planar, function returns false <br>
Standard_EXPORT static  Standard_Boolean GetAverageNormal(const TColStd_Array1OfReal& Nodes,gp_Vec& Norm) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
