// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _NLPlate_NLPlate_HeaderFile
#define _NLPlate_NLPlate_HeaderFile

#ifndef _Handle_Geom_Surface_HeaderFile
#include <Handle_Geom_Surface.hxx>
#endif
#ifndef _NLPlate_SequenceOfHGPPConstraint_HeaderFile
#include <NLPlate_SequenceOfHGPPConstraint.hxx>
#endif
#ifndef _NLPlate_StackOfPlate_HeaderFile
#include <NLPlate_StackOfPlate.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_NLPlate_HGPPConstraint_HeaderFile
#include <Handle_NLPlate_HGPPConstraint.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class Geom_Surface;
class NLPlate_HGPPConstraint;
class gp_XYZ;
class gp_XY;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class NLPlate_NLPlate  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT NLPlate_NLPlate(const Handle(Geom_Surface)& InitialSurface);


Standard_EXPORT   void Load(const Handle(NLPlate_HGPPConstraint)& GConst) ;


Standard_EXPORT   void Solve(const Standard_Integer ord = 2,const Standard_Integer InitialConsraintOrder = 1) ;


Standard_EXPORT   void Solve2(const Standard_Integer ord = 2,const Standard_Integer InitialConsraintOrder = 1) ;


Standard_EXPORT   void IncrementalSolve(const Standard_Integer ord = 2,const Standard_Integer InitialConsraintOrder = 1,const Standard_Integer NbIncrements = 4,const Standard_Boolean UVSliding = Standard_False) ;

//! returns True if all has been correctly done. <br>
Standard_EXPORT   Standard_Boolean IsDone() const;


Standard_EXPORT   void destroy() ;
~NLPlate_NLPlate()
{
  destroy();
}


//! reset the Plate in the initial state <br>
//!           ( same as after Create((Surface)) <br>
Standard_EXPORT   void Init() ;


Standard_EXPORT   gp_XYZ Evaluate(const gp_XY& point2d) const;


Standard_EXPORT   gp_XYZ EvaluateDerivative(const gp_XY& point2d,const Standard_Integer iu,const Standard_Integer iv) const;


Standard_EXPORT   Standard_Integer Continuity() const;


Standard_EXPORT   void ConstraintsSliding(const Standard_Integer NbIterations = 3) ;


Standard_EXPORT   Standard_Integer MaxActiveConstraintOrder() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   Standard_Boolean Iterate(const Standard_Integer ConstraintOrder,const Standard_Integer ResolutionOrder,const Standard_Real IncrementalLoading = 1.0) ;


 // Fields PRIVATE
 //
Handle_Geom_Surface myInitialSurface;
NLPlate_SequenceOfHGPPConstraint myHGPPConstraints;
NLPlate_StackOfPlate mySOP;
Standard_Boolean OK;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
