// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _NLPlate_StackOfPlate_HeaderFile
#define _NLPlate_StackOfPlate_HeaderFile

#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_NLPlate_StackNodeOfStackOfPlate_HeaderFile
#include <Handle_NLPlate_StackNodeOfStackOfPlate.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Standard_NoSuchObject;
class NLPlate_StackIteratorOfStackOfPlate;
class Plate_Plate;
class NLPlate_StackNodeOfStackOfPlate;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class NLPlate_StackOfPlate  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT NLPlate_StackOfPlate();


Standard_EXPORT  const NLPlate_StackOfPlate& Assign(const NLPlate_StackOfPlate& Other) ;
 const NLPlate_StackOfPlate& operator =(const NLPlate_StackOfPlate& Other) 
{
  return Assign(Other);
}


  Standard_Boolean IsEmpty() const;

  Standard_Integer Depth() const;


Standard_EXPORT  const Plate_Plate& Top() const;


Standard_EXPORT   void Push(const Plate_Plate& I) ;


Standard_EXPORT   void Pop() ;


Standard_EXPORT   void Clear() ;
~NLPlate_StackOfPlate()
{
  Clear();
}



Standard_EXPORT   Plate_Plate& ChangeTop() ;


friend class NLPlate_StackIteratorOfStackOfPlate;



protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT NLPlate_StackOfPlate(const NLPlate_StackOfPlate& Other);


 // Fields PRIVATE
 //
Standard_Address myTop;
Standard_Integer myDepth;


};

#define Item Plate_Plate
#define Item_hxx <Plate_Plate.hxx>
#define TCollection_StackNode NLPlate_StackNodeOfStackOfPlate
#define TCollection_StackNode_hxx <NLPlate_StackNodeOfStackOfPlate.hxx>
#define TCollection_StackIterator NLPlate_StackIteratorOfStackOfPlate
#define TCollection_StackIterator_hxx <NLPlate_StackIteratorOfStackOfPlate.hxx>
#define Handle_TCollection_StackNode Handle_NLPlate_StackNodeOfStackOfPlate
#define TCollection_StackNode_Type_() NLPlate_StackNodeOfStackOfPlate_Type_()
#define TCollection_Stack NLPlate_StackOfPlate
#define TCollection_Stack_hxx <NLPlate_StackOfPlate.hxx>

#include <TCollection_Stack.lxx>

#undef Item
#undef Item_hxx
#undef TCollection_StackNode
#undef TCollection_StackNode_hxx
#undef TCollection_StackIterator
#undef TCollection_StackIterator_hxx
#undef Handle_TCollection_StackNode
#undef TCollection_StackNode_Type_
#undef TCollection_Stack
#undef TCollection_Stack_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
