// File generated by CPPExt (Persistent CSFDB)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.
#ifndef _PGeom_BezierSurface_HeaderFile
#define _PGeom_BezierSurface_HeaderFile

#ifndef _Handle_PGeom_BezierSurface_HeaderFile
#include <Handle_PGeom_BezierSurface.hxx>
#endif
#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif

#ifndef _Handle_PColgp_HArray2OfPnt_HeaderFile
#include <Handle_PColgp_HArray2OfPnt.hxx>
#endif
#ifndef _Handle_PColStd_HArray2OfReal_HeaderFile
#include <Handle_PColStd_HArray2OfReal.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _PGeom_BoundedSurface_HeaderFile
#include <PGeom_BoundedSurface.hxx>
#endif
class PColgp_HArray2OfPnt;
class PColStd_HArray2OfReal;


class PGeom_BezierSurface : public PGeom_BoundedSurface {

public:

 // Methods PUBLIC
 // 

//! Creates a BezierSurface with default values. <br>
Standard_EXPORT PGeom_BezierSurface();

//! Creates a BezierSurface with these values. <br>
Standard_EXPORT PGeom_BezierSurface(const Standard_Boolean aURational,const Standard_Boolean aVRational,const Handle(PColgp_HArray2OfPnt)& aPoles,const Handle(PColStd_HArray2OfReal)& aWeights);

//! Set the field poles with <aPoles>. <br>
Standard_EXPORT   void Poles(const Handle(PColgp_HArray2OfPnt)& aPoles) ;

//! Returns the value of the field poles. <br>
Standard_EXPORT   Handle_PColgp_HArray2OfPnt Poles() const;

//! Set the value of the field weights with <aWeights>. <br>
Standard_EXPORT   void Weights(const Handle(PColStd_HArray2OfReal)& aWeights) ;

//! Returns the value of the field weights. <br>
Standard_EXPORT   Handle_PColStd_HArray2OfReal Weights() const;

//! Set the value of the field uRational with <aURational>. <br>
Standard_EXPORT   void URational(const Standard_Boolean aURational) ;

//! Returns the value of the field uRational. <br>
Standard_EXPORT   Standard_Boolean URational() const;

//! Set the value of the field vRational with <aVRational>. <br>
Standard_EXPORT   void VRational(const Standard_Boolean aVRational) ;

//! Returns the value of the field vRational. <br>
Standard_EXPORT   Standard_Boolean VRational() const;
//Standard_EXPORT ~PGeom_BezierSurface();
PGeom_BezierSurface(const Storage_stCONSTclCOM& a) : PGeom_BoundedSurface(a)
{
  
}

    Standard_Boolean _CSFDB_GetPGeom_BezierSurfaceuRational() const { return uRational; }
    void _CSFDB_SetPGeom_BezierSurfaceuRational(const Standard_Boolean p) { uRational = p; }
    Standard_Boolean _CSFDB_GetPGeom_BezierSurfacevRational() const { return vRational; }
    void _CSFDB_SetPGeom_BezierSurfacevRational(const Standard_Boolean p) { vRational = p; }
    Handle(PColgp_HArray2OfPnt) _CSFDB_GetPGeom_BezierSurfacepoles() const { return poles; }
    void _CSFDB_SetPGeom_BezierSurfacepoles(const Handle(PColgp_HArray2OfPnt)& p) { poles = p; }
    Handle(PColStd_HArray2OfReal) _CSFDB_GetPGeom_BezierSurfaceweights() const { return weights; }
    void _CSFDB_SetPGeom_BezierSurfaceweights(const Handle(PColStd_HArray2OfReal)& p) { weights = p; }



 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
// Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

 // Fields PRIVATE
 //
Standard_Boolean uRational;
Standard_Boolean vRational;
Handle_PColgp_HArray2OfPnt poles;
Handle_PColStd_HArray2OfReal weights;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
