// File generated by CPPExt (Persistent CSFDB)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.
#ifndef _PTopoDS_TShape_HeaderFile
#define _PTopoDS_TShape_HeaderFile

#ifndef _Handle_PTopoDS_TShape_HeaderFile
#include <Handle_PTopoDS_TShape.hxx>
#endif
#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif

#ifndef _TopAbs_ShapeEnum_HeaderFile
#include <TopAbs_ShapeEnum.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_PTopoDS_HArray1OfHShape_HeaderFile
#include <Handle_PTopoDS_HArray1OfHShape.hxx>
#endif
#ifndef _Handle_PTopoDS_HShape_HeaderFile
#include <Handle_PTopoDS_HShape.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Persistent_HeaderFile
#include <Standard_Persistent.hxx>
#endif
class PTopoDS_HArray1OfHShape;
class PTopoDS_HShape;


class PTopoDS_TShape : public Standard_Persistent {

public:

 // Methods PUBLIC
 // 

//! Returns the type as a term of the ShapeEnum enum : <br>
//!          VERTEX, EDGE, WIRE, FACE, .... <br>
Standard_EXPORT virtual  TopAbs_ShapeEnum ShapeType() const = 0;

//! Returns the modification flag. <br>
Standard_EXPORT   Standard_Boolean Modified() const;

//! Sets the modification flag. <br>
Standard_EXPORT   void Modified(const Standard_Boolean M) ;

//! Returns the checked flag. <br>
Standard_EXPORT   Standard_Boolean Checked() const;

//! Sets the checked flag. <br>
Standard_EXPORT   void Checked(const Standard_Boolean C) ;

//! Returns the orientability flag. <br>
Standard_EXPORT   Standard_Boolean Orientable() const;

//! Sets the orientability flag. <br>
Standard_EXPORT   void Orientable(const Standard_Boolean C) ;

//! Returns the closedness flag. <br>
Standard_EXPORT   Standard_Boolean Closed() const;

//! Sets the closedness flag. <br>
Standard_EXPORT   void Closed(const Standard_Boolean C) ;

//! Returns the infinity flag. <br>
Standard_EXPORT   Standard_Boolean Infinite() const;

//! Sets the infinity flag. <br>
Standard_EXPORT   void Infinite(const Standard_Boolean C) ;

//! Returns the convexness flag. <br>
Standard_EXPORT   Standard_Boolean Convex() const;

//! Sets the convexness flag. <br>
Standard_EXPORT   void Convex(const Standard_Boolean C) ;

//! Sets the hshape list <br>
Standard_EXPORT   Handle_PTopoDS_HArray1OfHShape Shapes() const;

//! Sets the i th element of the HShape list <br>
Standard_EXPORT   Handle_PTopoDS_HShape Shapes(const Standard_Integer I) const;

//! Returns the HShape list <br>
Standard_EXPORT   void Shapes(const Handle(PTopoDS_HArray1OfHShape)& S) ;

//! Returns the i th element of the hshape list <br>
Standard_EXPORT   void Shapes(const Standard_Integer I,const Handle(PTopoDS_HShape)& S) ;
//Standard_EXPORT ~PTopoDS_TShape();
PTopoDS_TShape(const Storage_stCONSTclCOM& a) : Standard_Persistent(a)
{
  
}

    Handle(PTopoDS_HArray1OfHShape) _CSFDB_GetPTopoDS_TShapemyShapes() const { return myShapes; }
    void _CSFDB_SetPTopoDS_TShapemyShapes(const Handle(PTopoDS_HArray1OfHShape)& p) { myShapes = p; }
    Standard_Integer _CSFDB_GetPTopoDS_TShapemyFlags() const { return myFlags; }
    void _CSFDB_SetPTopoDS_TShapemyFlags(const Standard_Integer p) { myFlags = p; }



 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
// Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


Standard_EXPORT PTopoDS_TShape();

 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

 // Fields PRIVATE
 //
Handle_PTopoDS_HArray1OfHShape myShapes;
Standard_Integer myFlags;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
