// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Prs3d_IsoAspect_HeaderFile
#define _Prs3d_IsoAspect_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Prs3d_IsoAspect_HeaderFile
#include <Handle_Prs3d_IsoAspect.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Prs3d_LineAspect_HeaderFile
#include <Prs3d_LineAspect.hxx>
#endif
#ifndef _Quantity_NameOfColor_HeaderFile
#include <Quantity_NameOfColor.hxx>
#endif
#ifndef _Aspect_TypeOfLine_HeaderFile
#include <Aspect_TypeOfLine.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class Quantity_Color;


//! A framework to define the display attributes of isoparameters. <br>
//! This framework can be used to modify the default <br>
//! setting for isoparameters in AIS_Drawer. <br>
class Prs3d_IsoAspect : public Prs3d_LineAspect {

public:
 // Methods PUBLIC
 // 

//! Constructs a framework to define display attributes of isoparameters. <br>
//! These include: <br>
//! -   the color attribute aColor <br>
//! -   the type of line aType <br>
//! -   the width value aWidth <br>
//! -   aNumber, the number of isoparameters to be   displayed. <br>
Standard_EXPORT Prs3d_IsoAspect(const Quantity_NameOfColor aColor,const Aspect_TypeOfLine aType,const Standard_Real aWidth,const Standard_Integer aNumber);


Standard_EXPORT Prs3d_IsoAspect(const Quantity_Color& aColor,const Aspect_TypeOfLine aType,const Standard_Real aWidth,const Standard_Integer aNumber);

//! defines the number of U or V isoparametric curves <br>
//!         to be drawn for a single face. <br>
//!          Default value: 10 <br>
Standard_EXPORT   void SetNumber(const Standard_Integer aNumber) ;

//! returns the number of U or V isoparametric curves drawn for a single face. <br>
Standard_EXPORT   Standard_Integer Number() const;


Standard_EXPORT virtual  void Print(Standard_OStream& s) const;
//Standard_EXPORT ~Prs3d_IsoAspect();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer myNumber;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
