// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Prs3d_PointAspect_HeaderFile
#define _Prs3d_PointAspect_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Prs3d_PointAspect_HeaderFile
#include <Handle_Prs3d_PointAspect.hxx>
#endif

#ifndef _Handle_Graphic3d_AspectMarker3d_HeaderFile
#include <Handle_Graphic3d_AspectMarker3d.hxx>
#endif
#ifndef _Prs3d_BasicAspect_HeaderFile
#include <Prs3d_BasicAspect.hxx>
#endif
#ifndef _Aspect_TypeOfMarker_HeaderFile
#include <Aspect_TypeOfMarker.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Quantity_NameOfColor_HeaderFile
#include <Quantity_NameOfColor.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Graphic3d_HArray1OfBytes_HeaderFile
#include <Handle_Graphic3d_HArray1OfBytes.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class Graphic3d_AspectMarker3d;
class Quantity_Color;
class Graphic3d_HArray1OfBytes;


//! This  class  defines  attributes for the points <br>
//!  The points are drawn using markers, whose size does not depend on <br>
//!  the zoom value of the views. <br>
class Prs3d_PointAspect : public Prs3d_BasicAspect {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT Prs3d_PointAspect(const Aspect_TypeOfMarker aType,const Quantity_Color& aColor,const Standard_Real aScale);


Standard_EXPORT Prs3d_PointAspect(const Aspect_TypeOfMarker aType,const Quantity_NameOfColor aColor,const Standard_Real aScale);

//! defines only the urer defined marker point. <br>
Standard_EXPORT Prs3d_PointAspect(const Quantity_Color& AColor,const Standard_Real AnId,const Standard_Integer AWidth,const Standard_Integer AHeight,const Handle(Graphic3d_HArray1OfBytes)& ATexture);


Standard_EXPORT   void SetColor(const Quantity_Color& aColor) ;

//! defines the color to be used when drawing a point. <br>
//!          Default value: Quantity_NOC_YELLOW <br>
Standard_EXPORT   void SetColor(const Quantity_NameOfColor aColor) ;

//! defines the type of representation to be used when drawing a point. <br>
//!          Default value: Aspect_TOM_PLUS <br>
Standard_EXPORT   void SetTypeOfMarker(const Aspect_TypeOfMarker aType) ;

//! defines the size of the marker used when drawing a point. <br>
//!          Default value: 1. <br>
Standard_EXPORT   void SetScale(const Standard_Real aScale) ;


Standard_EXPORT   Handle_Graphic3d_AspectMarker3d Aspect() const;


Standard_EXPORT   void Print(Standard_OStream& s) const;

//! Returns marker's texture size. <br>
Standard_EXPORT   void GetTextureSize(Standard_Integer& AWidth,Standard_Integer& AHeight) ;

//! Returns marker's texture. <br>
Standard_EXPORT  const Handle_Graphic3d_HArray1OfBytes& GetTexture() ;
//Standard_EXPORT ~Prs3d_PointAspect();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_Graphic3d_AspectMarker3d myAspect;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
