// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Prs3d_Projector_HeaderFile
#define _Prs3d_Projector_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Prs3d_Projector_HeaderFile
#include <Handle_Prs3d_Projector.hxx>
#endif

#ifndef _HLRAlgo_Projector_HeaderFile
#include <HLRAlgo_Projector.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Quantity_Length_HeaderFile
#include <Quantity_Length.hxx>
#endif
class HLRAlgo_Projector;


//! A projector object. <br>
//! This object defines the parameters of a view for a <br>
//! visualization algorithm. It is, for example, used by the <br>
//! hidden line removal algorithms. <br>
class Prs3d_Projector : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT Prs3d_Projector(const HLRAlgo_Projector& Pr);

//! Constructs a projector framework from the following parameters <br>
//! -   Pers is true if the view is a perspective view and <br>
//!   false if it is an axonometric one; <br>
//! -   Focus is the focal length if a perspective view is defined; <br>
//! -   DX, DY and DZ are the coordinates of the <br>
//!   projection vector; <br>
//! -   XAt, YAt and ZAt are the coordinates of the view point; <br>
//! -   XUp, YUp and ZUp are the coordinates of the <br>
//!   vertical direction vector. <br>
Standard_EXPORT Prs3d_Projector(const Standard_Boolean Pers,const Quantity_Length Focus,const Quantity_Length DX,const Quantity_Length DY,const Quantity_Length DZ,const Quantity_Length XAt,const Quantity_Length YAt,const Quantity_Length ZAt,const Quantity_Length XUp,const Quantity_Length YUp,const Quantity_Length ZUp);

//! Returns a projector object for use in a hidden line removal algorithm. <br>
Standard_EXPORT   HLRAlgo_Projector Projector() const;
//Standard_EXPORT ~Prs3d_Projector();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
HLRAlgo_Projector MyProjector;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
