// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _STEPControl_ActorWrite_HeaderFile
#define _STEPControl_ActorWrite_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_STEPControl_ActorWrite_HeaderFile
#include <Handle_STEPControl_ActorWrite.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _STEPConstruct_ContextTool_HeaderFile
#include <STEPConstruct_ContextTool.hxx>
#endif
#ifndef _Transfer_ActorOfFinderProcess_HeaderFile
#include <Transfer_ActorOfFinderProcess.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Transfer_Finder_HeaderFile
#include <Handle_Transfer_Finder.hxx>
#endif
#ifndef _Handle_Transfer_Binder_HeaderFile
#include <Handle_Transfer_Binder.hxx>
#endif
#ifndef _Handle_Transfer_FinderProcess_HeaderFile
#include <Handle_Transfer_FinderProcess.hxx>
#endif
#ifndef _Handle_StepShape_ShapeDefinitionRepresentation_HeaderFile
#include <Handle_StepShape_ShapeDefinitionRepresentation.hxx>
#endif
#ifndef _Handle_StepGeom_Axis2Placement3d_HeaderFile
#include <Handle_StepGeom_Axis2Placement3d.hxx>
#endif
#ifndef _STEPControl_StepModelType_HeaderFile
#include <STEPControl_StepModelType.hxx>
#endif
class Transfer_Finder;
class Transfer_Binder;
class Transfer_FinderProcess;
class StepShape_ShapeDefinitionRepresentation;
class StepGeom_Axis2Placement3d;
class TopoDS_Shape;


//! This class performs the transfer of a Shape from TopoDS <br>
//!           to AP203 or AP214 (CD2 or DIS) <br>
class STEPControl_ActorWrite : public Transfer_ActorOfFinderProcess {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT STEPControl_ActorWrite();


Standard_EXPORT virtual  Standard_Boolean Recognize(const Handle(Transfer_Finder)& start) ;


Standard_EXPORT virtual  Handle_Transfer_Binder Transfer(const Handle(Transfer_Finder)& start,const Handle(Transfer_FinderProcess)& FP) ;


Standard_EXPORT   Handle_Transfer_Binder TransferSubShape(const Handle(Transfer_Finder)& start,const Handle(StepShape_ShapeDefinitionRepresentation)& SDR,Handle(StepGeom_Axis2Placement3d)& AX1,const Handle(Transfer_FinderProcess)& FP) ;


Standard_EXPORT   Handle_Transfer_Binder TransferShape(const Handle(Transfer_Finder)& start,const Handle(StepShape_ShapeDefinitionRepresentation)& SDR,const Handle(Transfer_FinderProcess)& FP) ;


Standard_EXPORT   Handle_Transfer_Binder TransferCompound(const Handle(Transfer_Finder)& start,const Handle(StepShape_ShapeDefinitionRepresentation)& SDR,const Handle(Transfer_FinderProcess)& FP) ;


Standard_EXPORT   void SetMode(const STEPControl_StepModelType M) ;


Standard_EXPORT   STEPControl_StepModelType Mode() const;


Standard_EXPORT   void SetGroupMode(const Standard_Integer mode) ;


Standard_EXPORT   Standard_Integer GroupMode() const;


Standard_EXPORT   void SetTolerance(const Standard_Real Tol) ;

//! Customizable method to check whether shape S should <br>
//!          be written as assembly or not <br>
//!          Default implementation uses flag GroupMode and analyses <br>
//!          the shape itself <br>
//!          NOTE: this method can modify shape <br>
Standard_EXPORT virtual  Standard_Boolean IsAssembly(TopoDS_Shape& S) const;
//Standard_EXPORT ~STEPControl_ActorWrite();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Integer mygroup;
Standard_Real mytoler;
STEPConstruct_ContextTool myContext;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
