// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _SelectBasics_EntityOwner_HeaderFile
#define _SelectBasics_EntityOwner_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_SelectBasics_EntityOwner_HeaderFile
#include <Handle_SelectBasics_EntityOwner.hxx>
#endif

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class TopLoc_Location;


//! defines an abstract owner of sensitive primitives. <br>
//!           Owners are typically used to establish a connection <br>
//!           between sensitive entities and high-level objects (e.g. presentations). <br>
class SelectBasics_EntityOwner : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 
//! sets the selectable priority of the owner <br>
  void Set(const Standard_Integer aPriority) ;

  Standard_Integer Priority() const;


Standard_EXPORT virtual  Standard_Boolean HasLocation() const = 0;


Standard_EXPORT virtual  void SetLocation(const TopLoc_Location& aLoc)  = 0;


Standard_EXPORT virtual  void ResetLocation()  = 0;


Standard_EXPORT virtual const TopLoc_Location& Location() const = 0;
//Standard_EXPORT ~SelectBasics_EntityOwner();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


Standard_EXPORT SelectBasics_EntityOwner(const Standard_Integer aPriority = 0);


 // Fields PROTECTED
 //
Standard_Integer mypriority;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};


#include <SelectBasics_EntityOwner.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
