// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _ShapeBuild_Vertex_HeaderFile
#define _ShapeBuild_Vertex_HeaderFile

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class TopoDS_Vertex;
class gp_Pnt;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Provides low-level functions used for constructing vertices <br>
class ShapeBuild_Vertex  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Combines new vertex from two others. This new one is the <br>
//!          smallest vertex which comprises both of the source vertices. <br>
//!          The function takes into account the positions and tolerances <br>
//!          of the source vertices. <br>
//!          The tolerance of the new vertex will be equal to the minimal <br>
//!          tolerance that is required to comprise source vertices <br>
//!          multiplied by tolFactor (in order to avoid errors because <br>
//!          of discreteness of calculations). <br>
Standard_EXPORT   TopoDS_Vertex CombineVertex(const TopoDS_Vertex& V1,const TopoDS_Vertex& V2,const Standard_Real tolFactor = 1.0001) const;

//! The same function as above, except that it accepts two points <br>
//!          and two tolerances instead of vertices <br>
Standard_EXPORT   TopoDS_Vertex CombineVertex(const gp_Pnt& pnt1,const gp_Pnt& pnt2,const Standard_Real tol1,const Standard_Real tol2,const Standard_Real tolFactor = 1.0001) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
