// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _ShapeFix_ShapeTolerance_HeaderFile
#define _ShapeFix_ShapeTolerance_HeaderFile

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _TopAbs_ShapeEnum_HeaderFile
#include <TopAbs_ShapeEnum.hxx>
#endif
class TopoDS_Shape;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Modifies tolerances of sub-shapes (vertices, edges, faces) <br>
class ShapeFix_ShapeTolerance  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT ShapeFix_ShapeTolerance();

//! Limits tolerances in a shape as follows : <br>
//!          tmin = tmax -> as SetTolerance (forces) <br>
//!          tmin = 0   -> maximum tolerance will be <tmax> <br>
//!          tmax = 0 or not given (more generally, tmax < tmin) -> <br>
//!             <tmax> ignored, minimum will be <tmin> <br>
//!          else, maximum will be <max> and minimum will be <min> <br>
//!          styp = VERTEX : only vertices are set <br>
//!          styp = EDGE   : only edges are set <br>
//!          styp = FACE   : only faces are set <br>
//!          styp = WIRE   : to have edges and their vertices set <br>
//!          styp = other value : all (vertices,edges,faces) are set <br>
//!          Returns True if at least one tolerance of the sub-shape has <br>
//!          been modified <br>
Standard_EXPORT   Standard_Boolean LimitTolerance(const TopoDS_Shape& shape,const Standard_Real tmin,const Standard_Real tmax = 0.0,const TopAbs_ShapeEnum styp = TopAbs_SHAPE) const;

//! Sets (enforces) tolerances in a shape to the given value <br>
//!          styp = VERTEX : only vertices are set <br>
//!          styp = EDGE   : only edges are set <br>
//!          styp = FACE   : only faces are set <br>
//!          styp = WIRE   : to have edges and their vertices set <br>
//!          styp = other value : all (vertices,edges,faces) are set <br>
Standard_EXPORT   void SetTolerance(const TopoDS_Shape& shape,const Standard_Real preci,const TopAbs_ShapeEnum styp = TopAbs_SHAPE) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
