// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _ShapeUpgrade_SplitCurve3d_HeaderFile
#define _ShapeUpgrade_SplitCurve3d_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_ShapeUpgrade_SplitCurve3d_HeaderFile
#include <Handle_ShapeUpgrade_SplitCurve3d.hxx>
#endif

#ifndef _Handle_Geom_Curve_HeaderFile
#include <Handle_Geom_Curve.hxx>
#endif
#ifndef _Handle_TColGeom_HArray1OfCurve_HeaderFile
#include <Handle_TColGeom_HArray1OfCurve.hxx>
#endif
#ifndef _ShapeUpgrade_SplitCurve_HeaderFile
#include <ShapeUpgrade_SplitCurve.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Geom_Curve;
class TColGeom_HArray1OfCurve;


//! Splits a 3d curve with a criterion. <br>
class ShapeUpgrade_SplitCurve3d : public ShapeUpgrade_SplitCurve {

public:
 // Methods PUBLIC
 // 

//! Empty constructor. <br>
Standard_EXPORT ShapeUpgrade_SplitCurve3d();

//! Initializes with curve with its first and last parameters. <br>
Standard_EXPORT   void Init(const Handle(Geom_Curve)& C) ;

//! Initializes with curve with its parameters. <br>
Standard_EXPORT   void Init(const Handle(Geom_Curve)& C,const Standard_Real First,const Standard_Real Last) ;

//! If Segment is True, the result is composed with <br>
//!  segments of the curve bounded by the SplitValues.  If <br>
//!  Segment is False, the result is composed with trimmed <br>
//!  Curves all based on the same complete curve. <br>
//! <br>
Standard_EXPORT virtual  void Build(const Standard_Boolean Segment) ;


Standard_EXPORT  const Handle_TColGeom_HArray1OfCurve& GetCurves() const;
//Standard_EXPORT ~ShapeUpgrade_SplitCurve3d();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //
Handle_Geom_Curve myCurve;
Handle_TColGeom_HArray1OfCurve myResultingCurves;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
