// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StdSelect_TextProjector2d_HeaderFile
#define _StdSelect_TextProjector2d_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_StdSelect_TextProjector2d_HeaderFile
#include <Handle_StdSelect_TextProjector2d.hxx>
#endif

#ifndef _Handle_V2d_View_HeaderFile
#include <Handle_V2d_View.hxx>
#endif
#ifndef _Select2D_Projector_HeaderFile
#include <Select2D_Projector.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class V2d_View;
class gp_Trsf2d;
class gp_Pnt2d;
class TCollection_ExtendedString;


//! A projector framework specific to texts in 2D views. <br>
//! For a string of text, an insertion point and a font, it <br>
//! calculates the minimum and maximum points of the text box in the view. <br>
class StdSelect_TextProjector2d : public Select2D_Projector {

public:
 // Methods PUBLIC
 // 

//! Constructs a 2D text projector framework defined by the 2D view aView. <br>
Standard_EXPORT StdSelect_TextProjector2d(const Handle(V2d_View)& aView);
//! Sets the view aView. <br>
  void Set(const Handle(V2d_View)& aView) ;
//! Sets the transformation atrsf. <br>
//! This transformation is applied to the attachment point <br>
//! of the text, and takes the size and length of the text <br>
//! into account to give the upper right hand point of the text box. <br>
  void Set(const gp_Trsf2d& atrsf) ;

//! applies the stored trsf to aPointIn to get aPointOut <br>
Standard_EXPORT virtual  void Convert(const gp_Pnt2d& aPointIn,gp_Pnt2d& aPointOut) const;

//!XPos,YPos is the AttachPoint for the text.First, the stored Trsf is <br>
//!         applied to this point, then we get the size and length of text to <br>
//!         give the upper point <br>
Standard_EXPORT virtual  void Convert(const TCollection_ExtendedString& aText,const Standard_Real XPos,const Standard_Real YPos,gp_Pnt2d& MinPoint,gp_Pnt2d& MaxPoint,const Standard_Integer afont = -1) const;
//Standard_EXPORT ~StdSelect_TextProjector2d();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_V2d_View myview;


};


#include <StdSelect_TextProjector2d.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
