// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StepAP214_DateItem_HeaderFile
#define _StepAP214_DateItem_HeaderFile

#ifndef _StepAP214_ApprovalItem_HeaderFile
#include <StepAP214_ApprovalItem.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_StepBasic_ApprovalPersonOrganization_HeaderFile
#include <Handle_StepBasic_ApprovalPersonOrganization.hxx>
#endif
#ifndef _Handle_StepAP214_AppliedPersonAndOrganizationAssignment_HeaderFile
#include <Handle_StepAP214_AppliedPersonAndOrganizationAssignment.hxx>
#endif
#ifndef _Handle_StepAP214_AppliedOrganizationAssignment_HeaderFile
#include <Handle_StepAP214_AppliedOrganizationAssignment.hxx>
#endif
#ifndef _Handle_StepBasic_Effectivity_HeaderFile
#include <Handle_StepBasic_Effectivity.hxx>
#endif
class Standard_Transient;
class StepBasic_ApprovalPersonOrganization;
class StepAP214_AppliedPersonAndOrganizationAssignment;
class StepAP214_AppliedOrganizationAssignment;
class StepBasic_Effectivity;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class StepAP214_DateItem  : public StepAP214_ApprovalItem {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Returns a DateItem SelectType <br>
Standard_EXPORT StepAP214_DateItem();

//! Recognizes a DateItem Kind Entity that is : <br>
//!        1 -> ApprovalPersonOrganization <br>
//!        2 -> AppliedDateAndPersonAssignment <br>
//!        3 -> AppliedOrganizationAssignment <br>
//!        4 -> AssemblyComponentUsageSubstitute <br>
//!        5 -> DocumentFile <br>
//!        6 -> Effectivity <br>
//!        7 -> MaterialDesignation <br>
//!        8 -> MechanicalDesignGeometricPresentationRepresentation <br>
//!        9 -> PresentationArea <br>
//!        10 -> Product <br>
//!        11 -> ProductDefinition <br>
//!        12 -> ProductDefinitionFormation <br>
//!        13 -> ProductDefinitionRelationship <br>
//!    	  14 -> PropertyDefinition <br>
//!        15 -> ShapeRepresentation <br>
//!        0 else <br>
Standard_EXPORT virtual  Standard_Integer CaseNum(const Handle(Standard_Transient)& ent) const;

//! returns Value as a ApprovalPersonOrganization (Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_ApprovalPersonOrganization ApprovalPersonOrganization() const;

//! returns Value as a AppliedDateAndPersonAssignment (Null if another type) <br>
Standard_EXPORT   Handle_StepAP214_AppliedPersonAndOrganizationAssignment AppliedPersonAndOrganizationAssignment() const;

//! returns Value as a AppliedOrganizationAssignment (Null if another type) <br>
Standard_EXPORT   Handle_StepAP214_AppliedOrganizationAssignment AppliedOrganizationAssignment() const;

//! returns Value as a Effectivity (Null if another type) <br>
Standard_EXPORT   Handle_StepBasic_Effectivity Effectivity() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
