// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _StepElement_MeasureOrUnspecifiedValue_HeaderFile
#define _StepElement_MeasureOrUnspecifiedValue_HeaderFile

#ifndef _StepData_SelectType_HeaderFile
#include <StepData_SelectType.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_StepData_SelectMember_HeaderFile
#include <Handle_StepData_SelectMember.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _StepElement_UnspecifiedValue_HeaderFile
#include <StepElement_UnspecifiedValue.hxx>
#endif
class Standard_Transient;
class StepData_SelectMember;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Representation of STEP SELECT type MeasureOrUnspecifiedValue <br>
class StepElement_MeasureOrUnspecifiedValue  : public StepData_SelectType {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 

//! Empty constructor <br>
Standard_EXPORT StepElement_MeasureOrUnspecifiedValue();

//! Recognizes a kind of MeasureOrUnspecifiedValue select type <br>
//!          return 0 <br>
Standard_EXPORT   Standard_Integer CaseNum(const Handle(Standard_Transient)& ent) const;

//! Recognizes a items of select member MeasureOrUnspecifiedValueMember <br>
//!          1 -> ContextDependentMeasure <br>
//!          2 -> UnspecifiedValue <br>
//!          0 else <br>
Standard_EXPORT virtual  Standard_Integer CaseMem(const Handle(StepData_SelectMember)& ent) const;

//! Returns a new select member the type MeasureOrUnspecifiedValueMember <br>
Standard_EXPORT virtual  Handle_StepData_SelectMember NewMember() const;

//! Set Value for ContextDependentMeasure <br>
Standard_EXPORT   void SetContextDependentMeasure(const Standard_Real aVal) ;

//! Returns Value as ContextDependentMeasure (or Null if another type) <br>
Standard_EXPORT   Standard_Real ContextDependentMeasure() const;

//! Set Value for UnspecifiedValue <br>
Standard_EXPORT   void SetUnspecifiedValue(const StepElement_UnspecifiedValue aVal) ;

//! Returns Value as UnspecifiedValue (or Null if another type) <br>
Standard_EXPORT   StepElement_UnspecifiedValue UnspecifiedValue() const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
