// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TDataStd_BooleanArray_HeaderFile
#define _TDataStd_BooleanArray_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_TDataStd_BooleanArray_HeaderFile
#include <Handle_TDataStd_BooleanArray.hxx>
#endif

#ifndef _Handle_TDataStd_HArray1OfByte_HeaderFile
#include <Handle_TDataStd_HArray1OfByte.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _TDF_Attribute_HeaderFile
#include <TDF_Attribute.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_TDF_Attribute_HeaderFile
#include <Handle_TDF_Attribute.hxx>
#endif
#ifndef _Handle_TDF_RelocationTable_HeaderFile
#include <Handle_TDF_RelocationTable.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class TDataStd_HArray1OfByte;
class Standard_GUID;
class TDF_Label;
class TDF_Attribute;
class TDF_RelocationTable;


//! An array of boolean values. <br>
class TDataStd_BooleanArray : public TDF_Attribute {

public:
 // Methods PUBLIC
 // 

//! Static methods <br>
//!          ============== <br>//! Returns an ID for array. <br>
Standard_EXPORT static const Standard_GUID& GetID() ;

//! Finds or creates an attribute with the array. <br>
Standard_EXPORT static  Handle_TDataStd_BooleanArray Set(const TDF_Label& label,const Standard_Integer lower,const Standard_Integer upper) ;

//! Initialize the inner array with bounds from <lower> to <upper> <br>
Standard_EXPORT   void Init(const Standard_Integer lower,const Standard_Integer upper) ;

//! Sets the <Index>th element of the array to <Value> <br>
Standard_EXPORT   void SetValue(const Standard_Integer index,const Standard_Boolean value) ;

//! Return the value of the <Index>th element of the array. <br>
Standard_EXPORT   Standard_Boolean Value(const Standard_Integer Index) const;
  Standard_Boolean operator ()(const Standard_Integer Index) const
{
  return Value(Index);
}


//! Returns the lower boundary of the array. <br>
Standard_EXPORT   Standard_Integer Lower() const;

//! Returns the upper boundary of the array. <br>
Standard_EXPORT   Standard_Integer Upper() const;

//! Returns the number of elements in the array. <br>
Standard_EXPORT   Standard_Integer Length() const;


Standard_EXPORT  const Handle_TDataStd_HArray1OfByte& InternalArray() const;


Standard_EXPORT   void SetInternalArray(const Handle(TDataStd_HArray1OfByte)& values) ;


Standard_EXPORT TDataStd_BooleanArray();


Standard_EXPORT  const Standard_GUID& ID() const;


Standard_EXPORT   void Restore(const Handle(TDF_Attribute)& with) ;


Standard_EXPORT   Handle_TDF_Attribute NewEmpty() const;


Standard_EXPORT   void Paste(const Handle(TDF_Attribute)& into,const Handle(TDF_RelocationTable)& RT) const;


Standard_EXPORT virtual  Standard_OStream& Dump(Standard_OStream& OS) const;
//Standard_EXPORT ~TDataStd_BooleanArray();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_TDataStd_HArray1OfByte myValues;
Standard_Integer myLower;
Standard_Integer myUpper;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
