// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TDataStd_RealList_HeaderFile
#define _TDataStd_RealList_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_TDataStd_RealList_HeaderFile
#include <Handle_TDataStd_RealList.hxx>
#endif

#ifndef _TColStd_ListOfReal_HeaderFile
#include <TColStd_ListOfReal.hxx>
#endif
#ifndef _TDF_Attribute_HeaderFile
#include <TDF_Attribute.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Handle_TDF_Attribute_HeaderFile
#include <Handle_TDF_Attribute.hxx>
#endif
#ifndef _Handle_TDF_RelocationTable_HeaderFile
#include <Handle_TDF_RelocationTable.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class Standard_GUID;
class TDF_Label;
class TColStd_ListOfReal;
class TDF_Attribute;
class TDF_RelocationTable;


//! Contains a list of doubles. <br>
class TDataStd_RealList : public TDF_Attribute {

public:
 // Methods PUBLIC
 // 

//! Static methods <br>
//!          ============== <br>//! Returns the ID of the list of doubles attribute. <br>
Standard_EXPORT static const Standard_GUID& GetID() ;

//! Finds or creates a list of double values attribute. <br>
Standard_EXPORT static  Handle_TDataStd_RealList Set(const TDF_Label& label) ;


Standard_EXPORT TDataStd_RealList();


Standard_EXPORT   Standard_Boolean IsEmpty() const;


Standard_EXPORT   Standard_Integer Extent() const;


Standard_EXPORT   void Prepend(const Standard_Real value) ;


Standard_EXPORT   void Append(const Standard_Real value) ;

//! Inserts the <value> before the first meet of <before_value>. <br>
Standard_EXPORT   Standard_Boolean InsertBefore(const Standard_Real value,const Standard_Real before_value) ;

//! Inserts the <value> after the first meet of <after_value>. <br>
Standard_EXPORT   Standard_Boolean InsertAfter(const Standard_Real value,const Standard_Real after_value) ;

//! Removes the first meet of the <value>. <br>
Standard_EXPORT   Standard_Boolean Remove(const Standard_Real value) ;


Standard_EXPORT   void Clear() ;


Standard_EXPORT   Standard_Real First() const;


Standard_EXPORT   Standard_Real Last() const;


Standard_EXPORT  const TColStd_ListOfReal& List() const;


Standard_EXPORT  const Standard_GUID& ID() const;


Standard_EXPORT   void Restore(const Handle(TDF_Attribute)& With) ;


Standard_EXPORT   Handle_TDF_Attribute NewEmpty() const;


Standard_EXPORT   void Paste(const Handle(TDF_Attribute)& Into,const Handle(TDF_RelocationTable)& RT) const;


Standard_EXPORT virtual  Standard_OStream& Dump(Standard_OStream& anOS) const;
//Standard_EXPORT ~TDataStd_RealList();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TColStd_ListOfReal myList;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
