// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TDataStd_Shape_HeaderFile
#define _TDataStd_Shape_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_TDataStd_Shape_HeaderFile
#include <Handle_TDataStd_Shape.hxx>
#endif

#ifndef _TDF_Attribute_HeaderFile
#include <TDF_Attribute.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_TDF_Attribute_HeaderFile
#include <Handle_TDF_Attribute.hxx>
#endif
#ifndef _Handle_TDF_RelocationTable_HeaderFile
#include <Handle_TDF_RelocationTable.hxx>
#endif
#ifndef _Handle_TDF_DataSet_HeaderFile
#include <Handle_TDF_DataSet.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class TDF_Label;
class TopoDS_Shape;
class Standard_GUID;
class TDF_Attribute;
class TDF_RelocationTable;
class TDF_DataSet;


//! A Shape is associated in the framework with : <br>
//!          a NamedShape attribute <br>
class TDataStd_Shape : public TDF_Attribute {

public:
 // Methods PUBLIC
 // 

//! class methods <br>
//!          ============= <br>//! try to retrieve a Shape attribute at <current> label <br>
//!           or in  fathers  label of  <current>. Returns True  if <br>
//!          found and set <S>. <br>
Standard_EXPORT static  Standard_Boolean Find(const TDF_Label& current,Handle(TDataStd_Shape)& S) ;

//! Find, or create, a Shape attribute.  the Shape attribute <br>
//!          is returned. Raises if <label> has attribute. <br>
Standard_EXPORT static  Handle_TDataStd_Shape New(const TDF_Label& label) ;

//! Create or update associated NamedShape attribute.  the <br>
//!          Shape attribute is returned. <br>
Standard_EXPORT static  Handle_TDataStd_Shape Set(const TDF_Label& label,const TopoDS_Shape& shape) ;

//!   the Shape from  associated NamedShape attribute <br>
//!            is returned. <br>
Standard_EXPORT static  TopoDS_Shape Get(const TDF_Label& label) ;

//! Shape methods <br>
//!          ============ <br>
Standard_EXPORT static const Standard_GUID& GetID() ;


Standard_EXPORT TDataStd_Shape();


Standard_EXPORT  const Standard_GUID& ID() const;


Standard_EXPORT   void Restore(const Handle(TDF_Attribute)& with) ;


Standard_EXPORT   Handle_TDF_Attribute NewEmpty() const;


Standard_EXPORT   void Paste(const Handle(TDF_Attribute)& into,const Handle(TDF_RelocationTable)& RT) const;


Standard_EXPORT virtual  void References(const Handle(TDF_DataSet)& DS) const;


Standard_EXPORT virtual  Standard_OStream& Dump(Standard_OStream& anOS) const;
//Standard_EXPORT ~TDataStd_Shape();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
