// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TNaming_OldShapeIterator_HeaderFile
#define _TNaming_OldShapeIterator_HeaderFile

#ifndef _TNaming_PtrNode_HeaderFile
#include <TNaming_PtrNode.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_TNaming_UsedShapes_HeaderFile
#include <Handle_TNaming_UsedShapes.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_TNaming_NamedShape_HeaderFile
#include <Handle_TNaming_NamedShape.hxx>
#endif
class Standard_NoMoreObject;
class Standard_NoSuchObject;
class TNaming_Tool;
class TNaming_Localizer;
class TNaming_Naming;
class TopoDS_Shape;
class TNaming_UsedShapes;
class TDF_Label;
class TNaming_Iterator;
class TNaming_NamedShape;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Iterates on all the ascendants of a shape <br>
class TNaming_OldShapeIterator  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT TNaming_OldShapeIterator(const TopoDS_Shape& aShape,const Standard_Integer Transaction,const TDF_Label& access);


Standard_EXPORT TNaming_OldShapeIterator(const TopoDS_Shape& aShape,const TDF_Label& access);

//! Iterates from the current Shape in <anIterator> <br>
Standard_EXPORT TNaming_OldShapeIterator(const TNaming_OldShapeIterator& anIterator);

//! Iterates from the current Shape in <anIterator> <br>
Standard_EXPORT TNaming_OldShapeIterator(const TNaming_Iterator& anIterator);

  Standard_Boolean More() const;


Standard_EXPORT   void Next() ;


Standard_EXPORT   TDF_Label Label() const;


Standard_EXPORT   Handle_TNaming_NamedShape NamedShape() const;


Standard_EXPORT  const TopoDS_Shape& Shape() const;

//! True if the  new  shape is a modification  (split, <br>
//!          fuse,etc...) of the old shape. <br>
Standard_EXPORT   Standard_Boolean IsModification() const;


friend class TNaming_Tool;
friend class TNaming_Localizer;
friend class TNaming_Naming;



protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT TNaming_OldShapeIterator(const TopoDS_Shape& aShape,const Standard_Integer Transaction,const Handle(TNaming_UsedShapes)& Shapes);


Standard_EXPORT TNaming_OldShapeIterator(const TopoDS_Shape& aShape,const Handle(TNaming_UsedShapes)& Shapes);


 // Fields PRIVATE
 //
TNaming_PtrNode myNode;
Standard_Integer myTrans;


};


#include <TNaming_OldShapeIterator.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
