// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TopExp_StackOfIterator_HeaderFile
#define _TopExp_StackOfIterator_HeaderFile

#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_TopExp_StackNodeOfStackOfIterator_HeaderFile
#include <Handle_TopExp_StackNodeOfStackOfIterator.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Standard_NoSuchObject;
class TopExp_StackIteratorOfStackOfIterator;
class TopoDS_Iterator;
class TopExp_StackNodeOfStackOfIterator;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class TopExp_StackOfIterator  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT TopExp_StackOfIterator();


Standard_EXPORT  const TopExp_StackOfIterator& Assign(const TopExp_StackOfIterator& Other) ;
 const TopExp_StackOfIterator& operator =(const TopExp_StackOfIterator& Other) 
{
  return Assign(Other);
}


  Standard_Boolean IsEmpty() const;

  Standard_Integer Depth() const;


Standard_EXPORT  const TopoDS_Iterator& Top() const;


Standard_EXPORT   void Push(const TopoDS_Iterator& I) ;


Standard_EXPORT   void Pop() ;


Standard_EXPORT   void Clear() ;
~TopExp_StackOfIterator()
{
  Clear();
}



Standard_EXPORT   TopoDS_Iterator& ChangeTop() ;


friend class TopExp_StackIteratorOfStackOfIterator;



protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT TopExp_StackOfIterator(const TopExp_StackOfIterator& Other);


 // Fields PRIVATE
 //
Standard_Address myTop;
Standard_Integer myDepth;


};

#define Item TopoDS_Iterator
#define Item_hxx <TopoDS_Iterator.hxx>
#define TCollection_StackNode TopExp_StackNodeOfStackOfIterator
#define TCollection_StackNode_hxx <TopExp_StackNodeOfStackOfIterator.hxx>
#define TCollection_StackIterator TopExp_StackIteratorOfStackOfIterator
#define TCollection_StackIterator_hxx <TopExp_StackIteratorOfStackOfIterator.hxx>
#define Handle_TCollection_StackNode Handle_TopExp_StackNodeOfStackOfIterator
#define TCollection_StackNode_Type_() TopExp_StackNodeOfStackOfIterator_Type_()
#define TCollection_Stack TopExp_StackOfIterator
#define TCollection_Stack_hxx <TopExp_StackOfIterator.hxx>

#include <TCollection_Stack.lxx>

#undef Item
#undef Item_hxx
#undef TCollection_StackNode
#undef TCollection_StackNode_hxx
#undef TCollection_StackIterator
#undef TCollection_StackIterator_hxx
#undef Handle_TCollection_StackNode
#undef TCollection_StackNode_Type_
#undef TCollection_Stack
#undef TCollection_Stack_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
