// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TopOpeBRepBuild_CorrectFace2d_HeaderFile
#define _TopOpeBRepBuild_CorrectFace2d_HeaderFile

#ifndef _TopoDS_Face_HeaderFile
#include <TopoDS_Face.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _TopoDS_Wire_HeaderFile
#include <TopoDS_Wire.hxx>
#endif
#ifndef _TopTools_ListOfShape_HeaderFile
#include <TopTools_ListOfShape.hxx>
#endif
#ifndef _TopTools_IndexedMapOfOrientedShape_HeaderFile
#include <TopTools_IndexedMapOfOrientedShape.hxx>
#endif
#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _TopTools_IndexedDataMapOfShapeShape_HeaderFile
#include <TopTools_IndexedDataMapOfShapeShape.hxx>
#endif
#ifndef _Handle_Geom2d_Curve_HeaderFile
#include <Handle_Geom2d_Curve.hxx>
#endif
class TopoDS_Face;
class TopTools_IndexedMapOfOrientedShape;
class TopTools_IndexedDataMapOfShapeShape;
class TopoDS_Edge;
class gp_Pnt2d;
class TopoDS_Shape;
class TopTools_ListOfShape;
class gp_Vec2d;
class Geom2d_Curve;
class TopoDS_Wire;
class Bnd_Box2d;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class TopOpeBRepBuild_CorrectFace2d  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT TopOpeBRepBuild_CorrectFace2d();


Standard_EXPORT TopOpeBRepBuild_CorrectFace2d(const TopoDS_Face& aFace,const TopTools_IndexedMapOfOrientedShape& anAvoidMap,TopTools_IndexedDataMapOfShapeShape& aMap);


Standard_EXPORT  const TopoDS_Face& Face() const;


Standard_EXPORT   void Perform() ;


Standard_EXPORT   Standard_Boolean IsDone() const;


Standard_EXPORT   Standard_Integer ErrorStatus() const;


Standard_EXPORT  const TopoDS_Face& CorrectedFace() const;


Standard_EXPORT   void SetMapOfTrans2dInfo(TopTools_IndexedDataMapOfShapeShape& aMap) ;


Standard_EXPORT   TopTools_IndexedDataMapOfShapeShape& MapOfTrans2dInfo() ;


Standard_EXPORT static  void GetP2dFL(const TopoDS_Face& aFace,const TopoDS_Edge& anEdge,gp_Pnt2d& P2dF,gp_Pnt2d& P2dL) ;


Standard_EXPORT static  void CheckList(const TopoDS_Face& aFace,TopTools_ListOfShape& aHeadList) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   void CheckFace() ;


Standard_EXPORT   Standard_Integer MakeRightWire() ;


Standard_EXPORT   void MakeHeadList(const TopoDS_Shape& aFirstEdge,TopTools_ListOfShape& aHeadList) const;


Standard_EXPORT   void TranslateCurve2d(const TopoDS_Edge& anEdge,const TopoDS_Face& aFace,const gp_Vec2d& aTranslateVec,Handle(Geom2d_Curve)& aCurve2d) ;


Standard_EXPORT   Standard_Integer OuterWire(TopoDS_Wire& anOuterWire) const;


Standard_EXPORT   void BndBoxWire(const TopoDS_Wire& aWire,Bnd_Box2d& aB2d) const;


Standard_EXPORT   void MoveWire2d(TopoDS_Wire& aWire,const gp_Vec2d& aTrV) ;


Standard_EXPORT   void MoveWires2d(TopoDS_Wire& aWire) ;


Standard_EXPORT   void UpdateEdge(const TopoDS_Edge& E,const Handle(Geom2d_Curve)& C,const TopoDS_Face& F,const Standard_Real Tol) ;


Standard_EXPORT   void UpdateEdge(const TopoDS_Edge& E,const Handle(Geom2d_Curve)& C1,const Handle(Geom2d_Curve)& C2,const TopoDS_Face& F,const Standard_Real Tol) ;


Standard_EXPORT   void BuildCopyData(const TopoDS_Face& F,const TopTools_IndexedMapOfOrientedShape& anAvoidMap,TopoDS_Face& aCopyFace,TopTools_IndexedMapOfOrientedShape& aCopyAvoidMap,const Standard_Boolean aNeedToUsePMap) ;


Standard_EXPORT   Standard_Integer ConnectWire(TopoDS_Face& aCopyFace,const TopTools_IndexedMapOfOrientedShape& aCopyAvoidMap,const Standard_Boolean aTryToConnectFlag) ;


 // Fields PRIVATE
 //
TopoDS_Face myFace;
TopoDS_Face myCorrectedFace;
Standard_Boolean myIsDone;
Standard_Integer myErrorStatus;
Standard_Real myFaceTolerance;
TopoDS_Wire myCurrentWire;
TopTools_ListOfShape myOrderedWireList;
TopTools_IndexedMapOfOrientedShape myAvoidMap;
Standard_Address myMap;
TopoDS_Face myCopyFace;
TopTools_IndexedMapOfOrientedShape myCopyAvoidMap;
TopTools_IndexedDataMapOfShapeShape myEdMapInversed;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
