// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TopOpeBRepDS_EdgeVertexInterference_HeaderFile
#define _TopOpeBRepDS_EdgeVertexInterference_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_TopOpeBRepDS_EdgeVertexInterference_HeaderFile
#include <Handle_TopOpeBRepDS_EdgeVertexInterference.hxx>
#endif

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _TopOpeBRepDS_ShapeShapeInterference_HeaderFile
#include <TopOpeBRepDS_ShapeShapeInterference.hxx>
#endif
#ifndef _TopOpeBRepDS_Kind_HeaderFile
#include <TopOpeBRepDS_Kind.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _TopOpeBRepDS_Config_HeaderFile
#include <TopOpeBRepDS_Config.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class TopOpeBRepDS_Transition;


//! An interference with a parameter. <br>
class TopOpeBRepDS_EdgeVertexInterference : public TopOpeBRepDS_ShapeShapeInterference {

public:
 // Methods PUBLIC
 // 

//! Create an interference of VERTEX <G> on a crossed EDGE E. <br>
//! <br>
//!  if support type <ST> == EDGE : <S> is edge E <br>
//!                          FACE : <S> is the face with bound E. <br>
//!  <T> is the transition along the edge, crossing the crossed edge. <br>
//!   E  is the crossed edge. <br>
//!  <GIsBound> indicates if <G> is a bound of the edge. <br>
//!  <P> is the parameter of <G> on the edge. <br>
//! <br>
//!  interference is stored in the list of interfs of the edge. <br>
//! <br>
Standard_EXPORT TopOpeBRepDS_EdgeVertexInterference(const TopOpeBRepDS_Transition& T,const TopOpeBRepDS_Kind ST,const Standard_Integer S,const Standard_Integer G,const Standard_Boolean GIsBound,const TopOpeBRepDS_Config C,const Standard_Real P);

//! Create an interference of VERTEX <G> on crossed EDGE <S>. <br>
//! <br>
//!  <T> is the transition along the edge, crossing the crossed edge. <br>
//!  <S> is the crossed edge. <br>
//!  <GIsBound> indicates if <G> is a bound of the edge. <br>
//!  <C> indicates the geometric configuration between <br>
//!        the edge and the crossed edge. <br>
//!  <P> is the parameter of <G> on the edge. <br>
//! <br>
//!  interference is stored in the list of interfs of the edge. <br>
//! <br>
Standard_EXPORT TopOpeBRepDS_EdgeVertexInterference(const TopOpeBRepDS_Transition& T,const Standard_Integer S,const Standard_Integer G,const Standard_Boolean GIsBound,const TopOpeBRepDS_Config C,const Standard_Real P);


Standard_EXPORT   Standard_Real Parameter() const;


Standard_EXPORT   void Parameter(const Standard_Real P) ;


Standard_EXPORT virtual  Standard_OStream& Dump(Standard_OStream& OS) const;
//Standard_EXPORT ~TopOpeBRepDS_EdgeVertexInterference();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real myParam;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
