// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TopOpeBRepDS_Point_HeaderFile
#define _TopOpeBRepDS_Point_HeaderFile

#ifndef _gp_Pnt_HeaderFile
#include <gp_Pnt.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class gp_Pnt;
class TopoDS_Shape;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! A Geom point and a tolerance. <br>
class TopOpeBRepDS_Point  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT TopOpeBRepDS_Point();


Standard_EXPORT TopOpeBRepDS_Point(const gp_Pnt& P,const Standard_Real T);


Standard_EXPORT TopOpeBRepDS_Point(const TopoDS_Shape& S);


Standard_EXPORT   Standard_Boolean IsEqual(const TopOpeBRepDS_Point& other) const;


Standard_EXPORT  const gp_Pnt& Point() const;


Standard_EXPORT   gp_Pnt& ChangePoint() ;


Standard_EXPORT   Standard_Real Tolerance() const;


Standard_EXPORT   void Tolerance(const Standard_Real Tol) ;


Standard_EXPORT   Standard_Boolean Keep() const;


Standard_EXPORT   void ChangeKeep(const Standard_Boolean B) ;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
gp_Pnt myPoint;
Standard_Real myTolerance;
Standard_Boolean myKeep;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
