// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TopOpeBRep_ShapeScanner_HeaderFile
#define _TopOpeBRep_ShapeScanner_HeaderFile

#ifndef _TopOpeBRepTool_BoxSort_HeaderFile
#include <TopOpeBRepTool_BoxSort.hxx>
#endif
#ifndef _TColStd_ListIteratorOfListOfInteger_HeaderFile
#include <TColStd_ListIteratorOfListOfInteger.hxx>
#endif
#ifndef _TopAbs_ShapeEnum_HeaderFile
#include <TopAbs_ShapeEnum.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class TopoDS_Shape;
class TopOpeBRepTool_ShapeExplorer;
class TopOpeBRepTool_BoxSort;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! Find, among the  subshapes SS of a reference shape <br>
//!          RS, the ones which 3D box interfers with the box of <br>
//!          a shape S (SS and S are of the same type). <br>
class TopOpeBRep_ShapeScanner  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT TopOpeBRep_ShapeScanner();


Standard_EXPORT   void Clear() ;


Standard_EXPORT   void AddBoxesMakeCOB(const TopoDS_Shape& S,const TopAbs_ShapeEnum TS,const TopAbs_ShapeEnum TA = TopAbs_SHAPE) ;


Standard_EXPORT   void Init(const TopoDS_Shape& E) ;


Standard_EXPORT   void Init(TopOpeBRepTool_ShapeExplorer& X) ;


Standard_EXPORT   Standard_Boolean More() const;


Standard_EXPORT   void Next() ;


Standard_EXPORT  const TopoDS_Shape& Current() const;


Standard_EXPORT  const TopOpeBRepTool_BoxSort& BoxSort() const;


Standard_EXPORT   TopOpeBRepTool_BoxSort& ChangeBoxSort() ;


Standard_EXPORT   Standard_Integer Index() const;


Standard_EXPORT   Standard_OStream& DumpCurrent(Standard_OStream& OS) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TopOpeBRepTool_BoxSort myBoxSort;
TColStd_ListIteratorOfListOfInteger myListIterator;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
