// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TopTools_Array2OfShape_HeaderFile
#define _TopTools_Array2OfShape_HeaderFile

#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
class Standard_RangeError;
class Standard_OutOfRange;
class Standard_OutOfMemory;
class Standard_DimensionMismatch;
class TopoDS_Shape;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class TopTools_Array2OfShape  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT TopTools_Array2OfShape(const Standard_Integer R1,const Standard_Integer R2,const Standard_Integer C1,const Standard_Integer C2);


Standard_EXPORT TopTools_Array2OfShape(const TopoDS_Shape& Item,const Standard_Integer R1,const Standard_Integer R2,const Standard_Integer C1,const Standard_Integer C2);


Standard_EXPORT   void Init(const TopoDS_Shape& V) ;


Standard_EXPORT   void Destroy() ;
~TopTools_Array2OfShape()
{
  Destroy();
}



Standard_EXPORT  const TopTools_Array2OfShape& Assign(const TopTools_Array2OfShape& Other) ;
 const TopTools_Array2OfShape& operator =(const TopTools_Array2OfShape& Other) 
{
  return Assign(Other);
}


  Standard_Integer ColLength() const;

  Standard_Integer RowLength() const;

  Standard_Integer LowerCol() const;

  Standard_Integer LowerRow() const;

  Standard_Integer UpperCol() const;

  Standard_Integer UpperRow() const;

  void SetValue(const Standard_Integer Row,const Standard_Integer Col,const TopoDS_Shape& Value) ;

 const TopoDS_Shape& Value(const Standard_Integer Row,const Standard_Integer Col) const;
 const TopoDS_Shape& operator()(const Standard_Integer Row,const Standard_Integer Col) const
{
  return Value(Row,Col);
}


  TopoDS_Shape& ChangeValue(const Standard_Integer Row,const Standard_Integer Col) ;
  TopoDS_Shape& operator()(const Standard_Integer Row,const Standard_Integer Col) 
{
  return ChangeValue(Row,Col);
}






protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT TopTools_Array2OfShape(const TopTools_Array2OfShape& AnArray);


Standard_EXPORT   void Allocate() ;


 // Fields PRIVATE
 //
Standard_Integer myLowerRow;
Standard_Integer myLowerColumn;
Standard_Integer myUpperRow;
Standard_Integer myUpperColumn;
Standard_Boolean myDeletable;
Standard_Address myData;


};

#define Array2Item TopoDS_Shape
#define Array2Item_hxx <TopoDS_Shape.hxx>
#define TCollection_Array2 TopTools_Array2OfShape
#define TCollection_Array2_hxx <TopTools_Array2OfShape.hxx>

#include <TCollection_Array2.lxx>

#undef Array2Item
#undef Array2Item_hxx
#undef TCollection_Array2
#undef TCollection_Array2_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
