// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _TopoDS_HShape_HeaderFile
#define _TopoDS_HShape_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_TopoDS_HShape_HeaderFile
#include <Handle_TopoDS_HShape.hxx>
#endif

#ifndef _TopoDS_Shape_HeaderFile
#include <TopoDS_Shape.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
class TopoDS_Shape;


//!Class to manipulate a Shape with  handle. <br>
class TopoDS_HShape : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Constructs an empty shape object <br>
Standard_EXPORT TopoDS_HShape();

//! Constructs a shape object defined by the shape aShape. <br>
Standard_EXPORT TopoDS_HShape(const TopoDS_Shape& aShape);

//! Loads this shape with the shape aShape <br>
Standard_EXPORT   void Shape(const TopoDS_Shape& aShape) ;
//! Returns a reference to a constant TopoDS_Shape based on this shape. <br>
 const TopoDS_Shape& Shape() const;

//! Exchanges the TopoDS_Shape object defining this <br>
//! shape for another one referencing the same underlying shape <br>
//! Accesses the list of shapes within the underlying <br>
//! shape referenced by the TopoDS_Shape object. <br>
//! Returns a reference to a TopoDS_Shape based on <br>
//! this shape. The TopoDS_Shape can be modified. <br>
  TopoDS_Shape& ChangeShape() ;
//Standard_EXPORT ~TopoDS_HShape();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
TopoDS_Shape myShape;


};


#include <TopoDS_HShape.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
