// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Units_UnitsLexicon_HeaderFile
#define _Units_UnitsLexicon_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Units_UnitsLexicon_HeaderFile
#include <Handle_Units_UnitsLexicon.hxx>
#endif

#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Units_Lexicon_HeaderFile
#include <Units_Lexicon.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class TCollection_HAsciiString;
class TCollection_AsciiString;


//! This class defines a lexicon useful to analyse and <br>
//!          recognize the different key  words  included  in a <br>
//!          sentence. The  lexicon is stored  in a sequence of <br>
//!          tokens. <br>
class Units_UnitsLexicon : public Units_Lexicon {

public:
 // Methods PUBLIC
 // 

//! Returns an empty instance of UnitsLexicon <br>
Standard_EXPORT Units_UnitsLexicon();

//! Reads  the files  <afilename1>  and  <afilename2>   to <br>
//!          create     a   sequence     of    tokens   stored   in <br>
//!          <thesequenceoftokens>. <br>
Standard_EXPORT   void Creates(const Standard_CString afilename1,const Standard_CString afilename2,const Standard_Boolean amode = Standard_True) ;

//! Returns in a AsciiString from TCollection the name of the file. <br>
Standard_EXPORT   TCollection_AsciiString FileName2() const;

//! Returns true if  the  file has not  changed  since the <br>
//!          creation   of   the  Lexicon   object.   Returns false <br>
//!          otherwise. <br>
Standard_EXPORT virtual  Standard_Boolean UpToDate() const;
//! Useful for debugging. <br>
virtual  void Dump() const;
//Standard_EXPORT ~Units_UnitsLexicon();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_TCollection_HAsciiString thefilename;
Standard_Integer thetime;


};


#include <Units_UnitsLexicon.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
