// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _V2d_BackgroundGraphicObject_HeaderFile
#define _V2d_BackgroundGraphicObject_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_V2d_BackgroundGraphicObject_HeaderFile
#include <Handle_V2d_BackgroundGraphicObject.hxx>
#endif

#ifndef _Graphic2d_GraphicObject_HeaderFile
#include <Graphic2d_GraphicObject.hxx>
#endif
#ifndef _Handle_Graphic2d_View_HeaderFile
#include <Handle_Graphic2d_View.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class Graphic2d_View;


//! Creates a 2D background graphic object in a view. <br>
//!	    A graphic object is a primitives manager <br>
//!	    which drawn before all the others graphic objects <br>
class V2d_BackgroundGraphicObject : public Graphic2d_GraphicObject {

public:
 // Methods PUBLIC
 // 

//! Creates a graphic object in the view <aView>. <br>
//!          A graphic object manages a sequence of primitives. <br>
Standard_EXPORT V2d_BackgroundGraphicObject(const Handle(Graphic2d_View)& aView);

//! Returns the max usable relative priority of the <br>
//!         "hiding" graphic object. <br>
Standard_EXPORT virtual  Standard_Integer MaxPriority() const;
//Standard_EXPORT ~V2d_BackgroundGraphicObject();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

//! Returns the min usable absolute priority of the <br>
//!         "hiding" graphic object. <br>
Standard_EXPORT virtual  Standard_Integer BasePriority() const;


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
