// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _V2d_CircularGraphicGrid_HeaderFile
#define _V2d_CircularGraphicGrid_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_V2d_CircularGraphicGrid_HeaderFile
#include <Handle_V2d_CircularGraphicGrid.hxx>
#endif

#ifndef _Standard_ShortReal_HeaderFile
#include <Standard_ShortReal.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Aspect_GridDrawMode_HeaderFile
#include <Aspect_GridDrawMode.hxx>
#endif
#ifndef _Graphic2d_Primitive_HeaderFile
#include <Graphic2d_Primitive.hxx>
#endif
#ifndef _Handle_Graphic2d_GraphicObject_HeaderFile
#include <Handle_Graphic2d_GraphicObject.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Handle_Graphic2d_Drawer_HeaderFile
#include <Handle_Graphic2d_Drawer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Aspect_FStream_HeaderFile
#include <Aspect_FStream.hxx>
#endif
class Graphic2d_GraphicObject;
class Graphic2d_Drawer;



class V2d_CircularGraphicGrid : public Graphic2d_Primitive {

public:
 // Methods PUBLIC
 // 


Standard_EXPORT V2d_CircularGraphicGrid(const Handle(Graphic2d_GraphicObject)& aGraphicObject,const Standard_Real X,const Standard_Real Y,const Standard_Real alpha,const Standard_Real step,const Standard_Integer aDivision,const Standard_Integer PointsColorIndex);


Standard_EXPORT   void SetDrawMode(const Aspect_GridDrawMode aDrawMode) ;


Standard_EXPORT virtual  void Save(Aspect_FStream& aFStream) const;
//Standard_EXPORT ~V2d_CircularGraphicGrid();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

//! Draws the grid <br>
Standard_EXPORT   void Draw(const Handle(Graphic2d_Drawer)& aDrawer) ;

//! Returns Standard_True if the infinite line <me> is picked, <br>
//!	    Standard_False if not. <br>
Standard_EXPORT   Standard_Boolean Pick(const Standard_ShortReal X,const Standard_ShortReal Y,const Standard_ShortReal aPrecision,const Handle(Graphic2d_Drawer)& aDrawer) ;


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT   void DrawCircle(const Handle(Graphic2d_Drawer)& aDrawer,const Standard_ShortReal xc,const Standard_ShortReal yc,const Standard_ShortReal r,const Standard_Boolean DrawPoints) const;


 // Fields PRIVATE
 //
Standard_ShortReal OX;
Standard_ShortReal OY;
Standard_ShortReal angle;
Standard_ShortReal Step;
Standard_Integer Division;
Aspect_GridDrawMode DrawMode;
Standard_Integer myPointsColorIndex;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
