// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _V3d_OrthographicView_HeaderFile
#define _V3d_OrthographicView_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_V3d_OrthographicView_HeaderFile
#include <Handle_V3d_OrthographicView.hxx>
#endif

#ifndef _V3d_View_HeaderFile
#include <V3d_View.hxx>
#endif
#ifndef _Handle_V3d_Viewer_HeaderFile
#include <Handle_V3d_Viewer.hxx>
#endif
#ifndef _Handle_V3d_PerspectiveView_HeaderFile
#include <Handle_V3d_PerspectiveView.hxx>
#endif
class V3d_Viewer;
class V3d_PerspectiveView;


//! Define an orthographic view. <br>
//!          See the methods of the Class View <br>
class V3d_OrthographicView : public V3d_View {

public:
 // Methods PUBLIC
 // 

//! Define an orthographic view in the viewer VM. <br>
Standard_EXPORT V3d_OrthographicView(const Handle(V3d_Viewer)& VM);

//! Defines an orthographic view from a Perspective view. <br>
//!	    The parameters of the original view are duplicated <br>
//!	    in the resulting view (Projection,Mapping,Context) . <br>
//!	    The view thus created must be activated in a new <br>
//!	    window. <br>
Standard_EXPORT V3d_OrthographicView(const Handle(V3d_Viewer)& VM,const Handle(V3d_PerspectiveView)& V);

//! Defines one orthographic view from another. <br>
//!	    The parameters of the original view are duplicated <br>
//!	    in the resulting view. (Projection,Mapping,Context) . <br>
//!	    The view thus created must be activated in a new window. <br>
Standard_EXPORT V3d_OrthographicView(const Handle(V3d_Viewer)& VM,const Handle(V3d_OrthographicView)& V);


Standard_EXPORT   Handle_V3d_OrthographicView Copy() const;
//Standard_EXPORT ~V3d_OrthographicView();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
