// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Viewer_View_HeaderFile
#define _Viewer_View_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Viewer_View_HeaderFile
#include <Handle_Viewer_View.hxx>
#endif

#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Quantity_Factor_HeaderFile
#include <Quantity_Factor.hxx>
#endif
class Viewer_BadValue;


//! This class defines a view. <br>
class Viewer_View : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Clears the window and redraws all primitives. <br>
Standard_EXPORT virtual  void Update() const = 0;

//! sets the immediate update mode and returns the previous one. <br>
Standard_EXPORT   Standard_Boolean SetImmediateUpdate(const Standard_Boolean onoff) ;

//! Centres the defined pixel window defined by the <br>
//! minimum and maximum pixels Xmin, Ymin, Xmax, <br>
//! Ymax so that it occupies the largest possible space <br>
//! while maintaining the initial height/width ratio. <br>
//! Exceptions <br>
//! Viewer_BadValue if the size of the defined <br>
//! projection window is equal to 0. <br>
Standard_EXPORT virtual  void WindowFit(const Standard_Integer Xmin,const Standard_Integer Ymin,const Standard_Integer Xmax,const Standard_Integer Ymax)  = 0;

//! Sets the center of the object space defined by x, y <br>
//! and the zoom factor aZoomFactor. The view is updated. <br>
Standard_EXPORT virtual  void Place(const Standard_Integer x,const Standard_Integer y,const Quantity_Factor aZoomFactor = 1)  = 0;
//Standard_EXPORT ~Viewer_View();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


Standard_EXPORT Viewer_View();


Standard_EXPORT   void ImmediateUpdate() const;


 // Fields PROTECTED
 //
Standard_Boolean myImmediateUpdate;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
