// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Visual3d_ClipPlane_HeaderFile
#define _Visual3d_ClipPlane_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_Visual3d_ClipPlane_HeaderFile
#include <Handle_Visual3d_ClipPlane.hxx>
#endif

#ifndef _Graphic3d_CPlane_HeaderFile
#include <Graphic3d_CPlane.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class Visual3d_View;


//! This class allows the definition and update <br>
//!	    of clipping planes in the space model. <br>
class Visual3d_ClipPlane : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Creates a clipping plane from the equation : <br>
//!	    <ACoefA>*X + <ACoefB>*Y + <ACoefC>*Z + <ACoefD> = 0.0 <br>
Standard_EXPORT Visual3d_ClipPlane(const Standard_Real ACoefA,const Standard_Real ACoefB,const Standard_Real ACoefC,const Standard_Real ACoefD);

//! Modifies the plane equation. <br>
Standard_EXPORT   void SetPlane(const Standard_Real ACoefA,const Standard_Real ACoefB,const Standard_Real ACoefC,const Standard_Real ACoefD) ;

//! Maximum number of activatable clipping planes. <br>
Standard_EXPORT static  Standard_Integer Limit() ;

//! Returns the values of the clipping plane <me>. <br>
Standard_EXPORT   void Plane(Standard_Real& ACoefA,Standard_Real& ACoefB,Standard_Real& ACoefC,Standard_Real& ACoefD) const;
//Standard_EXPORT ~Visual3d_ClipPlane();


friend class Visual3d_View;


 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 

//! Returns the plane identification. <br>
Standard_EXPORT   Standard_Integer Identification() const;


 // Fields PRIVATE
 //
Graphic3d_CPlane MyCPlane;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
