// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Vrml_Cylinder_HeaderFile
#define _Vrml_Cylinder_HeaderFile

#ifndef _Vrml_CylinderParts_HeaderFile
#include <Vrml_CylinderParts.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! defines a Cylinder node of VRML specifying geometry shapes. <br>
//! This  node  represents  a  simple  capped  cylinder  centred  around the  y-axis. <br>
//! By  default ,  the  cylinder  is  centred  at  (0,0,0) <br>
//! and  has  size  of  -1  to  +1  in  the  all  three  dimensions. <br>
//! The  cylinder  has  three  parts: <br>
//! the  sides,  the  top  (y=+1)  and  the  bottom (y=-1) <br>
class Vrml_Cylinder  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT Vrml_Cylinder(const Vrml_CylinderParts aParts = Vrml_CylinderALL,const Standard_Real aRadius = 1,const Standard_Real aHeight = 2);


Standard_EXPORT   void SetParts(const Vrml_CylinderParts aParts) ;


Standard_EXPORT   Vrml_CylinderParts Parts() const;


Standard_EXPORT   void SetRadius(const Standard_Real aRadius) ;


Standard_EXPORT   Standard_Real Radius() const;


Standard_EXPORT   void SetHeight(const Standard_Real aHeight) ;


Standard_EXPORT   Standard_Real Height() const;


Standard_EXPORT   Standard_OStream& Print(Standard_OStream& anOStream) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Vrml_CylinderParts myParts;
Standard_Real myRadius;
Standard_Real myHeight;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
