// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _Vrml_FontStyle_HeaderFile
#define _Vrml_FontStyle_HeaderFile

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Vrml_FontStyleFamily_HeaderFile
#include <Vrml_FontStyleFamily.hxx>
#endif
#ifndef _Vrml_FontStyleStyle_HeaderFile
#include <Vrml_FontStyleStyle.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

//! defines a FontStyle node of VRML of properties of geometry <br>
//!  and its appearance. <br>
//!  The  size  field  specifies  the  height  (in  object  space  units) <br>
//!  of  glyphs  rendered  and  determines  the  vertical  spacing  of <br>
//!  adjacent  lines  of  text. <br>
class Vrml_FontStyle  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT Vrml_FontStyle(const Standard_Real aSize = 10,const Vrml_FontStyleFamily aFamily = Vrml_SERIF,const Vrml_FontStyleStyle aStyle = Vrml_NONE);


Standard_EXPORT   void SetSize(const Standard_Real aSize) ;


Standard_EXPORT   Standard_Real Size() const;


Standard_EXPORT   void SetFamily(const Vrml_FontStyleFamily aFamily) ;


Standard_EXPORT   Vrml_FontStyleFamily Family() const;


Standard_EXPORT   void SetStyle(const Vrml_FontStyleStyle aStyle) ;


Standard_EXPORT   Vrml_FontStyleStyle Style() const;


Standard_EXPORT   Standard_OStream& Print(Standard_OStream& anOStream) const;





protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Standard_Real mySize;
Vrml_FontStyleFamily myFamily;
Vrml_FontStyleStyle myStyle;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
