// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _WOKBuilder_WNTCollector_HeaderFile
#define _WOKBuilder_WNTCollector_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_WOKBuilder_WNTCollector_HeaderFile
#include <Handle_WOKBuilder_WNTCollector.hxx>
#endif

#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _OSD_File_HeaderFile
#include <OSD_File.hxx>
#endif
#ifndef _WOKBuilder_ToolInShell_HeaderFile
#include <WOKBuilder_ToolInShell.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_WOKBuilder_HSequenceOfObjectFile_HeaderFile
#include <Handle_WOKBuilder_HSequenceOfObjectFile.hxx>
#endif
#ifndef _WOKBuilder_BuildStatus_HeaderFile
#include <WOKBuilder_BuildStatus.hxx>
#endif
class TCollection_HAsciiString;
class WOKUtils_Param;
class WOKBuilder_HSequenceOfObjectFile;


//! defines abstract class to provide collection of <br>
//!          input files ( Windows NT specific ) <br>
class WOKBuilder_WNTCollector : public WOKBuilder_ToolInShell {

public:
 // Methods PUBLIC
 // 

//! sets name for target <br>
Standard_EXPORT   void SetTargetName(const Handle(TCollection_HAsciiString)& aName) ;

//! retrieves the target name <br>
Standard_EXPORT   Handle_TCollection_HAsciiString TargetName() const;

//! creates tool command file <br>
Standard_EXPORT   Standard_Boolean OpenCommandFile() ;

//! closes tool command file <br>
Standard_EXPORT   Standard_Boolean CloseCommandFile() ;

//! evaluates extension for name of the command file <br>
Standard_EXPORT virtual  Handle_TCollection_HAsciiString EvalCFExt()  = 0;

//! evaluats tool command line <br>
Standard_EXPORT virtual  Handle_TCollection_HAsciiString EvalHeader()  = 0;

//! writes list of the object files to the command file <br>
Standard_EXPORT   void ProduceObjectList(const Handle(WOKBuilder_HSequenceOfObjectFile)& anObjectList) ;

//! evaluates additional information for the tool <br>
Standard_EXPORT virtual  Handle_TCollection_HAsciiString EvalFooter()  = 0;

//! executes a tool ( library manager ) <br>
Standard_EXPORT   WOKBuilder_BuildStatus Execute() ;
//Standard_EXPORT ~WOKBuilder_WNTCollector();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 

//! initialization <br>
Standard_EXPORT WOKBuilder_WNTCollector(const Handle(TCollection_HAsciiString)& aName,const WOKUtils_Param& aParams);


 // Fields PROTECTED
 //
Handle_TCollection_HAsciiString myTargetName;
OSD_File myCommandFile;


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
