// File generated by CPPExt (Value)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _WOKNT_StackOfHandle_HeaderFile
#define _WOKNT_StackOfHandle_HeaderFile

#ifndef _Standard_Address_HeaderFile
#include <Standard_Address.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _WOKNT_Handle_HeaderFile
#include <WOKNT_Handle.hxx>
#endif
#ifndef _Handle_WOKNT_StackNodeOfStackOfHandle_HeaderFile
#include <Handle_WOKNT_StackNodeOfStackOfHandle.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class Standard_NoSuchObject;
class WOKNT_StackIteratorOfStackOfHandle;
class WOKNT_StackNodeOfStackOfHandle;


#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif


class WOKNT_StackOfHandle  {

public:

    void* operator new(size_t,void* anAddress) 
      {
        return anAddress;
      }
    void* operator new(size_t size) 
      { 
        return Standard::Allocate(size); 
      }
    void  operator delete(void *anAddress) 
      { 
        if (anAddress) Standard::Free((Standard_Address&)anAddress); 
      }
 // Methods PUBLIC
 // 


Standard_EXPORT WOKNT_StackOfHandle();


Standard_EXPORT  const WOKNT_StackOfHandle& Assign(const WOKNT_StackOfHandle& Other) ;
 const WOKNT_StackOfHandle& operator =(const WOKNT_StackOfHandle& Other) 
{
  return Assign(Other);
}


  Standard_Boolean IsEmpty() const;

  Standard_Integer Depth() const;


Standard_EXPORT  const WOKNT_Handle& Top() const;


Standard_EXPORT   void Push(const WOKNT_Handle& I) ;


Standard_EXPORT   void Pop() ;


Standard_EXPORT   void Clear() ;
~WOKNT_StackOfHandle()
{
  Clear();
}



Standard_EXPORT   WOKNT_Handle& ChangeTop() ;


friend class WOKNT_StackIteratorOfStackOfHandle;



protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


Standard_EXPORT WOKNT_StackOfHandle(const WOKNT_StackOfHandle& Other);


 // Fields PRIVATE
 //
Standard_Address myTop;
Standard_Integer myDepth;


};

#define Item WOKNT_Handle
#define Item_hxx <WOKNT_Handle.hxx>
#define TCollection_StackNode WOKNT_StackNodeOfStackOfHandle
#define TCollection_StackNode_hxx <WOKNT_StackNodeOfStackOfHandle.hxx>
#define TCollection_StackIterator WOKNT_StackIteratorOfStackOfHandle
#define TCollection_StackIterator_hxx <WOKNT_StackIteratorOfStackOfHandle.hxx>
#define Handle_TCollection_StackNode Handle_WOKNT_StackNodeOfStackOfHandle
#define TCollection_StackNode_Type_() WOKNT_StackNodeOfStackOfHandle_Type_()
#define TCollection_Stack WOKNT_StackOfHandle
#define TCollection_Stack_hxx <WOKNT_StackOfHandle.hxx>

#include <TCollection_Stack.lxx>

#undef Item
#undef Item_hxx
#undef TCollection_StackNode
#undef TCollection_StackNode_hxx
#undef TCollection_StackIterator
#undef TCollection_StackIterator_hxx
#undef Handle_TCollection_StackNode
#undef TCollection_StackNode_Type_
#undef TCollection_Stack
#undef TCollection_Stack_hxx


// other Inline functions and methods (like "C++: function call" methods)
//


#endif
