// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _WOKernel_File_HeaderFile
#define _WOKernel_File_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_WOKernel_File_HeaderFile
#include <Handle_WOKernel_File.hxx>
#endif

#ifndef _Handle_WOKernel_FileType_HeaderFile
#include <Handle_WOKernel_FileType.hxx>
#endif
#ifndef _Handle_WOKUtils_Path_HeaderFile
#include <Handle_WOKUtils_Path.hxx>
#endif
#ifndef _Handle_TCollection_HAsciiString_HeaderFile
#include <Handle_TCollection_HAsciiString.hxx>
#endif
#ifndef _WOKernel_BaseEntity_HeaderFile
#include <WOKernel_BaseEntity.hxx>
#endif
#ifndef _Handle_WOKernel_Entity_HeaderFile
#include <Handle_WOKernel_Entity.hxx>
#endif
class WOKernel_FileType;
class WOKUtils_Path;
class TCollection_HAsciiString;
class Standard_ProgramError;
class WOKernel_Entity;


//! a file in WOK context <br>
class WOKernel_File : public WOKernel_BaseEntity {

public:
 // Methods PUBLIC
 // 

//! Constructor of a File with a FileDependent Type <br>
Standard_EXPORT WOKernel_File(const Handle(TCollection_HAsciiString)& aname,const Handle(WOKernel_Entity)& anesting,const Handle(WOKernel_FileType)& atype);

//! Constructor of a File with a !FileDependent Type <br>
//!          Warning : Raises if FileType is FileDependent <br>
Standard_EXPORT WOKernel_File(const Handle(WOKernel_Entity)& anesting,const Handle(WOKernel_FileType)& atype);

 const Handle_WOKUtils_Path& Path() const;


Standard_EXPORT   void SetPath(const Handle(WOKUtils_Path)& apath) ;

 const Handle_WOKernel_FileType& Type() const;

 const Handle_TCollection_HAsciiString& TypeName() const;


Standard_EXPORT   void SetType(const Handle(WOKernel_FileType)& atype) ;


Standard_EXPORT virtual  Handle_TCollection_HAsciiString GetUniqueName() const;


Standard_EXPORT  const Handle_TCollection_HAsciiString& LocatorName() ;


Standard_EXPORT static  Handle_TCollection_HAsciiString FileLocatorName(const Handle(TCollection_HAsciiString)& unitname,const Handle(TCollection_HAsciiString)& type,const Handle(TCollection_HAsciiString)& aname) ;


Standard_EXPORT   void GetPath() ;
//Standard_EXPORT ~WOKernel_File();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
Handle_WOKernel_FileType mytype;
Handle_WOKUtils_Path mypath;
Handle_TCollection_HAsciiString mylocatorname;


};


#include <WOKernel_File.lxx>



// other Inline functions and methods (like "C++: function call" methods)
//


#endif
