#ifndef _Storage_Schema_HeaderFile_
#include <Storage_Schema.hxx>
#endif
#ifndef _Storage_BaseDriver_HeaderFile_
#include <Storage_BaseDriver.hxx>
#endif
#ifndef _Storage_CallBack_HeaderFile_
#include <Storage_CallBack.hxx>
#endif
#ifndef _Storage_Macros_HeaderFile_
#include <Storage_Macros.hxx>
#endif
class Handle_PXCAFDoc_Location;
class Handle_PXCAFDoc_Color;
class Handle_PXCAFDoc_Volume;
class Handle_PXCAFDoc_Area;
class Handle_PXCAFDoc_Centroid;
class Handle_PXCAFDoc_ColorTool;
class Handle_PXCAFDoc_ShapeTool;
class Handle_PXCAFDoc_DocumentTool;
class Handle_PXCAFDoc_LayerTool;
class Handle_PXCAFDoc_GraphNode;
class Handle_PXCAFDoc_GraphNodeSequence;
class Handle_PXCAFDoc_SeqNodeOfGraphNodeSequence;
class Handle_PDF_Attribute;
class Handle_Standard_Persistent;
class Standard_Storable;
class PTopLoc_Location;
class Quantity_Color;
class gp_Pnt;
class Standard_GUID;
class Handle_PMMgt_PManaged;
class Handle_PTopLoc_Datum3D;
class Handle_PTopLoc_ItemLocation;
class gp_Ax1;
class gp_Ax2;
class gp_Trsf;
class gp_Vec;
class gp_XYZ;
class gp_Dir;
class gp_Ax3;
class gp_Mat;
class gp_Trsf2d;
class gp_Ax2d;
class gp_Mat2d;
class gp_Pnt2d;
class gp_Vec2d;
class gp_XY;
class gp_Dir2d;
// File generated by Schema (Schema)
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _XCAFSchema_HeaderFile
#define _XCAFSchema_HeaderFile

#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif
#ifndef _Storage_Macros_HeaderFile
#include <Storage_Macros.hxx>
#endif
#ifndef _Storage_stCONSTclCOM_HeaderFile
#include <Storage_stCONSTclCOM.hxx>
#endif
#ifndef _Handle_Storage_Schema_HeaderFile
#include <Handle_Storage_Schema.hxx>
#endif

class Handle_Standard_Type;
Standard_EXPORT Handle_Standard_Type& XCAFSchema_Type_();
class Standard_Transient;
class Handle(Storage_Schema);
//! Schema <br>
class XCAFSchema;

class Handle(XCAFSchema) : public Handle(Storage_Schema) {
  public:
    Handle(XCAFSchema)():Handle(Storage_Schema)() {} 
    Handle(XCAFSchema)(const Handle(XCAFSchema)& aHandle) : Handle(Storage_Schema)(aHandle) 
     {
     }

    Handle(XCAFSchema)(const XCAFSchema* anItem) : Handle(Storage_Schema)((Storage_Schema *)anItem) 
     {
     }

    Handle(XCAFSchema)& operator=(const Handle(XCAFSchema)& aHandle)
     {
      Assign(aHandle.Access());
      return *this;
     }

    Handle(XCAFSchema)& operator=(const XCAFSchema* anItem)
     {
      Assign((Standard_Transient *)anItem);
      return *this;
     }

    XCAFSchema* operator->() 
     {
      return (XCAFSchema *)ControlAccess();
     }

    XCAFSchema* operator->() const 
     {
      return (XCAFSchema *)ControlAccess();
     }

   ~Handle(XCAFSchema)(){};

   static const Handle(XCAFSchema) DownCast(const Handle(Storage_Schema)& AnObject) 
   {
     Handle(XCAFSchema) _anOtherObject;

     if (!AnObject.IsNull()) {
        if (AnObject->IsKind(STANDARD_TYPE(XCAFSchema))) {
          _anOtherObject = Handle(XCAFSchema)((Handle(XCAFSchema)&)AnObject);
        }
     }

     return _anOtherObject ;
   }
};

#ifndef _Storage_CallBack_HeaderFile_
#include <Storage_CallBack.hxx>
#endif
#ifndef _Storage_BaseDriver_HeaderFile_
#include <Storage_BaseDriver.hxx>
#endif

class XCAFSchema : public Storage_Schema {
public:

  Storage_DECLARE_SCHEMA_METHODS(XCAFSchema)

  Standard_Boolean IsKind(const Handle(Standard_Type)& AType) const 
  { 
    return (STANDARD_TYPE(XCAFSchema) == AType || Storage_Schema::IsKind(AType)); 
  }

  const Handle(Standard_Type)& DynamicType() const 
  { 
    return STANDARD_TYPE(XCAFSchema) ; 
  }
};

#endif
