// File generated by CPPExt (Transient)
//
//
//                     Copyright (C) 1991 - 2000 by  
//                      Matra Datavision SA.  All rights reserved.
//  
//                     Copyright (C) 2001 - 2004 by
//                     Open CASCADE SA.  All rights reserved.
// 
// This file is part of the Open CASCADE Technology software.
//
// This software may be distributed and/or modified under the terms and
// conditions of the Open CASCADE Public License as defined by Open CASCADE SA
// and appearing in the file LICENSE included in the packaging of this file.
//  
// This software is distributed on an "AS IS" basis, without warranty of any
// kind, and Open CASCADE SA hereby disclaims all such warranties,
// including without limitation, any warranties of merchantability, fitness
// for a particular purpose or non-infringement. Please see the License for
// the specific terms and conditions governing rights and limitations under the
// License.

#ifndef _XmlMDF_ADriverTable_HeaderFile
#define _XmlMDF_ADriverTable_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Handle_XmlMDF_ADriverTable_HeaderFile
#include <Handle_XmlMDF_ADriverTable.hxx>
#endif

#ifndef _XmlMDF_TypeADriverMap_HeaderFile
#include <XmlMDF_TypeADriverMap.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Handle_XmlMDF_ADriver_HeaderFile
#include <Handle_XmlMDF_ADriver.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Standard_Type_HeaderFile
#include <Handle_Standard_Type.hxx>
#endif
class XmlMDF_ADriver;
class XmlMDF_TypeADriverMap;
class Standard_Type;


//! A driver table is an object building links between <br>
//!          object types and object drivers. In the <br>
//!          translation process, a driver table is asked to <br>
//!          give a translation driver for each current object <br>
//!          to be translated. <br>
class XmlMDF_ADriverTable : public MMgt_TShared {

public:
 // Methods PUBLIC
 // 

//! Creates a mutable ADriverTable from XmlMDF. <br>
Standard_EXPORT XmlMDF_ADriverTable();

//! Sets a translation driver: <aDriver>. <br>
Standard_EXPORT   void AddDriver(const Handle(XmlMDF_ADriver)& anHDriver) ;

//! Gets a map of drivers. <br>
Standard_EXPORT  const XmlMDF_TypeADriverMap& GetDrivers() const;

//! Gets a driver <aDriver> according to <aType> <br>
//! <br>
//!          Returns True if a driver is found; false otherwise. <br>
Standard_EXPORT   Standard_Boolean GetDriver(const Handle(Standard_Type)& aType,Handle(XmlMDF_ADriver)& anHDriver) const;
//Standard_EXPORT ~XmlMDF_ADriverTable();




 // Type management
 //
 Standard_EXPORT const Handle(Standard_Type)& DynamicType() const;
 //Standard_EXPORT Standard_Boolean	       IsKind(const Handle(Standard_Type)&) const;

protected:

 // Methods PROTECTED
 // 


 // Fields PROTECTED
 //


private: 

 // Methods PRIVATE
 // 


 // Fields PRIVATE
 //
XmlMDF_TypeADriverMap myMap;


};





// other Inline functions and methods (like "C++: function call" methods)
//


#endif
